/**
 ********************************************************************************
 *** AnoAccessApplicationDataServiceImpl.java                                 ***
 *** The implementation of the IAnoAccessApplicationDataService.              ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.anoaccessapplicationdata.service;

import java.util.List;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.anosite.gen.shared.service.BasicService;
import net.anotheria.anosite.gen.anoaccessapplicationdata.service.persistence.IAnoAccessApplicationDataPersistenceService;
import net.anotheria.anosite.gen.anoaccessapplicationdata.service.persistence.AnoAccessApplicationDataPersistenceServiceFactory;
import net.anotheria.anosite.gen.anoaccessapplicationdata.service.persistence.AnoAccessApplicationDataPersistenceServiceException;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.util.slicer.Segment;
import net.anotheria.anosite.gen.anoaccessapplicationdata.data.UserData;
import net.anotheria.anosite.gen.anoaccessapplicationdata.data.UserDataXMLHelper;
import net.anotheria.anosite.gen.anoaccessapplicationdata.service.persistence.UserDataNotFoundInAnoAccessApplicationDataPersistenceServiceException;

public class AnoAccessApplicationDataServiceImpl extends BasicService implements IAnoAccessApplicationDataService{

	// Generated by: class net.anotheria.asg.generator.model.db.JDBCBasedServiceGenerator.generateImplementation

	private static AnoAccessApplicationDataServiceImpl instance;

	private IAnoAccessApplicationDataPersistenceService pService;
	private AnoAccessApplicationDataServiceImpl(){
		pService = AnoAccessApplicationDataPersistenceServiceFactory.createAnoAccessApplicationDataPersistenceService();
	}

	static final AnoAccessApplicationDataServiceImpl getInstance(){
		if (instance==null){
			instance = new AnoAccessApplicationDataServiceImpl();
		}
		return instance;
	}

	public List<UserData> getUserDatas() throws AnoAccessApplicationDataServiceException {
		try {
			return pService.getUserDatas();
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	public List<UserData> getUserDatas(SortType sortType) throws AnoAccessApplicationDataServiceException {
		return StaticQuickSorter.sort(getUserDatas(), sortType);
	}

	public void deleteUserData(UserData userdata) throws AnoAccessApplicationDataServiceException {
		deleteUserData(userdata.getId());
		if(hasServiceListeners()){
			fireObjectDeletedEvent(userdata);
		}
	}

	public void deleteUserData(String id) throws AnoAccessApplicationDataServiceException {
		try {
			UserData varValue = hasServiceListeners()?pService.getUserData(id):null;
			pService.deleteUserData(id);
			if(varValue!=null){
				fireObjectDeletedEvent(varValue);
			}
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	/**
	 * Deletes multiple UserData objects.
	 */
	public void deleteUserDatas(List<UserData> list) throws AnoAccessApplicationDataServiceException {
		try {
			pService.deleteUserDatas(list);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		if (hasServiceListeners()){
			for (int t = 0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public UserData getUserData(String id) throws AnoAccessApplicationDataServiceException {
		try {
			return pService.getUserData(id);
		}catch(UserDataNotFoundInAnoAccessApplicationDataPersistenceServiceException e){
			throw new UserDataNotFoundInAnoAccessApplicationDataServiceException(id);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	public UserData importUserData(UserData userdata) throws AnoAccessApplicationDataServiceException {
		try {
			userdata = pService.importUserData(userdata);
			if(hasServiceListeners()){
				fireObjectImportedEvent(userdata);
			}
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		return userdata;
	}

	public List<UserData> importUserDatas(List<UserData> list) throws AnoAccessApplicationDataServiceException {
		List<UserData> ret = null;
		try {
			ret = pService.importUserDatas(list);
			if(hasServiceListeners()){
				for (UserData userdata : ret)
					fireObjectImportedEvent(userdata);
			}
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		return ret;
	}

	public UserData createUserData(UserData userdata) throws AnoAccessApplicationDataServiceException {
		try {
			userdata = pService.createUserData(userdata);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		fireObjectCreatedEvent(userdata);
		return userdata;
	}

	/**
	 * Creates multiple new UserData objects.
	 * Returns the created versions.
	 */
	public List<UserData> createUserDatas(List<UserData> list) throws AnoAccessApplicationDataServiceException {
		List<UserData> ret = null;
		try {
			ret = pService.createUserDatas(list);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		if (hasServiceListeners()){
			for (UserData userdata : ret)
				fireObjectCreatedEvent(userdata);
		}
		return ret;
	}

	/**
	 * Updates multiple UserData objects.
	 * Returns the updated versions.
	 */
	public List<UserData> updateUserDatas(List<UserData> list) throws AnoAccessApplicationDataServiceException {
		List<UserData> ret = null;
		try {
			ret = pService.updateUserDatas(list);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		if (hasServiceListeners()){
			for (int t = 0; t<ret.size(); t++)
				fireObjectUpdatedEvent(list.get(t), ret.get(t));
		}
		return ret;
	}

	public UserData updateUserData(UserData userdata) throws AnoAccessApplicationDataServiceException {
		UserData oldVersion = null;
		try {
			if (hasServiceListeners())
				oldVersion = pService.getUserData(userdata.getId());
			userdata = pService.updateUserData(userdata);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
		if (oldVersion!=null)
			fireObjectUpdatedEvent(oldVersion, userdata);
		return userdata;
	}

	public List<UserData> getUserDatasByProperty(String propertyName, Object value) throws AnoAccessApplicationDataServiceException {
		QueryProperty p = new QueryProperty(propertyName, value);
		try{
			return pService.getUserDatasByProperty(p);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	public List<UserData> getUserDatasByProperty(String propertyName, Object value, SortType sortType) throws AnoAccessApplicationDataServiceException {
		return StaticQuickSorter.sort(getUserDatasByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on UserDatas
	 */
	public QueryResult executeQueryOnUserDatas(DocumentQuery query) throws AnoAccessApplicationDataServiceException {
		List<UserData> allUserDatas = getUserDatas();
		QueryResult result = new QueryResult();
		for (int i=0; i<allUserDatas.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allUserDatas.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all UserData objects, where property matches.
	 */
	public List<UserData> getUserDatasByProperty(QueryProperty... property) throws AnoAccessApplicationDataServiceException {;
		try{
			return pService.getUserDatasByProperty(property);
		}catch(AnoAccessApplicationDataPersistenceServiceException e){
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	/**
	 * Returns all UserData objects, where property matches, sorted
	 */
	public List<UserData> getUserDatasByProperty(SortType sortType, QueryProperty... property) throws AnoAccessApplicationDataServiceException {;
		return StaticQuickSorter.sort(getUserDatasByProperty(property), sortType);
	}

	/**
	 * Returns UserData objects count.
	 */
	public int getUserDatasCount() throws AnoAccessApplicationDataServiceException {
		try {
			return pService.getUserDatasCount();
		} catch (AnoAccessApplicationDataPersistenceServiceException e) {
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	/**
	 * Returns UserData objects segment.
	 */
	public List<UserData> getUserDatas(Segment aSegment) throws AnoAccessApplicationDataServiceException {
		try {
			return pService.getUserDatas(aSegment);
		} catch (AnoAccessApplicationDataPersistenceServiceException e) {
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	/**
	 * Returns UserData objects segment, where property matches.
	 */
	public List<UserData> getUserDatasByProperty(Segment aSegment, QueryProperty... aProperty) throws AnoAccessApplicationDataServiceException {;
		try {
			return pService.getUserDatasByProperty(aSegment, aProperty);
		} catch (AnoAccessApplicationDataPersistenceServiceException e) {
			throw new AnoAccessApplicationDataServiceException("Persistence failed: "+e.getMessage());
		}
	}

	/**
	 * Returns UserData objects segment, where property matches, sorted
	 */
	public List<UserData> getUserDatasByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws AnoAccessApplicationDataServiceException {;
		return StaticQuickSorter.sort(getUserDatasByProperty(aSegment, aProperty), aSortType);
	}


	public XMLNode exportUserDatasToXML(){
		XMLNode ret = new XMLNode("UserDatas");
		try{
			List<UserData> list = getUserDatas();
			ret.addAttribute(new XMLAttribute("count", list.size()));
			for (UserData object : list)
				ret.addChildNode(UserDataXMLHelper.toXML(object));
			return ret;
		}
		catch(AnoAccessApplicationDataServiceException e){;
			throw new RuntimeException("exportUserDatasToXML() failure: " + e.getStackTrace());
		}
	}

	public XMLNode exportUserDatasToXML(List<UserData> list){
		XMLNode ret = new XMLNode("UserDatas");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (UserData object : list)
			ret.addChildNode(UserDataXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportUserDatasToXML(String languages[]){
		XMLNode ret = new XMLNode("UserDatas");
		try{
			List<UserData> list = getUserDatas();
			ret.addAttribute(new XMLAttribute("count", list.size()));
			for (UserData object : list)
				ret.addChildNode(UserDataXMLHelper.toXML(object, languages));
			return ret;
		}
		catch(AnoAccessApplicationDataServiceException e){;
			throw new RuntimeException("exportUserDatasToXML() failure: " + e.getStackTrace());
		}
	}

	public XMLNode exportUserDatasToXML(String languages[], List<UserData> list){
		XMLNode ret = new XMLNode("UserDatas");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (UserData object : list)
			ret.addChildNode(UserDataXMLHelper.toXML(object, languages));
		return ret;
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query) throws AnoAccessApplicationDataServiceException {
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnUserDatas(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("AnoAccessApplicationData");

		ret.addChildNode(exportUserDatasToXML());

		return ret;
	}

	public XMLNode exportToXML(String[] languages){
		XMLNode ret = new XMLNode("AnoAccessApplicationData");

		ret.addChildNode(exportUserDatasToXML(languages));

		return ret;
	}
}
