/**
 ********************************************************************************
 *** AnoAccessApplicationDataPersistenceServiceImpl.java                      ***
 *** The implementation of the IAnoAccessApplicationDataPersistenceService.   ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.anoaccessapplicationdata.service.persistence;

import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.Date;
import net.anotheria.util.slicer.Segment;
import net.anotheria.anodoc.query2.QueryProperty;
import org.slf4j.MarkerFactory;
import net.anotheria.anosite.gen.anoaccessapplicationdata.data.UserData;
import net.anotheria.db.service.BasePersistenceServiceJDBCImpl;
import net.anotheria.db.dao.DAOException;
import java.sql.Connection;
import java.sql.SQLException;

public class AnoAccessApplicationDataPersistenceServiceImpl extends BasePersistenceServiceJDBCImpl implements IAnoAccessApplicationDataPersistenceService{

	// Generated by: class net.anotheria.asg.generator.model.db.JDBCPersistenceServiceGenerator.generateImplementation


	private static AnoAccessApplicationDataPersistenceServiceImpl instance;

	// DAO Objects for data access.
	private UserDataDAO userdataDAO;

	private AnoAccessApplicationDataPersistenceServiceImpl(){
		super("ano-access-db-configuration");
	}

	static final AnoAccessApplicationDataPersistenceServiceImpl getInstance(){
		if (instance==null){
			instance = new AnoAccessApplicationDataPersistenceServiceImpl();
		}
		return instance;
	}

	public void init(){
		super.init();
		userdataDAO = new UserDataDAO("ano-access-db-configuration");
		String currentDAO = null;
		try {
			Connection c = getConnection();
			log.info("Initializing DAO for UserData" );
			currentDAO = "UserData";
			userdataDAO.init(c);
		}catch(DAOException e){
			log.error(MarkerFactory.getMarker("FATAL"), "init failed (dao:"+currentDAO+") ",e );
		}catch(SQLException e){
			log.error(MarkerFactory.getMarker("FATAL"), "init failed (sql) ",e );
		}catch(Exception e){
			System.out.println(e.getMessage()+" "+e.getClass());
			log.error(MarkerFactory.getMarker("FATAL"), "init failed (e) ",e );
		}
	}

	/**
	 * Returns all UserDatas objects stored.
	 */
	public List<UserData> getUserDatas() throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call getUserDatas() ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.getUserDatas(c);
		}catch(SQLException e){
			log.error("getUserDatas() ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Deletes a UserData object by id.
	 */
	public void deleteUserData(String id) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call deleteUserData("+id+") ");
		Connection c = null;
		try {
			c = getConnection();
			userdataDAO.deleteUserData(c, id);
		}catch(SQLException e){
			log.error("deleteUserData("+id+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Deletes multiple  UserData objects.
	 */
	public void deleteUserDatas(List<UserData> list) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call deleteUserDatas("+list+") ");
		Connection c = null;
		try {
			c = getConnection();
			userdataDAO.deleteUserDatas(c, list);
			return;
		}catch(SQLException e){
			log.error("deleteUserDatas("+list+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Returns the UserData object with the specified id.
	 */
	public UserData getUserData(String id) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call getUserData("+id+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.getUserData(c, id);
		}catch(UserDataDAONoItemForIdFoundException e){
			throw new UserDataNotFoundInAnoAccessApplicationDataPersistenceServiceException(id);
		}catch(SQLException e){
			log.error("getUserData("+id+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Imports a new UserData object.
	 * Returns the imported version.
	 */
	public UserData importUserData(UserData userdata) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call importUserData("+userdata+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.importUserData(c, userdata);
		}catch(SQLException e){
			log.error("importUserData("+userdata+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Imports multiple new UserData objects.
	 * Returns the imported versions.
	 */
	public List<UserData> importUserDatas(List<UserData> list) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call importUserDatas("+list+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.importUserDatas(c, list);
		}catch(SQLException e){
			log.error("importUserDatas("+list+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Creates a new UserData object.
	 * Returns the created version.
	 */
	public UserData createUserData(UserData userdata) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call createUserData("+userdata+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.createUserData(c, userdata);
		}catch(SQLException e){
			log.error("createUserData("+userdata+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Creates multiple new UserData objects.
	 * Returns the created versions.
	 */
	public List<UserData> createUserDatas(List<UserData> list) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call createUserDatas("+list+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.createUserDatas(c, list);
		}catch(SQLException e){
			log.error("createUserDatas("+list+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Updates a UserData object.
	 * Returns the updated version.
	 */
	public UserData updateUserData(UserData userdata) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call updateUserData("+userdata+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.updateUserData(c, userdata);
		}catch(SQLException e){
			log.error("updateUserData("+userdata+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Updates multiple  UserData objects.
	 * Returns the updated versions.
	 */
	public List<UserData> updateUserDatas(List<UserData> list) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call updateUserDatas("+list+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.updateUserDatas(c, list);
		}catch(SQLException e){
			log.error("updateUserDatas("+list+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Returns all UserData objects which match the given property.
	 */
	public List<UserData> getUserDatasByProperty(QueryProperty... properties) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call getUserDatasByProperty("+properties+") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.getUserDatasByProperty(c, Arrays.asList(properties));
		}catch(SQLException e){
			log.error("getUserDatasByProperty("+properties+") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Returns UserDatas objects count.
	 */
	public int getUserDatasCount() throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call getUserDatasCount() ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.getUserDatasCount(c);
		}catch(SQLException e){
			log.error("getUserDatasCount() ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Returns UserDatas objects segment.
	 */
	public List<UserData> getUserDatas(Segment aSegment) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call getUserDatas(" + aSegment + ") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.getUserDatas(c, aSegment);
		}catch(SQLException e){
			log.error("getUserDatas(" + aSegment + ") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

	/**
	 * Returns UserData objects segment which match the given property.
	 */
	public List<UserData> getUserDatasByProperty(Segment aSegment, QueryProperty... aProperties) throws AnoAccessApplicationDataPersistenceServiceException {
		log.debug("Call getUserDatasByProperty(" + aSegment + "," + aProperties + ") ");
		Connection c = null;
		try {
			c = getConnection();
			return userdataDAO.getUserDatasByProperty(c, aSegment, Arrays.asList(aProperties));
		}catch(SQLException e){
			log.error("getUserDatasByProperty(" + aSegment + "," + aProperties + ") ",e);
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}catch(DAOException e){
			throw new AnoAccessApplicationDataPersistenceServiceException(e);
		}finally{
			release(c);
		}
	}

}
