/**
 **************************************************************************************
 *** UserDataDAO.java                                                               ***
 *** Generator: net.anotheria.asg.generator.model.db.PersistenceServiceDAOGenerator ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                            ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net                     ***
 *** All Rights Reserved.                                                           ***
 **************************************************************************************
 *** Don't edit this code, if you aren't sure                                       ***
 *** that you do exactly know what you are doing!                                   ***
 *** It's better to invest time in the generator, as into the generated code.       ***
 **************************************************************************************
 */

package net.anotheria.anosite.gen.anoaccessapplicationdata.service.persistence;

import java.util.List;
import java.util.ArrayList;
import java.util.concurrent.atomic.AtomicLong;
import net.anotheria.anosite.gen.anoaccessapplicationdata.data.UserData;
import net.anotheria.anosite.gen.anoaccessapplicationdata.data.UserDataVO;
import net.anotheria.db.dao.DAO;
import net.anotheria.db.dao.DAOException;
import net.anotheria.db.dao.DAOSQLException;
import net.anotheria.db.dao.RowMapper;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.anodoc.util.context.DBContext;
import net.anotheria.anodoc.util.context.ContextManager;
import net.anotheria.util.slicer.Segment;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import net.anotheria.db.config.JDBCConfigFactory;
import net.anotheria.db.config.JDBCConfig;
import net.anotheria.db.array.StringArray;
import java.lang.IllegalArgumentException;

public class UserDataDAO implements DAO{

	private static Logger log = LoggerFactory.getLogger(UserDataDAO.class);
	public static final String TABNAME = "userdata";

	public static final String ATT_NAME_ID = "id";
	public static final String ATT_NAME_USERID 	 = "userid";
	public static final String ATT_NAME_ROLES 	 = "roles";

	public static final String  SQL_CREATE_1 	= "INSERT INTO ";
	public static final String  SQL_CREATE_2 	= " ("+ATT_NAME_ID+", "+ATT_NAME_USERID+", "+ATT_NAME_ROLES+", "+ATT_NAME_DAO_CREATED+") VALUES (?,?,?,?)";
	public static final String  SQL_UPDATE_1 	= "UPDATE ";
	public static final String  SQL_UPDATE_2 	= " SET " + ATT_NAME_USERID + " = ?, " + ATT_NAME_ROLES + " = ?, " + ATT_NAME_DAO_UPDATED + " = ?" + " WHERE " + ATT_NAME_ID + " = ?";
	public static final String  SQL_DELETE_1 	= "DELETE FROM ";
	public static final String  SQL_DELETE_2 	= " WHERE " + TABNAME +"." + ATT_NAME_ID + " = ?";
	public static final String  SQL_READ_ONE_1 	= "SELECT "+ATT_NAME_ID+", "+ATT_NAME_USERID+", "+ATT_NAME_ROLES+", "+ATT_NAME_DAO_CREATED+", "+ATT_NAME_DAO_UPDATED+" FROM ";
	public static final String  SQL_READ_ONE_2 	= " WHERE " + TABNAME +"." + ATT_NAME_ID + " = ?";
	public static final String  SQL_READ_ALL_1 	= "SELECT "+ATT_NAME_ID+", "+ATT_NAME_USERID+", "+ATT_NAME_ROLES+", "+ATT_NAME_DAO_CREATED+", "+ATT_NAME_DAO_UPDATED+" FROM ";
	public static final String  SQL_READ_ALL_2 	= " ORDER BY id";
	public static final String  SQL_READ_ALL_BY_PROPERTY_1 	= "SELECT "+ATT_NAME_ID+", "+ATT_NAME_USERID+", "+ATT_NAME_ROLES+", "+ATT_NAME_DAO_CREATED+", "+ATT_NAME_DAO_UPDATED+" FROM ";
	public static final String  SQL_READ_ALL_BY_PROPERTY_2 	= " WHERE ";
	public static final String  SQL_COUNT_1 	= "SELECT COUNT(id) FROM ";
	public static final String  SQL_LIMIT_1 	= " LIMIT ?";
	public static final String  SQL_OFFSET_1 	= " OFFSET ?";

	private RowMapper<UserData> rowMapper = new UserDataRowMapper();

	private AtomicLong lastId = new AtomicLong();

	private final JDBCConfig dbConfig;

	public UserDataDAO() {
		dbConfig = JDBCConfigFactory.getJDBCConfig();
	}

	public UserDataDAO(String jdbcConfig) {
		dbConfig = JDBCConfigFactory.getNamedJDBCConfig(jdbcConfig);
	}

	private AtomicLong getLastId(Connection con) throws DAOException {
		return lastId;
	}

	private void adjustLastId(Connection con, long lastIdValue) throws DAOException {
		if (lastId.get()<lastIdValue)
			lastId.set(lastIdValue);
	}

	private String createSQL(String sql1, String sql2){
		StringBuilder sql = new StringBuilder();
		sql.append(sql1).append(TABNAME).append(sql2);
		return sql.toString();
	}

	/**
	 * Returns all UserDatas objects stored.
	 */
	public List<UserData> getUserDatas(Connection con) throws DAOException {
		PreparedStatement ps = null;
		ResultSet result = null;
		try {
			con.setAutoCommit(true);
			ps = con.prepareStatement(createSQL(SQL_READ_ALL_1, SQL_READ_ALL_2));
			result = ps.executeQuery();
			ArrayList<UserData> ret = new ArrayList<UserData>();
			while(result.next())
				ret.add(rowMapper.map(result));
			return  ret;
		} catch (SQLException e) {
			log.error("getUserDatas("+con+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Deletes a UserData object by id.
	 */
	public void deleteUserData(Connection con, String id) throws DAOException {
		PreparedStatement ps = null;
		try {
			con.setAutoCommit(true);
			ps = con.prepareStatement(createSQL(SQL_DELETE_1, SQL_DELETE_2));
			ps.setLong(1, Long.parseLong(id));
			int rows = ps.executeUpdate();
			if (rows!=1 && rows!=0){
				log.warn("Deleted more than one row of UserData: "+id);
			}
		} catch (SQLException e) {
			log.error("deleteUserData("+con+", "+id+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Deletes multiple UserData objects.
	 */
	public void deleteUserDatas(Connection con, List<UserData> list) throws DAOException {
		PreparedStatement ps = null;
		try{
			con.setAutoCommit(false);
			ps = con.prepareStatement(createSQL(SQL_DELETE_1, SQL_DELETE_2));
			for (UserData userdata : list){
				ps.setLong(1, Long.parseLong(userdata.getId()));
				int rows = ps.executeUpdate();
				if (rows!=1 && rows!=0){
					log.warn("Deleted more than one row of UserData: "+userdata.getId());
				}
			}
			con.commit();
		} catch (SQLException e) {
			log.error("deleteUserDatas("+con+", "+list+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Returns the UserData object with the specified id.
	 */
	public UserData getUserData(Connection con, String id) throws DAOException {
		if(con == null)
			throw new IllegalArgumentException("Null arg: con");
		if(id == null)
			throw new IllegalArgumentException("Null arg: id");
		PreparedStatement ps = null;
		ResultSet result = null;
		try {
			con.setAutoCommit(true);
			ps = con.prepareStatement(createSQL(SQL_READ_ONE_1, SQL_READ_ONE_2));
			ps.setLong(1, Long.parseLong(id));
			result = ps.executeQuery();
			if (!result.next())
				throw new UserDataDAONoItemForIdFoundException(id);
			return rowMapper.map(result);
		} catch (SQLException e) {
			log.error("getUserData("+con+", "+id+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Imports a new UserData object.
	 * Returns the imported version.
	 */
	public UserData importUserData(Connection con, UserData userdata) throws DAOException {
		PreparedStatement ps = null;
		try {
			con.setAutoCommit(true);
			ps = con.prepareStatement(createSQL(SQL_CREATE_1, SQL_CREATE_2));
			ps.setLong(1, Long.parseLong(userdata.getId()));
			ps.setString(2, userdata.getUserId());
			ps.setArray(3, new StringArray(userdata.getRoles()));
			// set create timestamp
			ps.setLong(4, System.currentTimeMillis());
			int rows = ps.executeUpdate();
			if (rows!=1)
				throw new DAOException("Create failed, updated rows: "+rows);
			UserDataVO newUserdata = new UserDataVO(userdata.getId());
			newUserdata.copyAttributesFrom(userdata);
			adjustLastId(con, Long.parseLong(userdata.getId()));
			return newUserdata;
		} catch (SQLException e) {
			log.error("importUserData("+con+", "+userdata+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Imports multiple new UserData objects.
	 * Returns the imported versions.
	 */
	public List<UserData> importUserDatas(Connection con,List<UserData> list) throws DAOException {
		PreparedStatement ps = null;
		try{
			con.setAutoCommit(false);
			ps = con.prepareStatement(createSQL(SQL_CREATE_1, SQL_CREATE_2));
			List<UserData> ret = new ArrayList<UserData>();
			for (UserData userdata : list){
				ps.setLong(1, Long.parseLong(userdata.getId()));
				ps.setString(2, userdata.getUserId());
				ps.setArray(3, new StringArray(userdata.getRoles()));
				// set create timestamp
				ps.setLong(4, System.currentTimeMillis());
				int rows = ps.executeUpdate();
				if (rows!=1)
					throw new DAOException("Create failed, updated rows: "+rows);
				UserDataVO newUserdata = new UserDataVO(userdata.getId());
				newUserdata.copyAttributesFrom(userdata);
				adjustLastId(con, Long.parseLong(userdata.getId()));
				ret.add(newUserdata);
			}
			con.commit();
			return ret;
		} catch (SQLException e) {
			log.error("import UserDatas("+con+", "+list+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Creates a new UserData object.
	 * Returns the created version.
	 */
	public UserData createUserData(Connection con, UserData userdata) throws DAOException {
		java.sql.SQLException throwable = null;
		for (int recoveryAttempt = 1; recoveryAttempt <= dbConfig.getIdRecoveryAttempts(); recoveryAttempt++) {
			PreparedStatement ps = null;
			try {
				con.setAutoCommit(false);
				ps = con.prepareStatement(createSQL(SQL_CREATE_1, SQL_CREATE_2));
				long nextId = getLastId(con).incrementAndGet();
				ps.setLong(1, nextId);
				ps.setString(2, userdata.getUserId());
				ps.setArray(3, new StringArray(userdata.getRoles()));
				// set create timestamp
				ps.setLong(4, System.currentTimeMillis());
				int rows = ps.executeUpdate();
				if (rows!=1)
					throw new DAOException("Create failed, updated rows: "+rows);
				UserDataVO newUserdata = new UserDataVO(""+nextId);
				newUserdata.copyAttributesFrom(userdata);
				con.commit();
				return newUserdata;
			} catch (SQLException e) {
				getLastId(con).set(getMaxId(con,TABNAME));
				log.warn("Failed attempt" +recoveryAttempt+ " from " +dbConfig.getIdRecoveryAttempts()+ " to create new entry in "+TABNAME+" table", e);
				throwable = e;
				continue;
			} finally {
				net.anotheria.db.util.JDBCUtil.release(ps);
			}
		}
		log.error("All "+ dbConfig.getIdRecoveryAttempts()+" attempt of id rereading - Failed. "+"createUserData("+con+", "+userdata+")", throwable);
		throw new DAOSQLException(throwable);
	}

	/**
	 * Creates multiple new UserData objects.
	 * Returns the created versions.
	 */
	public List<UserData> createUserDatas(Connection con, List<UserData> list) throws DAOException {
		java.sql.SQLException throwable = null;
		for (int recoveryAttempt = 1; recoveryAttempt <= dbConfig.getIdRecoveryAttempts(); recoveryAttempt++) {
			PreparedStatement ps = null;
			try{
				con.setAutoCommit(false);
				ps = con.prepareStatement(createSQL(SQL_CREATE_1, SQL_CREATE_2));
				List<UserData> ret = new ArrayList<UserData>();
				for (UserData userdata : list){
					long nextId = getLastId(con).incrementAndGet();
					ps.setLong(1, nextId);
					ps.setString(2, userdata.getUserId());
					ps.setArray(3, new StringArray(userdata.getRoles()));
					// set create timestamp
					ps.setLong(4, System.currentTimeMillis());
					int rows = ps.executeUpdate();
					if (rows!=1)
						throw new DAOException("Create failed, updated rows: "+rows);
					UserDataVO newUserdata = new UserDataVO(""+nextId);
					newUserdata.copyAttributesFrom(userdata);
					ret.add(newUserdata);
				}
				con.commit();
				return ret;
			} catch (SQLException e) {
				getLastId(con).set(getMaxId(con,TABNAME));
				log.warn("Failed attempt" +recoveryAttempt+ " from " +dbConfig.getIdRecoveryAttempts()+ " to create new entries (list) in "+TABNAME+" table", e);
				throwable = e;
				continue;
			} finally {
				net.anotheria.db.util.JDBCUtil.release(ps);
			}
		}
		log.error("All "+ dbConfig.getIdRecoveryAttempts()+" attempt of id rereading - Failed. "+"createUserDatas("+con+", "+list+")", throwable);
		throw new DAOSQLException(throwable);
	}

	/**
	 * Updates a UserData object.
	 * Returns the updated version.
	 */
	public UserData updateUserData(Connection con, UserData userdata) throws DAOException {
		PreparedStatement ps = null;
		try {
			con.setAutoCommit(true);
			ps = con.prepareStatement(createSQL(SQL_UPDATE_1, SQL_UPDATE_2));
			ps.setString(1, userdata.getUserId());
			ps.setArray(2, new StringArray(userdata.getRoles()));
			// set update timestamp
			ps.setLong(3, System.currentTimeMillis());
			// set id for the where clause
			ps.setLong(4, Long.parseLong(userdata.getId()));
			int rows = ps.executeUpdate();
			if (rows!=1)
				throw new DAOException("Update failed, updated rows: "+rows);
			return userdata;
		} catch (SQLException e) {
			log.error("updateUserData("+con+", "+userdata+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Updates multiple new UserData objects.
	 * Returns the updated versions.
	 */
	public List<UserData> updateUserDatas(Connection con, List<UserData> list) throws DAOException {
		PreparedStatement ps = null;
		try{
			con.setAutoCommit(false);
			ps = con.prepareStatement(createSQL(SQL_UPDATE_1, SQL_UPDATE_2));
			List<UserData> ret = new ArrayList<UserData>();
			for (UserData userdata : list){
				ps.setString(1, userdata.getUserId());
				ps.setArray(2, new StringArray(userdata.getRoles()));
				// set update timestamp
				ps.setLong(3, System.currentTimeMillis());
				// set id for the where clause
				ps.setLong(4, Long.parseLong(userdata.getId()));
				int rows = ps.executeUpdate();
				if (rows!=1)
					throw new DAOException("Update failed, updated rows: "+rows);
			}
			con.commit();
			return list;
		} catch (SQLException e) {
			log.error("updateUserDatas("+con+", "+list+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Returns all UserDatas objects stored which matches given properties.
	 */
	public List<UserData> getUserDatasByProperty(Connection con, List<QueryProperty> properties) throws DAOException {
		PreparedStatement ps = null;
		ResultSet result = null;
		try {
			// //enable caching of statements one day
			String SQL = createSQL(SQL_READ_ALL_BY_PROPERTY_1, SQL_READ_ALL_BY_PROPERTY_2);
			String whereClause = "";
			for (QueryProperty p : properties){
				if (whereClause.length()>0)
					whereClause += " AND ";
				String statement = p.unprepaireable()? (String) p.getValue(): "?";
				whereClause += p.getName().toLowerCase()+p.getComparator()+statement;
			}
			SQL += whereClause;
			ps = con.prepareStatement(SQL);
			int propertyPosition = 0;
			for (QueryProperty property: properties){
				if(property.unprepaireable())
					continue;
				setProperty(++propertyPosition, ps, property);
			}
			result = ps.executeQuery();
			ArrayList<UserData> ret = new ArrayList<UserData>();
			while(result.next())
				ret.add(rowMapper.map(result));
			return  ret;
		} catch (SQLException e) {
			log.error("getUserDatasByProperty("+con+","+ properties+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Returns UserDatas objects count.
	 */
	public int getUserDatasCount(Connection con) throws DAOException {
		PreparedStatement ps = null;
		ResultSet result = null;
		try {
			ps = con.prepareStatement(SQL_COUNT_1 + TABNAME);
			result = ps.executeQuery();
			int pCount = 0;
			if (result.next())
				pCount = result.getInt(1);
			return pCount;
		} catch (SQLException e) {
			log.error("getUserDatasCount(" + con + ")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Returns UserDatas objects segment.
	 */
	public List<UserData> getUserDatas(Connection con, Segment aSegment) throws DAOException {
		PreparedStatement ps = null;
		ResultSet result = null;
		try {
			con.setAutoCommit(true);
			ps = con.prepareStatement(createSQL(SQL_READ_ALL_1, SQL_READ_ALL_2) + SQL_LIMIT_1 + SQL_OFFSET_1);
			int pLimit = aSegment.getElementsPerSlice();
			int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
			ps.setInt(1, pLimit);
			ps.setInt(2, pOffset);
			result = ps.executeQuery();
			ArrayList<UserData> ret = new ArrayList<UserData>();
			while(result.next())
				ret.add(rowMapper.map(result));
			return  ret;
		} catch (SQLException e) {
			log.error("getUserDatas(" + con + ","+ aSegment +")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	/**
	 * Returns UserDatas objects segment which matches given properties.
	 */
	public List<UserData> getUserDatasByProperty(Connection con, Segment aSegment, List<QueryProperty> properties) throws DAOException {
		PreparedStatement ps = null;
		ResultSet result = null;
		try {
			// //enable caching of statements one day
			String SQL = createSQL(SQL_READ_ALL_BY_PROPERTY_1, SQL_READ_ALL_BY_PROPERTY_2);
			String whereClause = "";
			for (QueryProperty p : properties){
				if (whereClause.length()>0)
					whereClause += " AND ";
				String statement = p.unprepaireable()? (String) p.getValue(): "?";
				whereClause += p.getName()+p.getComparator()+statement;
			}
			SQL += whereClause;
			SQL += SQL_READ_ALL_2 + SQL_LIMIT_1 + SQL_OFFSET_1;
			ps = con.prepareStatement(SQL);
			int propertyPosition = 0;
			for (QueryProperty property: properties){
				if(property.unprepaireable())
					continue;
				setProperty(++propertyPosition, ps, property);
			}
			int pLimit = aSegment.getElementsPerSlice();
			int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
			ps.setInt(++propertyPosition, pLimit);
			ps.setInt(++propertyPosition, pOffset);
			result = ps.executeQuery();
			ArrayList<UserData> ret = new ArrayList<UserData>();
			while(result.next())
				ret.add(rowMapper.map(result));
			return  ret;
		} catch (SQLException e) {
			log.error("getUserDatasByProperty(" + con + "," + aSegment + "," + properties + ")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(ps);
		}
	}

	private void setProperty(int position, PreparedStatement ps, QueryProperty property) throws SQLException {
		if(property.unprepaireable()){
			return;
		}
		if (ATT_NAME_USERID.equals(property.getName().toLowerCase())){
			ps.setString(position, (String)property.getValue());
			return;
		}
		if (ATT_NAME_ROLES.equals(property.getName().toLowerCase())){
			//Not implemented;
			return;
		}
		if (ATT_NAME_ID.equals(property.getName())){
			ps.setLong(position, (Long)property.getValue());
			return;
		}
		if ("dao_created".equals(property.getName())){
			ps.setLong(position, (Long)property.getValue());
			return;
		}
		if ("dao_updated".equals(property.getName())){
			ps.setLong(position, (Long)property.getValue());
			return;
		}
	}
	/* ---------- SQL --------- 
	CREATE TABLE userdata(
	id int8 PRIMARY KEY,
	userid varchar,
	roles UNKNOWN!,
	dao_created int8,
	dao_updated int8
	)
	   ---------- SQL --------- */
	public void createStructure(Connection connection)  throws DAOException {
		// not implemented
	}

	/* ---------- SQL --------- 
	DROP TABLE userdata
	   ---------- SQL --------- */
	public void deleteStructure(Connection connection)  throws DAOException {
		// not implemented
	}

	private long getMaxId(Connection con, String tableName)  throws DAOException {
		Statement st = null;
		ResultSet result = null;
		try {
			con.setAutoCommit(true);
			st = con.createStatement();
			st.execute("SELECT MAX("+ATT_NAME_ID+") FROM "+tableName);
			result = st.getResultSet();
			long maxId = 0;
			if (result.next())
				maxId = result.getLong(1);
			log.info("maxId in table "+tableName+" is "+maxId);
			return maxId;
		} catch (SQLException e) {
			log.error("getMaxId("+con+", "+tableName+")", e);
			throw new DAOSQLException(e);
		} finally {
			net.anotheria.db.util.JDBCUtil.release(result);
			net.anotheria.db.util.JDBCUtil.release(st);
		}
	}

	public void init(Connection con)  throws DAOException {
		log.debug("Called: init("+con+")");
		long maxId = getMaxId(con, TABNAME);
		maxId = maxId >= dbConfig.getStartId() ? maxId : dbConfig.getStartId();
		lastId = new AtomicLong(maxId);
	}
}
