/**
 ********************************************************************************
 *** AnoAccessConfigurationServiceImpl.java                                   ***
 *** The implementation of the IAnoAccessConfigurationService.                ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.anoaccessconfiguration.service;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.anodoc.data.Module;
import net.anotheria.anodoc.data.Property;
import net.anotheria.anodoc.data.NoSuchPropertyException;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.util.slicer.Segment;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.ModuleAnoAccessConfiguration;
import net.anotheria.anosite.gen.shared.service.BasicCMSService;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.asg.util.listener.IModuleListener;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.AccessOperation;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.AccessOperationXMLHelper;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.AccessOperationDocument;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.Role;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.RoleXMLHelper;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.RoleDocument;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.Permission;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.PermissionXMLHelper;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.PermissionDocument;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.Constraint;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.ConstraintXMLHelper;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.ConstraintDocument;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.ContextInitializer;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.ContextInitializerXMLHelper;
import net.anotheria.anosite.gen.anoaccessconfiguration.data.ContextInitializerDocument;

public class AnoAccessConfigurationServiceImpl extends BasicCMSService implements IAnoAccessConfigurationService, IModuleListener{

	// Generated by: class net.anotheria.asg.generator.model.docs.CMSBasedServiceGenerator.generateImplementation

	private static AnoAccessConfigurationServiceImpl instance;

	private AnoAccessConfigurationServiceImpl(){
		addServiceListener(new net.anotheria.anosite.cms.listener.CRUDLogListener());
		addModuleListener(ModuleAnoAccessConfiguration.MODULE_ID, this);
	}

	static final AnoAccessConfigurationServiceImpl getInstance(){
		if (instance==null){
			instance = new AnoAccessConfigurationServiceImpl();
		}
		return instance;
	}

	private ModuleAnoAccessConfiguration _getModuleAnoAccessConfiguration(){
		return (ModuleAnoAccessConfiguration) getModule(ModuleAnoAccessConfiguration.MODULE_ID);
	}

	@Override
	public void moduleLoaded(Module module){
		firePersistenceChangedEvent();
	}

	@SuppressWarnings("unchecked")
	public List<AccessOperation> getAccessOperations(){
		List accessoperations = new ArrayList();
		accessoperations.addAll(_getModuleAnoAccessConfiguration().getAccessOperations());
		return accessoperations;
	}

	public List<AccessOperation> getAccessOperations(SortType sortType){
		return StaticQuickSorter.sort(getAccessOperations(), sortType);
	}

	/**
	 * Returns the AccessOperation objects with the specified ids.
	 */
	public List<AccessOperation> getAccessOperations(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<AccessOperation>(0);
		List<AccessOperation> all = getAccessOperations();
		List<AccessOperation> ret = new ArrayList<AccessOperation>();
		for (AccessOperation accessoperation : all){
			if(ids.contains(accessoperation.getId())){
				ret.add(accessoperation);
			}
		}
		return ret;
	}

	/**
	 * Returns the AccessOperation objects with the specified ids, sorted by given sorttype.
	 */
	public List<AccessOperation> getAccessOperations(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getAccessOperations(ids), sortType);
	}

	public void deleteAccessOperation(AccessOperation accessoperation){
		deleteAccessOperation(accessoperation.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(accessoperation);
		}
	}

	public void deleteAccessOperation(String id){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		AccessOperation varValue = hasServiceListeners()?module.getAccessOperation(id):null;
		module.deleteAccessOperation(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteAccessOperations(List<AccessOperation> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (AccessOperation accessoperation : list){
			module.deleteAccessOperation(accessoperation.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public AccessOperation getAccessOperation(String id){
		return _getModuleAnoAccessConfiguration().getAccessOperation(id);
	}

	public AccessOperation importAccessOperation(AccessOperation accessoperation){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.importAccessOperation((AccessOperationDocument)accessoperation);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(accessoperation);
		}
		return accessoperation;
	}

	public List<AccessOperation> importAccessOperations(List<AccessOperation> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<AccessOperation> ret = new ArrayList<AccessOperation>();
		for (AccessOperation accessoperation : list){
			AccessOperation imported = module.importAccessOperation((AccessOperationDocument)accessoperation);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (AccessOperation accessoperation : ret)
				fireObjectImportedEvent(accessoperation);
		}
		return ret;
	}

	public AccessOperation createAccessOperation(AccessOperation accessoperation){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.createAccessOperation((AccessOperationDocument)accessoperation);
		updateModule(module);
		fireObjectCreatedEvent(accessoperation);
		return accessoperation;
	}

	/**
	 * Creates multiple new AccessOperation objects.
	 * Returns the created versions.
	 */
	public List<AccessOperation> createAccessOperations(List<AccessOperation> list){;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<AccessOperation> ret = new ArrayList<AccessOperation>();
		for (AccessOperation accessoperation : list){
			AccessOperation created = module.createAccessOperation((AccessOperationDocument)accessoperation);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (AccessOperation accessoperation : ret)
				fireObjectCreatedEvent(accessoperation);
		}
		return ret;
	}

	public AccessOperation updateAccessOperation(AccessOperation accessoperation){
		AccessOperation oldVersion = null;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		if (hasServiceListeners())
			oldVersion = module.getAccessOperation(accessoperation.getId());
		module.updateAccessOperation((AccessOperationDocument)accessoperation);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, accessoperation);
		}
		return accessoperation;
	}

	public List<AccessOperation> updateAccessOperations(List<AccessOperation> list){
		List<AccessOperation> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<AccessOperation>(list.size());
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (AccessOperation accessoperation : list){
			if (oldList!=null)
				oldList.add(module.getAccessOperation(accessoperation.getId()));
			module.updateAccessOperation((AccessOperationDocument)accessoperation);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<AccessOperation> getAccessOperationsByProperty(String propertyName, Object value){
		List<AccessOperation> allAccessOperations = getAccessOperations();
		List<AccessOperation> ret = new ArrayList<AccessOperation>();
		for (int i=0; i<allAccessOperations.size(); i++){
			AccessOperation accessoperation = allAccessOperations.get(i);
			try{
				Property property = ((AccessOperationDocument)accessoperation).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(accessoperation);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(accessoperation);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(accessoperation);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<AccessOperation> getAccessOperationsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getAccessOperationsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on AccessOperations
	 */
	public QueryResult executeQueryOnAccessOperations(DocumentQuery query){
		List<AccessOperation> allAccessOperations = getAccessOperations();
		QueryResult result = new QueryResult();
		for (int i=0; i<allAccessOperations.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allAccessOperations.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all AccessOperation objects, where property matches.
	 */
	public List<AccessOperation> getAccessOperationsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<AccessOperation> ret = new ArrayList<AccessOperation>();
		List<AccessOperation> src = getAccessOperations();
		for ( AccessOperation accessoperation : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(accessoperation.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(accessoperation);
		}
		return ret;
	}

	/**
	 * Returns all AccessOperation objects, where property matches, sorted
	 */
	public List<AccessOperation> getAccessOperationsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getAccessOperationsByProperty(property), sortType);
	}

	/**
	 * Returns AccessOperation objects count.
	 */
	public int getAccessOperationsCount() {
		return _getModuleAnoAccessConfiguration().getAccessOperations().size();
	}

	/**
	 * Returns AccessOperation objects segment.
	 */
	public List<AccessOperation> getAccessOperations(Segment aSegment) {
		return Slicer.slice(aSegment, getAccessOperations()).getSliceData();
	}

	/**
	 * Returns AccessOperation objects segment, where property matched.
	 */
	public List<AccessOperation> getAccessOperationsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<AccessOperation> ret = new ArrayList<AccessOperation>();
		List<AccessOperation> src = getAccessOperations();
		for (AccessOperation accessoperation : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(accessoperation.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(accessoperation);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns AccessOperation objects segment, where property matched, sorted.
	 */
	public List<AccessOperation> getAccessOperationsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getAccessOperationsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Role> getRoles(){
		List roles = new ArrayList();
		roles.addAll(_getModuleAnoAccessConfiguration().getRoles());
		return roles;
	}

	public List<Role> getRoles(SortType sortType){
		return StaticQuickSorter.sort(getRoles(), sortType);
	}

	/**
	 * Returns the Role objects with the specified ids.
	 */
	public List<Role> getRoles(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Role>(0);
		List<Role> all = getRoles();
		List<Role> ret = new ArrayList<Role>();
		for (Role role : all){
			if(ids.contains(role.getId())){
				ret.add(role);
			}
		}
		return ret;
	}

	/**
	 * Returns the Role objects with the specified ids, sorted by given sorttype.
	 */
	public List<Role> getRoles(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getRoles(ids), sortType);
	}

	public void deleteRole(Role role){
		deleteRole(role.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(role);
		}
	}

	public void deleteRole(String id){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		Role varValue = hasServiceListeners()?module.getRole(id):null;
		module.deleteRole(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteRoles(List<Role> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (Role role : list){
			module.deleteRole(role.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Role getRole(String id){
		return _getModuleAnoAccessConfiguration().getRole(id);
	}

	public Role importRole(Role role){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.importRole((RoleDocument)role);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(role);
		}
		return role;
	}

	public List<Role> importRoles(List<Role> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<Role> ret = new ArrayList<Role>();
		for (Role role : list){
			Role imported = module.importRole((RoleDocument)role);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Role role : ret)
				fireObjectImportedEvent(role);
		}
		return ret;
	}

	public Role createRole(Role role){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.createRole((RoleDocument)role);
		updateModule(module);
		fireObjectCreatedEvent(role);
		return role;
	}

	/**
	 * Creates multiple new Role objects.
	 * Returns the created versions.
	 */
	public List<Role> createRoles(List<Role> list){;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<Role> ret = new ArrayList<Role>();
		for (Role role : list){
			Role created = module.createRole((RoleDocument)role);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Role role : ret)
				fireObjectCreatedEvent(role);
		}
		return ret;
	}

	public Role updateRole(Role role){
		Role oldVersion = null;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		if (hasServiceListeners())
			oldVersion = module.getRole(role.getId());
		module.updateRole((RoleDocument)role);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, role);
		}
		return role;
	}

	public List<Role> updateRoles(List<Role> list){
		List<Role> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Role>(list.size());
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (Role role : list){
			if (oldList!=null)
				oldList.add(module.getRole(role.getId()));
			module.updateRole((RoleDocument)role);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Role> getRolesByProperty(String propertyName, Object value){
		List<Role> allRoles = getRoles();
		List<Role> ret = new ArrayList<Role>();
		for (int i=0; i<allRoles.size(); i++){
			Role role = allRoles.get(i);
			try{
				Property property = ((RoleDocument)role).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(role);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(role);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(role);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Role> getRolesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getRolesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Roles
	 */
	public QueryResult executeQueryOnRoles(DocumentQuery query){
		List<Role> allRoles = getRoles();
		QueryResult result = new QueryResult();
		for (int i=0; i<allRoles.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allRoles.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Role objects, where property matches.
	 */
	public List<Role> getRolesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Role> ret = new ArrayList<Role>();
		List<Role> src = getRoles();
		for ( Role role : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(role.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(role);
		}
		return ret;
	}

	/**
	 * Returns all Role objects, where property matches, sorted
	 */
	public List<Role> getRolesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getRolesByProperty(property), sortType);
	}

	/**
	 * Returns Role objects count.
	 */
	public int getRolesCount() {
		return _getModuleAnoAccessConfiguration().getRoles().size();
	}

	/**
	 * Returns Role objects segment.
	 */
	public List<Role> getRoles(Segment aSegment) {
		return Slicer.slice(aSegment, getRoles()).getSliceData();
	}

	/**
	 * Returns Role objects segment, where property matched.
	 */
	public List<Role> getRolesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Role> ret = new ArrayList<Role>();
		List<Role> src = getRoles();
		for (Role role : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(role.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(role);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Role objects segment, where property matched, sorted.
	 */
	public List<Role> getRolesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getRolesByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Permission> getPermissions(){
		List permissions = new ArrayList();
		permissions.addAll(_getModuleAnoAccessConfiguration().getPermissions());
		return permissions;
	}

	public List<Permission> getPermissions(SortType sortType){
		return StaticQuickSorter.sort(getPermissions(), sortType);
	}

	/**
	 * Returns the Permission objects with the specified ids.
	 */
	public List<Permission> getPermissions(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Permission>(0);
		List<Permission> all = getPermissions();
		List<Permission> ret = new ArrayList<Permission>();
		for (Permission permission : all){
			if(ids.contains(permission.getId())){
				ret.add(permission);
			}
		}
		return ret;
	}

	/**
	 * Returns the Permission objects with the specified ids, sorted by given sorttype.
	 */
	public List<Permission> getPermissions(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPermissions(ids), sortType);
	}

	public void deletePermission(Permission permission){
		deletePermission(permission.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(permission);
		}
	}

	public void deletePermission(String id){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		Permission varValue = hasServiceListeners()?module.getPermission(id):null;
		module.deletePermission(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePermissions(List<Permission> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (Permission permission : list){
			module.deletePermission(permission.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Permission getPermission(String id){
		return _getModuleAnoAccessConfiguration().getPermission(id);
	}

	public Permission importPermission(Permission permission){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.importPermission((PermissionDocument)permission);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(permission);
		}
		return permission;
	}

	public List<Permission> importPermissions(List<Permission> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<Permission> ret = new ArrayList<Permission>();
		for (Permission permission : list){
			Permission imported = module.importPermission((PermissionDocument)permission);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Permission permission : ret)
				fireObjectImportedEvent(permission);
		}
		return ret;
	}

	public Permission createPermission(Permission permission){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.createPermission((PermissionDocument)permission);
		updateModule(module);
		fireObjectCreatedEvent(permission);
		return permission;
	}

	/**
	 * Creates multiple new Permission objects.
	 * Returns the created versions.
	 */
	public List<Permission> createPermissions(List<Permission> list){;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<Permission> ret = new ArrayList<Permission>();
		for (Permission permission : list){
			Permission created = module.createPermission((PermissionDocument)permission);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Permission permission : ret)
				fireObjectCreatedEvent(permission);
		}
		return ret;
	}

	public Permission updatePermission(Permission permission){
		Permission oldVersion = null;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		if (hasServiceListeners())
			oldVersion = module.getPermission(permission.getId());
		module.updatePermission((PermissionDocument)permission);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, permission);
		}
		return permission;
	}

	public List<Permission> updatePermissions(List<Permission> list){
		List<Permission> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Permission>(list.size());
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (Permission permission : list){
			if (oldList!=null)
				oldList.add(module.getPermission(permission.getId()));
			module.updatePermission((PermissionDocument)permission);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Permission> getPermissionsByProperty(String propertyName, Object value){
		List<Permission> allPermissions = getPermissions();
		List<Permission> ret = new ArrayList<Permission>();
		for (int i=0; i<allPermissions.size(); i++){
			Permission permission = allPermissions.get(i);
			try{
				Property property = ((PermissionDocument)permission).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(permission);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(permission);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(permission);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Permission> getPermissionsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPermissionsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Permissions
	 */
	public QueryResult executeQueryOnPermissions(DocumentQuery query){
		List<Permission> allPermissions = getPermissions();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPermissions.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPermissions.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Permission objects, where property matches.
	 */
	public List<Permission> getPermissionsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Permission> ret = new ArrayList<Permission>();
		List<Permission> src = getPermissions();
		for ( Permission permission : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(permission.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(permission);
		}
		return ret;
	}

	/**
	 * Returns all Permission objects, where property matches, sorted
	 */
	public List<Permission> getPermissionsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPermissionsByProperty(property), sortType);
	}

	/**
	 * Returns Permission objects count.
	 */
	public int getPermissionsCount() {
		return _getModuleAnoAccessConfiguration().getPermissions().size();
	}

	/**
	 * Returns Permission objects segment.
	 */
	public List<Permission> getPermissions(Segment aSegment) {
		return Slicer.slice(aSegment, getPermissions()).getSliceData();
	}

	/**
	 * Returns Permission objects segment, where property matched.
	 */
	public List<Permission> getPermissionsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Permission> ret = new ArrayList<Permission>();
		List<Permission> src = getPermissions();
		for (Permission permission : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(permission.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(permission);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Permission objects segment, where property matched, sorted.
	 */
	public List<Permission> getPermissionsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPermissionsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Constraint> getConstraints(){
		List constraints = new ArrayList();
		constraints.addAll(_getModuleAnoAccessConfiguration().getConstraints());
		return constraints;
	}

	public List<Constraint> getConstraints(SortType sortType){
		return StaticQuickSorter.sort(getConstraints(), sortType);
	}

	/**
	 * Returns the Constraint objects with the specified ids.
	 */
	public List<Constraint> getConstraints(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Constraint>(0);
		List<Constraint> all = getConstraints();
		List<Constraint> ret = new ArrayList<Constraint>();
		for (Constraint constraint : all){
			if(ids.contains(constraint.getId())){
				ret.add(constraint);
			}
		}
		return ret;
	}

	/**
	 * Returns the Constraint objects with the specified ids, sorted by given sorttype.
	 */
	public List<Constraint> getConstraints(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getConstraints(ids), sortType);
	}

	public void deleteConstraint(Constraint constraint){
		deleteConstraint(constraint.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(constraint);
		}
	}

	public void deleteConstraint(String id){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		Constraint varValue = hasServiceListeners()?module.getConstraint(id):null;
		module.deleteConstraint(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteConstraints(List<Constraint> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (Constraint constraint : list){
			module.deleteConstraint(constraint.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Constraint getConstraint(String id){
		return _getModuleAnoAccessConfiguration().getConstraint(id);
	}

	public Constraint importConstraint(Constraint constraint){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.importConstraint((ConstraintDocument)constraint);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(constraint);
		}
		return constraint;
	}

	public List<Constraint> importConstraints(List<Constraint> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<Constraint> ret = new ArrayList<Constraint>();
		for (Constraint constraint : list){
			Constraint imported = module.importConstraint((ConstraintDocument)constraint);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Constraint constraint : ret)
				fireObjectImportedEvent(constraint);
		}
		return ret;
	}

	public Constraint createConstraint(Constraint constraint){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.createConstraint((ConstraintDocument)constraint);
		updateModule(module);
		fireObjectCreatedEvent(constraint);
		return constraint;
	}

	/**
	 * Creates multiple new Constraint objects.
	 * Returns the created versions.
	 */
	public List<Constraint> createConstraints(List<Constraint> list){;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<Constraint> ret = new ArrayList<Constraint>();
		for (Constraint constraint : list){
			Constraint created = module.createConstraint((ConstraintDocument)constraint);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Constraint constraint : ret)
				fireObjectCreatedEvent(constraint);
		}
		return ret;
	}

	public Constraint updateConstraint(Constraint constraint){
		Constraint oldVersion = null;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		if (hasServiceListeners())
			oldVersion = module.getConstraint(constraint.getId());
		module.updateConstraint((ConstraintDocument)constraint);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, constraint);
		}
		return constraint;
	}

	public List<Constraint> updateConstraints(List<Constraint> list){
		List<Constraint> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Constraint>(list.size());
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (Constraint constraint : list){
			if (oldList!=null)
				oldList.add(module.getConstraint(constraint.getId()));
			module.updateConstraint((ConstraintDocument)constraint);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Constraint> getConstraintsByProperty(String propertyName, Object value){
		List<Constraint> allConstraints = getConstraints();
		List<Constraint> ret = new ArrayList<Constraint>();
		for (int i=0; i<allConstraints.size(); i++){
			Constraint constraint = allConstraints.get(i);
			try{
				Property property = ((ConstraintDocument)constraint).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(constraint);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(constraint);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(constraint);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Constraint> getConstraintsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getConstraintsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Constraints
	 */
	public QueryResult executeQueryOnConstraints(DocumentQuery query){
		List<Constraint> allConstraints = getConstraints();
		QueryResult result = new QueryResult();
		for (int i=0; i<allConstraints.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allConstraints.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Constraint objects, where property matches.
	 */
	public List<Constraint> getConstraintsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Constraint> ret = new ArrayList<Constraint>();
		List<Constraint> src = getConstraints();
		for ( Constraint constraint : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(constraint.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(constraint);
		}
		return ret;
	}

	/**
	 * Returns all Constraint objects, where property matches, sorted
	 */
	public List<Constraint> getConstraintsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getConstraintsByProperty(property), sortType);
	}

	/**
	 * Returns Constraint objects count.
	 */
	public int getConstraintsCount() {
		return _getModuleAnoAccessConfiguration().getConstraints().size();
	}

	/**
	 * Returns Constraint objects segment.
	 */
	public List<Constraint> getConstraints(Segment aSegment) {
		return Slicer.slice(aSegment, getConstraints()).getSliceData();
	}

	/**
	 * Returns Constraint objects segment, where property matched.
	 */
	public List<Constraint> getConstraintsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Constraint> ret = new ArrayList<Constraint>();
		List<Constraint> src = getConstraints();
		for (Constraint constraint : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(constraint.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(constraint);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Constraint objects segment, where property matched, sorted.
	 */
	public List<Constraint> getConstraintsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getConstraintsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<ContextInitializer> getContextInitializers(){
		List contextinitializers = new ArrayList();
		contextinitializers.addAll(_getModuleAnoAccessConfiguration().getContextInitializers());
		return contextinitializers;
	}

	public List<ContextInitializer> getContextInitializers(SortType sortType){
		return StaticQuickSorter.sort(getContextInitializers(), sortType);
	}

	/**
	 * Returns the ContextInitializer objects with the specified ids.
	 */
	public List<ContextInitializer> getContextInitializers(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<ContextInitializer>(0);
		List<ContextInitializer> all = getContextInitializers();
		List<ContextInitializer> ret = new ArrayList<ContextInitializer>();
		for (ContextInitializer contextinitializer : all){
			if(ids.contains(contextinitializer.getId())){
				ret.add(contextinitializer);
			}
		}
		return ret;
	}

	/**
	 * Returns the ContextInitializer objects with the specified ids, sorted by given sorttype.
	 */
	public List<ContextInitializer> getContextInitializers(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getContextInitializers(ids), sortType);
	}

	public void deleteContextInitializer(ContextInitializer contextinitializer){
		deleteContextInitializer(contextinitializer.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(contextinitializer);
		}
	}

	public void deleteContextInitializer(String id){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		ContextInitializer varValue = hasServiceListeners()?module.getContextInitializer(id):null;
		module.deleteContextInitializer(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteContextInitializers(List<ContextInitializer> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (ContextInitializer contextinitializer : list){
			module.deleteContextInitializer(contextinitializer.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public ContextInitializer getContextInitializer(String id){
		return _getModuleAnoAccessConfiguration().getContextInitializer(id);
	}

	public ContextInitializer importContextInitializer(ContextInitializer contextinitializer){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.importContextInitializer((ContextInitializerDocument)contextinitializer);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(contextinitializer);
		}
		return contextinitializer;
	}

	public List<ContextInitializer> importContextInitializers(List<ContextInitializer> list){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<ContextInitializer> ret = new ArrayList<ContextInitializer>();
		for (ContextInitializer contextinitializer : list){
			ContextInitializer imported = module.importContextInitializer((ContextInitializerDocument)contextinitializer);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (ContextInitializer contextinitializer : ret)
				fireObjectImportedEvent(contextinitializer);
		}
		return ret;
	}

	public ContextInitializer createContextInitializer(ContextInitializer contextinitializer){
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		module.createContextInitializer((ContextInitializerDocument)contextinitializer);
		updateModule(module);
		fireObjectCreatedEvent(contextinitializer);
		return contextinitializer;
	}

	/**
	 * Creates multiple new ContextInitializer objects.
	 * Returns the created versions.
	 */
	public List<ContextInitializer> createContextInitializers(List<ContextInitializer> list){;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		List<ContextInitializer> ret = new ArrayList<ContextInitializer>();
		for (ContextInitializer contextinitializer : list){
			ContextInitializer created = module.createContextInitializer((ContextInitializerDocument)contextinitializer);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (ContextInitializer contextinitializer : ret)
				fireObjectCreatedEvent(contextinitializer);
		}
		return ret;
	}

	public ContextInitializer updateContextInitializer(ContextInitializer contextinitializer){
		ContextInitializer oldVersion = null;
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		if (hasServiceListeners())
			oldVersion = module.getContextInitializer(contextinitializer.getId());
		module.updateContextInitializer((ContextInitializerDocument)contextinitializer);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, contextinitializer);
		}
		return contextinitializer;
	}

	public List<ContextInitializer> updateContextInitializers(List<ContextInitializer> list){
		List<ContextInitializer> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<ContextInitializer>(list.size());
		ModuleAnoAccessConfiguration module = _getModuleAnoAccessConfiguration();
		for (ContextInitializer contextinitializer : list){
			if (oldList!=null)
				oldList.add(module.getContextInitializer(contextinitializer.getId()));
			module.updateContextInitializer((ContextInitializerDocument)contextinitializer);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<ContextInitializer> getContextInitializersByProperty(String propertyName, Object value){
		List<ContextInitializer> allContextInitializers = getContextInitializers();
		List<ContextInitializer> ret = new ArrayList<ContextInitializer>();
		for (int i=0; i<allContextInitializers.size(); i++){
			ContextInitializer contextinitializer = allContextInitializers.get(i);
			try{
				Property property = ((ContextInitializerDocument)contextinitializer).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(contextinitializer);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(contextinitializer);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(contextinitializer);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<ContextInitializer> getContextInitializersByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getContextInitializersByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on ContextInitializers
	 */
	public QueryResult executeQueryOnContextInitializers(DocumentQuery query){
		List<ContextInitializer> allContextInitializers = getContextInitializers();
		QueryResult result = new QueryResult();
		for (int i=0; i<allContextInitializers.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allContextInitializers.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all ContextInitializer objects, where property matches.
	 */
	public List<ContextInitializer> getContextInitializersByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<ContextInitializer> ret = new ArrayList<ContextInitializer>();
		List<ContextInitializer> src = getContextInitializers();
		for ( ContextInitializer contextinitializer : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(contextinitializer.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(contextinitializer);
		}
		return ret;
	}

	/**
	 * Returns all ContextInitializer objects, where property matches, sorted
	 */
	public List<ContextInitializer> getContextInitializersByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getContextInitializersByProperty(property), sortType);
	}

	/**
	 * Returns ContextInitializer objects count.
	 */
	public int getContextInitializersCount() {
		return _getModuleAnoAccessConfiguration().getContextInitializers().size();
	}

	/**
	 * Returns ContextInitializer objects segment.
	 */
	public List<ContextInitializer> getContextInitializers(Segment aSegment) {
		return Slicer.slice(aSegment, getContextInitializers()).getSliceData();
	}

	/**
	 * Returns ContextInitializer objects segment, where property matched.
	 */
	public List<ContextInitializer> getContextInitializersByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<ContextInitializer> ret = new ArrayList<ContextInitializer>();
		List<ContextInitializer> src = getContextInitializers();
		for (ContextInitializer contextinitializer : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(contextinitializer.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(contextinitializer);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns ContextInitializer objects segment, where property matched, sorted.
	 */
	public List<ContextInitializer> getContextInitializersByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getContextInitializersByProperty(aSegment, aProperty), aSortType);
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query){
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnAccessOperations(query).getEntries());
		ret.add(executeQueryOnRoles(query).getEntries());
		ret.add(executeQueryOnPermissions(query).getEntries());
		ret.add(executeQueryOnConstraints(query).getEntries());
		ret.add(executeQueryOnContextInitializers(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects


	public XMLNode exportAccessOperationsToXML(){;
		XMLNode ret = new XMLNode("AccessOperations");
		List<AccessOperation> list = getAccessOperations();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (AccessOperation object : list)
			ret.addChildNode(AccessOperationXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportAccessOperationsToXML(List<AccessOperation> list){;
		XMLNode ret = new XMLNode("AccessOperations");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (AccessOperation object : list)
			ret.addChildNode(AccessOperationXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportRolesToXML(){;
		XMLNode ret = new XMLNode("Roles");
		List<Role> list = getRoles();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Role object : list)
			ret.addChildNode(RoleXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportRolesToXML(List<Role> list){;
		XMLNode ret = new XMLNode("Roles");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Role object : list)
			ret.addChildNode(RoleXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPermissionsToXML(){;
		XMLNode ret = new XMLNode("Permissions");
		List<Permission> list = getPermissions();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Permission object : list)
			ret.addChildNode(PermissionXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPermissionsToXML(List<Permission> list){;
		XMLNode ret = new XMLNode("Permissions");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Permission object : list)
			ret.addChildNode(PermissionXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportConstraintsToXML(){;
		XMLNode ret = new XMLNode("Constraints");
		List<Constraint> list = getConstraints();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Constraint object : list)
			ret.addChildNode(ConstraintXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportConstraintsToXML(List<Constraint> list){;
		XMLNode ret = new XMLNode("Constraints");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Constraint object : list)
			ret.addChildNode(ConstraintXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportContextInitializersToXML(){;
		XMLNode ret = new XMLNode("ContextInitializers");
		List<ContextInitializer> list = getContextInitializers();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (ContextInitializer object : list)
			ret.addChildNode(ContextInitializerXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportContextInitializersToXML(List<ContextInitializer> list){;
		XMLNode ret = new XMLNode("ContextInitializers");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (ContextInitializer object : list)
			ret.addChildNode(ContextInitializerXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("AnoAccessConfiguration");

		ret.addChildNode(exportAccessOperationsToXML());
		ret.addChildNode(exportRolesToXML());
		ret.addChildNode(exportPermissionsToXML());
		ret.addChildNode(exportConstraintsToXML());
		ret.addChildNode(exportContextInitializersToXML());

		return ret;
	}
}
