/**
 ********************************************************************************
 *** BasePostAction.java                                                      ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.action;

import net.anotheria.anosite.gen.shared.action.BaseBlogAction;
import javax.servlet.http.HttpServletRequest;
import net.anotheria.anosite.gen.asblogdata.data.Post;
import net.anotheria.asg.data.AbstractASGDocument;
import net.anotheria.asg.data.LockableObject;
import net.anotheria.asg.util.locking.exeption.LockingException;
import net.anotheria.asg.util.locking.helper.DocumentLockingHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import net.anotheria.maf.bean.FormBean;

public abstract class BasePostAction <T extends FormBean> extends BaseBlogAction<T>{

// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateBaseAction


	private final Logger logger = LoggerFactory.getLogger("cms-lock-log");
	protected String getTitle(){
		return "Posts";
	} //getTitle

	protected String getCurrentModuleDefName(){
		return "ASBlogData";
	} //getCurrentModuleDefName

	protected String getCurrentDocumentDefName(){
		return "Post";
	} //getCurrentDocumentDefName

	/**
	 * Executing locking. Actually.
	 */
	protected void lockPosts(Post post, HttpServletRequest req) throws Exception{
		if(post instanceof AbstractASGDocument){
			AbstractASGDocument lock = (AbstractASGDocument)post;
			lock.setLocked(true);
			lock.setLockerId(getUserId(req));
			lock.setLockingTime(System.currentTimeMillis());
			getASBlogDataService().updatePost( post);
			logger.info("Lock-OPERATION, document with id : ["+post.getId()+"] was locked by: " + getUserId(req));
			addLockedAttribute(req, lock);
		}
	}
	/**
	 * Executing unlocking. Actually.
	 */
	protected void unLockPosts(Post post, HttpServletRequest req, boolean unlockByTimeoout) throws Exception{
		if(post instanceof AbstractASGDocument){
			AbstractASGDocument lock = (AbstractASGDocument)post;
			lock.setLocked(false);
			lock.setLockerId("");
			lock.setLockingTime(0);
			getASBlogDataService().updatePost( post);
			if (!unlockByTimeoout){
			   logger.info("UnLock-OPERATION, document with id : ["+post.getId()+"] was unlocked by: " + getUserId(req) +"  with 'admin' role :" + isUserInRole(req, "admin") );
			 } else { 
			   logger.info("UnLock-OPERATION, document with id : ["+post.getId()+"] was unlocked by: timeOut");
			}
			removeLockedAttribute(req, lock);
		}
	}
	/**
	 * Executing auto-unlocking check....
	 */
	protected void checkPosts(Post post, HttpServletRequest req) throws Exception{
		boolean shouldUnlock = post instanceof AbstractASGDocument && 
 	 	 	 	 ((AbstractASGDocument)post).isLocked() && 
 	 	 	 	 ( System.currentTimeMillis() >= ((AbstractASGDocument)post).getLockingTime() + getLockingTimeout());
		if(shouldUnlock)
			unLockPosts(post, req, true);
	}
	/**
	 * Checking UpdateCapability rights
	 */
	protected void canUpdatePosts(Post post, HttpServletRequest req) throws Exception{
		if(post instanceof LockableObject ){
		//Actually - simplest Check! --  exception - if anything happens!!!!
			DocumentLockingHelper.update.checkExecutionPermission((LockableObject)post, false, getUserId(req));
		}
		if (isTimeoutReached(post)) {
			checkPosts(post, req);
			throw new LockingException(getUserId(req)+" . Document can't be updated! Due to lock - timeout!!!");
		}
		if (wasUnlockedByAdmin(post, req)) {
			throw new LockingException(getUserId(req)+" . Document can't be updated! It was unlocked by user in 'admin' role!!!");
		}
	}
	/**
	 */
	private boolean isTimeoutReached(Post post){
		if (post instanceof LockableObject) {
			LockableObject lock = (LockableObject)post;
			return lock.isLocked() && lock.getLockingTime() + getLockingTimeout() <= System.currentTimeMillis();
		}
		return false;
	}
	/**
	 */
	private boolean wasUnlockedByAdmin(Post post, HttpServletRequest req){
		if (post instanceof AbstractASGDocument) {
			AbstractASGDocument lock = (AbstractASGDocument)post;
			return !lock.isLocked() && containsLockedAttribute(req, lock);
		}
		return false;
	}
}
