/**
 ********************************************************************************
 *** MultiOpDialogCommentsAction.java                                         ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.action;

import net.anotheria.util.NumberUtils;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.anotheria.maf.action.ActionForward;
import net.anotheria.maf.action.ActionMapping;
import net.anotheria.maf.bean.FormBean;
import java.util.List;
import java.util.ArrayList;
import net.anotheria.anosite.gen.asblogdata.data.CommentFactory;
import net.anotheria.anosite.gen.asblogdata.data.Comment;
import net.anotheria.anosite.gen.asblogdata.bean.EditCommentFB;
import net.anotheria.asg.data.LockableObject;
import net.anotheria.asg.util.locking.helper.DocumentLockingHelper;
import net.anotheria.maf.bean.annotations.Form;

public class MultiOpDialogCommentsAction extends BaseCommentAction<EditCommentFB>{

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateMultiOpDialogAction


	@Override
	public ActionForward execute(ActionMapping mapping, @Form(EditCommentFB.class) FormBean formBean, HttpServletRequest req, HttpServletResponse res) throws Exception{
		return super.execute(mapping, formBean, req, res);
	} //execute

	public ActionForward anoDocExecute(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String path = stripPath(mapping.getPath());
		if (path.equals("asblogdataCommentDelete"))
			return asblogdataCommentDelete(mapping, af, req, res);
		if (path.equals("asblogdataCommentDuplicate"))
			return asblogdataCommentDuplicate(mapping, af, req, res);
		if (path.equals("asblogdataCommentUpdate"))
			return asblogdataCommentUpdate(mapping, af, req, res);
		if (path.equals("asblogdataCommentClose"))
			return asblogdataCommentClose(mapping, af, req, res);
		if (path.equals("asblogdataCommentLock"))
			return asblogdataCommentLock(mapping, af, req, res);
		if (path.equals("asblogdataCommentUnLock"))
			return asblogdataCommentUnLock(mapping, af, req, res);
		throw new IllegalArgumentException("Unknown path: "+path);
	}

	public ActionForward asblogdataCommentDelete(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String[] iDs = req.getParameterValues(PARAM_ID);
		if (iDs == null){
		throw new RuntimeException("Parameter " + PARAM_ID + " is not set.");
	}
	for (String id : iDs){
		Comment commentCurr = getASBlogDataService().getComment(id);
		if (commentCurr instanceof LockableObject){ 
		LockableObject lockable = (LockableObject)commentCurr;
		DocumentLockingHelper.delete.checkExecutionPermission(lockable, false, getUserId(req));
		}
		getASBlogDataService().deleteComment(id);
	}
	res.sendRedirect("asblogdataCommentShow?ts="+System.currentTimeMillis());
	return null;
}

public ActionForward asblogdataCommentDuplicate(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Comment commentSrc = getASBlogDataService().getComment(id);
	Comment commentDest = CommentFactory.createComment(commentSrc);


	Comment commentCreated = getASBlogDataService().createComment(commentDest);
	res.sendRedirect("asblogdataCommentEdit?ts="+System.currentTimeMillis()+"&"+PARAM_ID+"="+commentCreated.getId());

	return null;
}

// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateUpdateActionMethod

public ActionForward asblogdataCommentUpdate(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	EditCommentFB form = (EditCommentFB) af;
	boolean create = false;
	Comment comment = null;
	if (form.getId()!=null && form.getId().length()>0){
		comment = (Comment)getASBlogDataService().getComment(form.getId()).clone();
	}else{
		comment = CommentFactory.createComment();
		create = true;
	}

	String nextAction = req.getParameter("nextAction");
	if (nextAction == null || nextAction.length() == 0)
		nextAction = "close";

	//skipped id because it's readonly.
	comment.setContent(form.getContent());

	Comment updatedCopy = null;
	if (create){
		updatedCopy = getASBlogDataService().createComment(comment);
	}else{
		canUpdateComments(comment, req);
		checkComments(comment, req);
		updatedCopy = getASBlogDataService().updateComment(comment);
	}
	if (nextAction.equalsIgnoreCase("stay")){
		res.sendRedirect("asblogdataCommentEdit?ts="+System.currentTimeMillis()+"&pId="+updatedCopy.getId());
	}else{
		unlockAfterUpdate(comment, req);
		res.sendRedirect("asblogdataCommentShow?ts="+System.currentTimeMillis());
	}
	return null;
}
/**
 * Simply unlocks document after updation.
 */
private void unlockAfterUpdate(Comment comment, HttpServletRequest req) throws Exception{
	if(((LockableObject)comment).isLocked())
		unLockComments(comment, req, false);
}

public ActionForward asblogdataCommentLock(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Comment commentCurr = id != null && !id.equals("") ? getASBlogDataService().getComment(id) : null;
	if(commentCurr != null && commentCurr instanceof LockableObject){ 
		LockableObject lockable = (LockableObject)commentCurr;
		DocumentLockingHelper.lock.checkExecutionPermission(lockable,false,getUserId(req));
		lockComments(commentCurr, req);
	}
	res.sendRedirect(getRedirectUrl(req, commentCurr));
	return null;
}

public ActionForward asblogdataCommentUnLock(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Comment commentCurr = id != null && !id.equals("") ? getASBlogDataService().getComment(id) : null;
	if(commentCurr != null && commentCurr instanceof LockableObject){ 
		LockableObject lockable = (LockableObject)commentCurr;
		DocumentLockingHelper.unLock.checkExecutionPermission(lockable,isUserInRole(req, "admin"),getUserId(req));
		unLockComments(commentCurr, req, false);
	}
	res.sendRedirect(getRedirectUrl(req, commentCurr));
	return null;
}

/**
 * Simplest method for redirect url creation. nextAction == showEdit - going to 'editView', to 'listView' otherwise. 
 */
private String getRedirectUrl(HttpServletRequest req, Comment item){
	String nextAction = req.getParameter("nextAction");
	if (item==null || nextAction == null || nextAction.length() == 0)
		return "asblogdataCommentShow?ts="+System.currentTimeMillis();
	else
		return nextAction.equals("showEdit") ? "asblogdataCommentEdit?ts="+System.currentTimeMillis()+"&pId="+item.getId()
		       : "asblogdataCommentShow?ts="+System.currentTimeMillis();
}

public ActionForward asblogdataCommentClose(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Comment commentCurr = id != null && !id.equals("") ? getASBlogDataService().getComment(id) : null;
	if(commentCurr != null && commentCurr instanceof LockableObject && ((LockableObject)commentCurr).isLocked()) 
		unLockComments(commentCurr, req, false);
	res.sendRedirect("asblogdataCommentShow?ts="+System.currentTimeMillis());
	return null;
}

}
