/**
 ********************************************************************************
 *** MultiOpDialogTagsAction.java                                             ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.action;

import net.anotheria.util.NumberUtils;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.anotheria.maf.action.ActionForward;
import net.anotheria.maf.action.ActionMapping;
import net.anotheria.maf.bean.FormBean;
import java.util.List;
import java.util.ArrayList;
import net.anotheria.anosite.gen.asblogdata.data.TagFactory;
import net.anotheria.anosite.gen.asblogdata.data.Tag;
import net.anotheria.anosite.gen.asblogdata.bean.EditTagFB;
import net.anotheria.asg.data.LockableObject;
import net.anotheria.asg.util.locking.helper.DocumentLockingHelper;
import net.anotheria.maf.bean.annotations.Form;

public class MultiOpDialogTagsAction extends BaseTagAction<EditTagFB>{

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateMultiOpDialogAction


	@Override
	public ActionForward execute(ActionMapping mapping, @Form(EditTagFB.class) FormBean formBean, HttpServletRequest req, HttpServletResponse res) throws Exception{
		return super.execute(mapping, formBean, req, res);
	} //execute

	public ActionForward anoDocExecute(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String path = stripPath(mapping.getPath());
		if (path.equals("asblogdataTagDelete"))
			return asblogdataTagDelete(mapping, af, req, res);
		if (path.equals("asblogdataTagDuplicate"))
			return asblogdataTagDuplicate(mapping, af, req, res);
		if (path.equals("asblogdataTagUpdate"))
			return asblogdataTagUpdate(mapping, af, req, res);
		if (path.equals("asblogdataTagClose"))
			return asblogdataTagClose(mapping, af, req, res);
		if (path.equals("asblogdataTagLock"))
			return asblogdataTagLock(mapping, af, req, res);
		if (path.equals("asblogdataTagUnLock"))
			return asblogdataTagUnLock(mapping, af, req, res);
		throw new IllegalArgumentException("Unknown path: "+path);
	}

	public ActionForward asblogdataTagDelete(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String[] iDs = req.getParameterValues(PARAM_ID);
		if (iDs == null){
		throw new RuntimeException("Parameter " + PARAM_ID + " is not set.");
	}
	for (String id : iDs){
		Tag tagCurr = getASBlogDataService().getTag(id);
		if (tagCurr instanceof LockableObject){ 
		LockableObject lockable = (LockableObject)tagCurr;
		DocumentLockingHelper.delete.checkExecutionPermission(lockable, false, getUserId(req));
		}
		getASBlogDataService().deleteTag(id);
	}
	res.sendRedirect("asblogdataTagShow?ts="+System.currentTimeMillis());
	return null;
}

public ActionForward asblogdataTagDuplicate(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Tag tagSrc = getASBlogDataService().getTag(id);
	Tag tagDest = TagFactory.createTag(tagSrc);


	Tag tagCreated = getASBlogDataService().createTag(tagDest);
	res.sendRedirect("asblogdataTagEdit?ts="+System.currentTimeMillis()+"&"+PARAM_ID+"="+tagCreated.getId());

	return null;
}

// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateUpdateActionMethod

public ActionForward asblogdataTagUpdate(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	EditTagFB form = (EditTagFB) af;
	boolean create = false;
	Tag tag = null;
	if (form.getId()!=null && form.getId().length()>0){
		tag = (Tag)getASBlogDataService().getTag(form.getId()).clone();
	}else{
		tag = TagFactory.createTag();
		create = true;
	}

	String nextAction = req.getParameter("nextAction");
	if (nextAction == null || nextAction.length() == 0)
		nextAction = "close";

	//skipped id because it's readonly.
	tag.setName(form.getName());

	Tag updatedCopy = null;
	if (create){
		updatedCopy = getASBlogDataService().createTag(tag);
	}else{
		canUpdateTags(tag, req);
		checkTags(tag, req);
		updatedCopy = getASBlogDataService().updateTag(tag);
	}
	if (nextAction.equalsIgnoreCase("stay")){
		res.sendRedirect("asblogdataTagEdit?ts="+System.currentTimeMillis()+"&pId="+updatedCopy.getId());
	}else{
		unlockAfterUpdate(tag, req);
		res.sendRedirect("asblogdataTagShow?ts="+System.currentTimeMillis());
	}
	return null;
}
/**
 * Simply unlocks document after updation.
 */
private void unlockAfterUpdate(Tag tag, HttpServletRequest req) throws Exception{
	if(((LockableObject)tag).isLocked())
		unLockTags(tag, req, false);
}

public ActionForward asblogdataTagLock(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Tag tagCurr = id != null && !id.equals("") ? getASBlogDataService().getTag(id) : null;
	if(tagCurr != null && tagCurr instanceof LockableObject){ 
		LockableObject lockable = (LockableObject)tagCurr;
		DocumentLockingHelper.lock.checkExecutionPermission(lockable,false,getUserId(req));
		lockTags(tagCurr, req);
	}
	res.sendRedirect(getRedirectUrl(req, tagCurr));
	return null;
}

public ActionForward asblogdataTagUnLock(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Tag tagCurr = id != null && !id.equals("") ? getASBlogDataService().getTag(id) : null;
	if(tagCurr != null && tagCurr instanceof LockableObject){ 
		LockableObject lockable = (LockableObject)tagCurr;
		DocumentLockingHelper.unLock.checkExecutionPermission(lockable,isUserInRole(req, "admin"),getUserId(req));
		unLockTags(tagCurr, req, false);
	}
	res.sendRedirect(getRedirectUrl(req, tagCurr));
	return null;
}

/**
 * Simplest method for redirect url creation. nextAction == showEdit - going to 'editView', to 'listView' otherwise. 
 */
private String getRedirectUrl(HttpServletRequest req, Tag item){
	String nextAction = req.getParameter("nextAction");
	if (item==null || nextAction == null || nextAction.length() == 0)
		return "asblogdataTagShow?ts="+System.currentTimeMillis();
	else
		return nextAction.equals("showEdit") ? "asblogdataTagEdit?ts="+System.currentTimeMillis()+"&pId="+item.getId()
		       : "asblogdataTagShow?ts="+System.currentTimeMillis();
}

public ActionForward asblogdataTagClose(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
	String id = getStringParameter(req, PARAM_ID);
	Tag tagCurr = id != null && !id.equals("") ? getASBlogDataService().getTag(id) : null;
	if(tagCurr != null && tagCurr instanceof LockableObject && ((LockableObject)tagCurr).isLocked()) 
		unLockTags(tagCurr, req, false);
	res.sendRedirect("asblogdataTagShow?ts="+System.currentTimeMillis());
	return null;
}

}
