/**
 ********************************************************************************
 *** MultiOpPostsTagsAction.java                                              ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.action;

import java.util.List;
import java.util.ArrayList;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.anotheria.maf.action.ActionForward;
import net.anotheria.maf.action.ActionMapping;
import net.anotheria.maf.bean.FormBean;
import net.anotheria.anosite.gen.asblogdata.data.PostFactory;
import net.anotheria.anosite.gen.asblogdata.data.Post;
import net.anotheria.anosite.gen.asblogdata.bean.TagsElementFB;
import net.anotheria.anosite.gen.asblogdata.bean.TagsQuickAddFB;
import net.anotheria.anosite.gen.asblogdata.data.Tag;
import net.anotheria.anosite.gen.asblogdata.data.TagSortType;
import net.anotheria.webutils.bean.LabelValueBean;
import net.anotheria.anodoc.data.NoSuchDocumentException;
import net.anotheria.util.StringUtils;
import net.anotheria.asg.exception.ASGRuntimeException;

public class MultiOpPostsTagsAction extends BasePostAction{

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateContainerMultiOpAction

	public ActionForward anoDocExecute(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String path = stripPath(mapping.getPath());
		if (path.equals("asblogdataPostTagsShow"))
			return asblogdataPostTagsShow(mapping, af, req, res);
		if (path.equals("asblogdataPostTagsAdd"))
			return asblogdataPostTagsAdd(mapping, af, req, res);
		if (path.equals("asblogdataPostTagsDelete"))
			return asblogdataPostTagsDelete(mapping, af, req, res);
		if (path.equals("asblogdataPostTagsMove"))
			return asblogdataPostTagsMove(mapping, af, req, res);
		if (path.equals("asblogdataPostTagsQuickAdd"))
			return asblogdataPostTagsQuickAdd(mapping, af, req, res);
		throw new IllegalArgumentException("Unknown path: "+path);
	}

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateListShowActionMethod

	public ActionForward asblogdataPostTagsShow(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String id = getStringParameter(req, "ownerId");
		Post post = getASBlogDataService().getPost(id);
		addBeanToRequest(req, "ownerId", id);
		checkPosts(post, req);

		TagsElementFB form = new TagsElementFB() ;
		form.setPosition(-1);
		form.setOwnerId(post.getId());
		addBeanToRequest(req, "asblogdataPostTagsElementForm", form);

		TagsQuickAddFB quickAddForm = new TagsQuickAddFB() ;
		quickAddForm.setOwnerId(post.getId());
		addBeanToRequest(req, "asblogdataPostTagsQuickAddForm", quickAddForm);


		//link postTagLink to ASBlogData.Tag
		List<Tag> tags = getASBlogDataService().getTags(new TagSortType(TagSortType.SORT_BY_NAME));
		List<LabelValueBean> tagsValues = new ArrayList<LabelValueBean>(tags.size());
		for (int i=0; i<tags.size(); i++){
			net.anotheria.anosite.gen.asblogdata.data.Tag tmp_tag = (net.anotheria.anosite.gen.asblogdata.data.Tag) tags.get(i);
			LabelValueBean bean = new LabelValueBean(tmp_tag.getId(), tmp_tag.getName()+" ["+tmp_tag.getId()+"]" );
			tagsValues.add(bean);
		}
		addBeanToRequest(req, "posttaglinkValuesCollection", tagsValues);
		// generate list ...
		int size = post.getTagsSize();
		List<TagsElementFB> beans = new ArrayList<TagsElementFB>(size);
		for (int i=0; i<size; i++){
			String value = post.getTagsElement(i);
			TagsElementFB bean = new TagsElementFB();
			bean.setOwnerId(post.getId());
			bean.setPosition(i);
			bean.setPostTagLink(value);
			try{
				Tag tmp_tag = getASBlogDataService().getTag(value);
				bean.setDescription(tmp_tag.getName());
			}catch(NoSuchDocumentException e){
				bean.setDescription("*** DELETED ***");
			}
			beans.add(bean);
		}
		addBeanToRequest(req, "elements", beans);
		return mapping.findForward("success");
	}

	public ActionForward asblogdataPostTagsDelete(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String id = getStringParameter(req, "ownerId");
		Post postCurr = getASBlogDataService().getPost(id);
		canUpdatePosts(postCurr, req);
		checkPosts(postCurr, req);
		int position = getIntParameter(req, "pPosition");
		Post post = getASBlogDataService().getPost(id);
		post.removeTagsElement(position);
		getASBlogDataService().updatePost(post);
		return asblogdataPostTagsShow(mapping, af, req, res);
	}

	public ActionForward asblogdataPostTagsMove(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String id = getStringParameter(req, "ownerId");
		int position = getIntParameter(req, "pPosition");
		String direction = getStringParameter(req, "dir");
		Post post = getASBlogDataService().getPost(id);
		canUpdatePosts(post, req);
		checkPosts(post, req);
		if ("top".equalsIgnoreCase(direction))
			moveTop(post, position);
		if ("up".equalsIgnoreCase(direction))
			moveUp(post, position);
		if ("down".equalsIgnoreCase(direction))
			moveDown(post, position);
		if ("bottom".equalsIgnoreCase(direction))
			moveBottom(post, position);
		return asblogdataPostTagsShow(mapping, af, req, res);
	}

	private void moveUp(Post post, int position) throws ASGRuntimeException {
		if (position==0) 
			return;
		post.swapTagsElement(position, position-1);
		getASBlogDataService().updatePost(post);
	}

	private void moveTop(Post post, int position) throws ASGRuntimeException {
		List<String> targetList = post.getTags();
		String toSwap = targetList.remove(position);
		targetList.add(0, toSwap);
		post.setTags(targetList);
		getASBlogDataService().updatePost(post);
	}

	private void moveDown(Post post, int position) throws ASGRuntimeException {
		if (position<post.getTagsSize()-1){
			post.swapTagsElement(position, position+1);
			getASBlogDataService().updatePost(post);
		}
	}

	private void moveBottom(Post post, int position) throws ASGRuntimeException {
		List<String> targetList = post.getTags();
		String toSwap = targetList.remove(position);
		targetList.add(toSwap);
		post.setTags(targetList);
		getASBlogDataService().updatePost(post);
	}

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateListAddRowActionMethod

	public ActionForward asblogdataPostTagsAdd(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		TagsElementFB form = new TagsElementFB();
		populateFormBean(req, form);
		String id = form.getOwnerId();
		System.out.println("FormBean: " + form.toString());;
		Post post;
		post = getASBlogDataService().getPost(id);
		canUpdatePosts(post, req);
		checkPosts(post, req);
		post.addTagsElement(form.getPostTagLink());
		getASBlogDataService().updatePost(post);
		return asblogdataPostTagsShow(mapping, af, req, res);
	}

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateListQuickAddActionMethod

	public ActionForward asblogdataPostTagsQuickAdd(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		TagsQuickAddFB form = new TagsQuickAddFB();
		populateFormBean(req, form);
		String id = form.getOwnerId();
		Post post;
		post = getASBlogDataService().getPost(id);
		canUpdatePosts(post, req);
		checkPosts(post, req);
		String paramIdsToAdd = form.getQuickAddIds();

		String idParameters[] = StringUtils.tokenize(paramIdsToAdd, ',');
		for (String anIdParam : idParameters){
			String ids[] = StringUtils.tokenize(anIdParam, '-');
			for (int i=Integer.parseInt(ids[0]); i<=Integer.parseInt(ids[ids.length-1]); i++){
				post.addTagsElement(""+i);
			}
		}
		getASBlogDataService().updatePost(post);
		return asblogdataPostTagsShow(mapping, af, req, res);
	}

}
