/**
 ********************************************************************************
 *** ShowCommentsAction.java                                                  ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.action;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.asg.util.decorators.IAttributeDecorator;
import net.anotheria.asg.util.filter.DocumentFilter;
import net.anotheria.util.NumberUtils;
import net.anotheria.anoplass.api.util.paging.PagingControl;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.anotheria.maf.action.ActionForward;
import net.anotheria.maf.action.ActionMapping;
import net.anotheria.maf.bean.FormBean;
import net.anotheria.anosite.gen.asblogdata.data.Comment;
import net.anotheria.anosite.gen.asblogdata.bean.CommentListItemBean;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.util.slicer.Slice;
import net.anotheria.util.slicer.Segment;
import net.anotheria.asg.data.LockableObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.MarkerFactory;
import net.anotheria.anosite.gen.asblogdata.bean.CommentListItemBeanSortType;
import net.anotheria.util.sorter.Sorter;
import net.anotheria.util.sorter.QuickSorter;

public class ShowCommentsAction extends BaseCommentAction{

	// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateShowAction

	public static final String SA_SORT_TYPE = SA_SORT_TYPE_PREFIX+"Comment";
	public static final String SA_FILTER = SA_FILTER_PREFIX+"Comment";
	private static final List<String> ITEMS_ON_PAGE_SELECTOR = java.util.Arrays.asList(new String[]{"5","10","20","25","50","100","500","1000"});
	private static Logger log = LoggerFactory.getLogger(ShowCommentsAction.class);
	private Sorter<CommentListItemBean> sorter;

	private IAttributeDecorator idDecorator;
	private IAttributeDecorator createdDecorator;
	private IAttributeDecorator commentatorDecorator;
	private IAttributeDecorator contentDecorator;

	public ShowCommentsAction(){
		super();
		sorter = new QuickSorter<CommentListItemBean>();
		try{ 
			idDecorator = (IAttributeDecorator)Class.forName("net.anotheria.asg.util.decorators.IDItoADecorator").newInstance();
			createdDecorator = (IAttributeDecorator)Class.forName("net.anotheria.anosite.decorator.DateDecorator").newInstance();
			commentatorDecorator = (IAttributeDecorator)Class.forName("net.anotheria.asg.util.decorators.EditLinkDecorator").newInstance();
			contentDecorator = (IAttributeDecorator)Class.forName("net.anotheria.asg.util.decorators.EditLinkDecorator").newInstance();
		} catch(Exception e){
			log.error(MarkerFactory.getMarker("FATAL"), "Couldn't instantiate decorator:", e);
		}
	}
	public ActionForward anoDocExecute(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		int sortMethod = CommentListItemBeanSortType.SORT_BY_DEFAULT;
		boolean sortOrder = CommentListItemBeanSortType.ASC;
		boolean sortParamSet = false;

		try{
			sortMethod = getIntParameter(req, PARAM_SORT_TYPE);
			sortParamSet = true;
		}catch(Exception ignored){}

		try{
			String sortMethodName = getStringParameter(req, PARAM_SORT_TYPE_NAME);
			sortMethod = CommentListItemBeanSortType.name2method(sortMethodName);
			sortParamSet = true;
		}catch(Exception ignored){}

		try{
			sortOrder = getStringParameter(req, PARAM_SORT_ORDER).equals("ASC") ? 
				CommentListItemBeanSortType.ASC : CommentListItemBeanSortType.DESC;
		}catch(Exception ignored){}

		CommentListItemBeanSortType sortType = null;
		if (sortParamSet){
			sortType = new CommentListItemBeanSortType(sortMethod, sortOrder);
			addBeanToSession(req, SA_SORT_TYPE, sortType);
		}else{
			sortType = (CommentListItemBeanSortType)getBeanFromSession(req, SA_SORT_TYPE);
			if (sortType==null)
				sortType = new CommentListItemBeanSortType(sortMethod, sortOrder);
		}
		req.setAttribute("currentSortCode", sortType.getMethodAndOrderCode());

		List<Comment> comments = getASBlogDataService().getComments();
		List<CommentListItemBean> beans = new ArrayList<CommentListItemBean>(comments.size());
		for (Comment comment : comments){
			checkComments(comment, req);
			CommentListItemBean bean = makeCommentListItemBean(comment);
			beans.add(bean);
		}

		beans = sorter.sort(beans, sortType);
		// paging
		int pageNumber = 1;
		try{
			pageNumber = Integer.parseInt(req.getParameter("pageNumber"));
		}catch(Exception ignored){}
		Integer lastItemsOnPage = (Integer)req.getSession().getAttribute("currentItemsOnPage");
		int itemsOnPage = lastItemsOnPage == null ? 20 : lastItemsOnPage;
		try{
			itemsOnPage = Integer.parseInt(req.getParameter("itemsOnPage"));
		}catch(Exception ignored){}
		Slice<CommentListItemBean> slice = Slicer.slice(new Segment(pageNumber, itemsOnPage), beans);
		beans = slice.getSliceData();

		// prepare paging control
		PagingControl pagingControl = new PagingControl(slice.getCurrentSlice(), slice.getElementsPerSlice(), slice.getTotalNumberOfItems());
		// end paging control
		req.setAttribute("pagingControl", pagingControl);
		req.setAttribute("currentpage", pageNumber);
		req.setAttribute("currentItemsOnPage", itemsOnPage);
		req.getSession().setAttribute("currentItemsOnPage", itemsOnPage);
		req.setAttribute("PagingSelector", ITEMS_ON_PAGE_SELECTOR);

		addBeanToRequest(req, "comments", beans);
		return mapping.findForward("success");
	}

	protected CommentListItemBean makeCommentListItemBean(Comment comment) {
		CommentListItemBean bean = new CommentListItemBean();
		bean.setPlainId(comment.getId());
		bean.setIdForSorting(comment.getId());
		bean.setId(idDecorator.decorate(comment, "id", "3"));
		bean.setCreatedForSorting(comment.getCreated());
		bean.setCreated(createdDecorator.decorate(comment, "created", "null"));
		bean.setCommentatorForSorting(comment.getCommentator());
		bean.setCommentator(commentatorDecorator.decorate(comment, "commentator", "null"));
		bean.setContentForSorting(comment.getContent());
		bean.setContent(contentDecorator.decorate(comment, "content", "null"));
		bean.setLocked(((LockableObject)comment).isLocked());
		bean.setLockerId(((LockableObject)comment).getLockerId());
		bean.setLockingTime(NumberUtils.makeISO8601TimestampString(((LockableObject)comment).getLockingTime()) + " till: " + NumberUtils.makeISO8601TimestampString(((LockableObject)comment).getLockingTime() + getLockingTimeout()));
		bean.setDocumentLastUpdateTimestamp(NumberUtils.makeISO8601TimestampString(comment.getLastUpdateTimestamp()));
		return bean;
	}
}
