/**
 ********************************************************************************
 *** PostDocument.java                                                        ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.data;

import net.anotheria.asg.data.AbstractASGDocument;
import java.util.List;
import net.anotheria.anodoc.data.StringProperty;
import net.anotheria.util.crypt.MD5Util;
import net.anotheria.util.sorter.IComparable;
import net.anotheria.util.BasicComparable;

public class PostDocument extends AbstractASGDocument implements Post, IComparable{

	public PostDocument(String id){
		super(id);
	}

	public PostDocument(PostDocument toClone){
		super(toClone);
	}

	PostDocument(PostBuilder builder){
		super("");
		setCreated(builder.created);
		setUpdated(builder.updated);
		setName(builder.name);
		setBlogger(builder.blogger);
		setContent(builder.content);
		setComments(builder.comments);
		setTags(builder.tags);
	}

	public long getCreated(){
		return getLong(PROP_CREATED);
	}

	public void setCreated(long value){
		setLong(PROP_CREATED, value);
	}

	public long getUpdated(){
		return getLong(PROP_UPDATED);
	}

	public void setUpdated(long value){
		setLong(PROP_UPDATED, value);
	}

	public String getName(){
		return getString(PROP_NAME);
	}

	public void setName(String value){
		setString(PROP_NAME, value);
	}

	public String getBlogger(){
		return getString(PROP_BLOGGER);
	}

	public void setBlogger(String value){
		setString(PROP_BLOGGER, value);
	}

	public String getContent(){
		return getString(PROP_CONTENT);
	}

	public void setContent(String value){
		setString(PROP_CONTENT, value);
	}

	public List<String> getComments(){
		return copyToStringList(getList(PROP_COMMENTS));
	}

	public void setComments(List<String> value){
		setList(PROP_COMMENTS, copyFromStringList(value));
	}

	public List<String> getTags(){
		return copyToStringList(getList(PROP_TAGS));
	}

	public void setTags(List<String> value){
		setList(PROP_TAGS, copyFromStringList(value));
	}


	public String toString(){
		String ret = "Post ";
		ret += "["+getId()+"] ";
		ret += "created: "+getCreated();
		ret += ", ";
		ret += "updated: "+getUpdated();
		ret += ", ";
		ret += "name: "+getName();
		ret += ", ";
		ret += "blogger: "+getBlogger();
		ret += ", ";
		ret += "content: "+getContent();
		ret += ", ";
		ret += "comments: "+getComments();
		ret += ", ";
		ret += "tags: "+getTags();
		return ret;
	}

	public int getCommentsSize(){
		return getList(PROP_COMMENTS).size();
	}

	public void addCommentsElement(String postCommentLink){
		getListPropertyAnyCase(PROP_COMMENTS).add(new StringProperty("" + postCommentLink, postCommentLink));
	} //method

	public void removeCommentsElement(int index){
		getListProperty(PROP_COMMENTS).remove(index);
	} //method

	public void swapCommentsElement(int index1, int index2){
		String tmp1, tmp2;
		tmp1 = ((StringProperty)getList(PROP_COMMENTS).get(index1)).getString();
		tmp2 = ((StringProperty)getList(PROP_COMMENTS).get(index2)).getString();
		((StringProperty)getList(PROP_COMMENTS).get(index1)).setString(tmp2);
		((StringProperty)getList(PROP_COMMENTS).get(index2)).setString(tmp1);
	} //method

	public String getCommentsElement(int index){
		StringProperty p = (StringProperty)getList(PROP_COMMENTS).get(index);
		return p.getString();
	} //method

	public int getTagsSize(){
		return getList(PROP_TAGS).size();
	}

	public void addTagsElement(String postTagLink){
		getListPropertyAnyCase(PROP_TAGS).add(new StringProperty("" + postTagLink, postTagLink));
	} //method

	public void removeTagsElement(int index){
		getListProperty(PROP_TAGS).remove(index);
	} //method

	public void swapTagsElement(int index1, int index2){
		String tmp1, tmp2;
		tmp1 = ((StringProperty)getList(PROP_TAGS).get(index1)).getString();
		tmp2 = ((StringProperty)getList(PROP_TAGS).get(index2)).getString();
		((StringProperty)getList(PROP_TAGS).get(index1)).setString(tmp2);
		((StringProperty)getList(PROP_TAGS).get(index2)).setString(tmp1);
	} //method

	public String getTagsElement(int index){
		StringProperty p = (StringProperty)getList(PROP_TAGS).get(index);
		return p.getString();
	} //method


	public int compareTo(Post comparable){
		return compareTo(comparable, PostSortType.SORT_BY_DEFAULT);
	}

	public int compareTo(IComparable anotherComparable, int method){
		PostDocument anotherDoc = (PostDocument) anotherComparable;
		switch(method){
			case PostSortType.SORT_BY_ID:
				return BasicComparable.compareString(getId(), anotherDoc.getId());
			case PostSortType.SORT_BY_CREATED:
				return BasicComparable.compareLong(getCreated(), anotherDoc.getCreated());
			case PostSortType.SORT_BY_UPDATED:
				return BasicComparable.compareLong(getUpdated(), anotherDoc.getUpdated());
			case PostSortType.SORT_BY_NAME:
				return BasicComparable.compareString(getName(), anotherDoc.getName());
			case PostSortType.SORT_BY_BLOGGER:
				return BasicComparable.compareString(getBlogger(), anotherDoc.getBlogger());
			case PostSortType.SORT_BY_CONTENT:
				return BasicComparable.compareString(getContent(), anotherDoc.getContent());
			default:
				throw new RuntimeException("Sort method "+method+" is not supported.");
		}
	}

	public String getDefinedName(){
		return "Post";
	}

	public String getDefinedParentName(){
		return "ASBlogData";
	}

	public String getFootprint(){
		StringBuilder footprint = new StringBuilder();
		footprint.append(getCreated());
		footprint.append(getUpdated());
		footprint.append(getName());
		footprint.append(getBlogger());
		footprint.append(getContent());
		footprint.append(getComments());
		footprint.append(getTags());
		return MD5Util.getMD5Hash(footprint);
	}

	public boolean equals(Object o){
		return o == this || ((o instanceof PostDocument) && ((PostDocument)o).getId().equals(getId()));
	}
}
