/**
 ********************************************************************************
 *** ASBlogDataServiceImpl.java                                               ***
 *** The implementation of the IASBlogDataService.                            ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.service;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.anodoc.data.Module;
import net.anotheria.anodoc.data.Property;
import net.anotheria.anodoc.data.NoSuchPropertyException;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.util.slicer.Segment;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.anosite.gen.asblogdata.data.ModuleASBlogData;
import net.anotheria.anosite.gen.shared.service.BasicCMSService;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.asg.util.listener.IModuleListener;
import net.anotheria.anosite.gen.asblogdata.data.Post;
import net.anotheria.anosite.gen.asblogdata.data.PostXMLHelper;
import net.anotheria.anosite.gen.asblogdata.data.PostDocument;
import net.anotheria.anosite.gen.asblogdata.data.Comment;
import net.anotheria.anosite.gen.asblogdata.data.CommentXMLHelper;
import net.anotheria.anosite.gen.asblogdata.data.CommentDocument;
import net.anotheria.anosite.gen.asblogdata.data.Tag;
import net.anotheria.anosite.gen.asblogdata.data.TagXMLHelper;
import net.anotheria.anosite.gen.asblogdata.data.TagDocument;

public class ASBlogDataServiceImpl extends BasicCMSService implements IASBlogDataService, IModuleListener{

	// Generated by: class net.anotheria.asg.generator.model.docs.CMSBasedServiceGenerator.generateImplementation

	private static ASBlogDataServiceImpl instance;

	private ASBlogDataServiceImpl(){
		addServiceListener(new net.anotheria.anosite.cms.listener.CRUDLogListener());
		addServiceListener(new net.anotheria.anosite.cms.listener.BlogListener());
		addModuleListener(ModuleASBlogData.MODULE_ID, this);
	}

	static final ASBlogDataServiceImpl getInstance(){
		if (instance==null){
			instance = new ASBlogDataServiceImpl();
		}
		return instance;
	}

	private ModuleASBlogData _getModuleASBlogData(){
		return (ModuleASBlogData) getModule(ModuleASBlogData.MODULE_ID);
	}

	@Override
	public void moduleLoaded(Module module){
		firePersistenceChangedEvent();
	}

	@SuppressWarnings("unchecked")
	public List<Post> getPosts(){
		List posts = new ArrayList();
		posts.addAll(_getModuleASBlogData().getPosts());
		return posts;
	}

	public List<Post> getPosts(SortType sortType){
		return StaticQuickSorter.sort(getPosts(), sortType);
	}

	/**
	 * Returns the Post objects with the specified ids.
	 */
	public List<Post> getPosts(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Post>(0);
		List<Post> all = getPosts();
		List<Post> ret = new ArrayList<Post>();
		for (Post post : all){
			if(ids.contains(post.getId())){
				ret.add(post);
			}
		}
		return ret;
	}

	/**
	 * Returns the Post objects with the specified ids, sorted by given sorttype.
	 */
	public List<Post> getPosts(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPosts(ids), sortType);
	}

	public void deletePost(Post post){
		deletePost(post.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(post);
		}
	}

	public void deletePost(String id){
		ModuleASBlogData module = _getModuleASBlogData();
		Post varValue = hasServiceListeners()?module.getPost(id):null;
		module.deletePost(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePosts(List<Post> list){
		ModuleASBlogData module = _getModuleASBlogData();
		for (Post post : list){
			module.deletePost(post.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Post getPost(String id){
		return _getModuleASBlogData().getPost(id);
	}

	public Post importPost(Post post){
		ModuleASBlogData module = _getModuleASBlogData();
		module.importPost((PostDocument)post);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(post);
		}
		return post;
	}

	public List<Post> importPosts(List<Post> list){
		ModuleASBlogData module = _getModuleASBlogData();
		List<Post> ret = new ArrayList<Post>();
		for (Post post : list){
			Post imported = module.importPost((PostDocument)post);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Post post : ret)
				fireObjectImportedEvent(post);
		}
		return ret;
	}

	public Post createPost(Post post){
		ModuleASBlogData module = _getModuleASBlogData();
		module.createPost((PostDocument)post);
		updateModule(module);
		fireObjectCreatedEvent(post);
		return post;
	}

	/**
	 * Creates multiple new Post objects.
	 * Returns the created versions.
	 */
	public List<Post> createPosts(List<Post> list){;
		ModuleASBlogData module = _getModuleASBlogData();
		List<Post> ret = new ArrayList<Post>();
		for (Post post : list){
			Post created = module.createPost((PostDocument)post);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Post post : ret)
				fireObjectCreatedEvent(post);
		}
		return ret;
	}

	public Post updatePost(Post post){
		Post oldVersion = null;
		ModuleASBlogData module = _getModuleASBlogData();
		if (hasServiceListeners())
			oldVersion = module.getPost(post.getId());
		module.updatePost((PostDocument)post);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, post);
		}
		return post;
	}

	public List<Post> updatePosts(List<Post> list){
		List<Post> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Post>(list.size());
		ModuleASBlogData module = _getModuleASBlogData();
		for (Post post : list){
			if (oldList!=null)
				oldList.add(module.getPost(post.getId()));
			module.updatePost((PostDocument)post);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Post> getPostsByProperty(String propertyName, Object value){
		List<Post> allPosts = getPosts();
		List<Post> ret = new ArrayList<Post>();
		for (int i=0; i<allPosts.size(); i++){
			Post post = allPosts.get(i);
			try{
				Property property = ((PostDocument)post).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(post);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(post);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(post);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Post> getPostsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPostsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Posts
	 */
	public QueryResult executeQueryOnPosts(DocumentQuery query){
		List<Post> allPosts = getPosts();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPosts.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPosts.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Post objects, where property matches.
	 */
	public List<Post> getPostsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Post> ret = new ArrayList<Post>();
		List<Post> src = getPosts();
		for ( Post post : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(post.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(post);
		}
		return ret;
	}

	/**
	 * Returns all Post objects, where property matches, sorted
	 */
	public List<Post> getPostsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPostsByProperty(property), sortType);
	}

	/**
	 * Returns Post objects count.
	 */
	public int getPostsCount() {
		return _getModuleASBlogData().getPosts().size();
	}

	/**
	 * Returns Post objects segment.
	 */
	public List<Post> getPosts(Segment aSegment) {
		return Slicer.slice(aSegment, getPosts()).getSliceData();
	}

	/**
	 * Returns Post objects segment, where property matched.
	 */
	public List<Post> getPostsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Post> ret = new ArrayList<Post>();
		List<Post> src = getPosts();
		for (Post post : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(post.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(post);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Post objects segment, where property matched, sorted.
	 */
	public List<Post> getPostsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPostsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Comment> getComments(){
		List comments = new ArrayList();
		comments.addAll(_getModuleASBlogData().getComments());
		return comments;
	}

	public List<Comment> getComments(SortType sortType){
		return StaticQuickSorter.sort(getComments(), sortType);
	}

	/**
	 * Returns the Comment objects with the specified ids.
	 */
	public List<Comment> getComments(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Comment>(0);
		List<Comment> all = getComments();
		List<Comment> ret = new ArrayList<Comment>();
		for (Comment comment : all){
			if(ids.contains(comment.getId())){
				ret.add(comment);
			}
		}
		return ret;
	}

	/**
	 * Returns the Comment objects with the specified ids, sorted by given sorttype.
	 */
	public List<Comment> getComments(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getComments(ids), sortType);
	}

	public void deleteComment(Comment comment){
		deleteComment(comment.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(comment);
		}
	}

	public void deleteComment(String id){
		ModuleASBlogData module = _getModuleASBlogData();
		Comment varValue = hasServiceListeners()?module.getComment(id):null;
		module.deleteComment(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteComments(List<Comment> list){
		ModuleASBlogData module = _getModuleASBlogData();
		for (Comment comment : list){
			module.deleteComment(comment.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Comment getComment(String id){
		return _getModuleASBlogData().getComment(id);
	}

	public Comment importComment(Comment comment){
		ModuleASBlogData module = _getModuleASBlogData();
		module.importComment((CommentDocument)comment);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(comment);
		}
		return comment;
	}

	public List<Comment> importComments(List<Comment> list){
		ModuleASBlogData module = _getModuleASBlogData();
		List<Comment> ret = new ArrayList<Comment>();
		for (Comment comment : list){
			Comment imported = module.importComment((CommentDocument)comment);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Comment comment : ret)
				fireObjectImportedEvent(comment);
		}
		return ret;
	}

	public Comment createComment(Comment comment){
		ModuleASBlogData module = _getModuleASBlogData();
		module.createComment((CommentDocument)comment);
		updateModule(module);
		fireObjectCreatedEvent(comment);
		return comment;
	}

	/**
	 * Creates multiple new Comment objects.
	 * Returns the created versions.
	 */
	public List<Comment> createComments(List<Comment> list){;
		ModuleASBlogData module = _getModuleASBlogData();
		List<Comment> ret = new ArrayList<Comment>();
		for (Comment comment : list){
			Comment created = module.createComment((CommentDocument)comment);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Comment comment : ret)
				fireObjectCreatedEvent(comment);
		}
		return ret;
	}

	public Comment updateComment(Comment comment){
		Comment oldVersion = null;
		ModuleASBlogData module = _getModuleASBlogData();
		if (hasServiceListeners())
			oldVersion = module.getComment(comment.getId());
		module.updateComment((CommentDocument)comment);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, comment);
		}
		return comment;
	}

	public List<Comment> updateComments(List<Comment> list){
		List<Comment> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Comment>(list.size());
		ModuleASBlogData module = _getModuleASBlogData();
		for (Comment comment : list){
			if (oldList!=null)
				oldList.add(module.getComment(comment.getId()));
			module.updateComment((CommentDocument)comment);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Comment> getCommentsByProperty(String propertyName, Object value){
		List<Comment> allComments = getComments();
		List<Comment> ret = new ArrayList<Comment>();
		for (int i=0; i<allComments.size(); i++){
			Comment comment = allComments.get(i);
			try{
				Property property = ((CommentDocument)comment).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(comment);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(comment);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(comment);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Comment> getCommentsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getCommentsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Comments
	 */
	public QueryResult executeQueryOnComments(DocumentQuery query){
		List<Comment> allComments = getComments();
		QueryResult result = new QueryResult();
		for (int i=0; i<allComments.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allComments.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Comment objects, where property matches.
	 */
	public List<Comment> getCommentsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Comment> ret = new ArrayList<Comment>();
		List<Comment> src = getComments();
		for ( Comment comment : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(comment.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(comment);
		}
		return ret;
	}

	/**
	 * Returns all Comment objects, where property matches, sorted
	 */
	public List<Comment> getCommentsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getCommentsByProperty(property), sortType);
	}

	/**
	 * Returns Comment objects count.
	 */
	public int getCommentsCount() {
		return _getModuleASBlogData().getComments().size();
	}

	/**
	 * Returns Comment objects segment.
	 */
	public List<Comment> getComments(Segment aSegment) {
		return Slicer.slice(aSegment, getComments()).getSliceData();
	}

	/**
	 * Returns Comment objects segment, where property matched.
	 */
	public List<Comment> getCommentsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Comment> ret = new ArrayList<Comment>();
		List<Comment> src = getComments();
		for (Comment comment : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(comment.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(comment);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Comment objects segment, where property matched, sorted.
	 */
	public List<Comment> getCommentsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getCommentsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Tag> getTags(){
		List tags = new ArrayList();
		tags.addAll(_getModuleASBlogData().getTags());
		return tags;
	}

	public List<Tag> getTags(SortType sortType){
		return StaticQuickSorter.sort(getTags(), sortType);
	}

	/**
	 * Returns the Tag objects with the specified ids.
	 */
	public List<Tag> getTags(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Tag>(0);
		List<Tag> all = getTags();
		List<Tag> ret = new ArrayList<Tag>();
		for (Tag tag : all){
			if(ids.contains(tag.getId())){
				ret.add(tag);
			}
		}
		return ret;
	}

	/**
	 * Returns the Tag objects with the specified ids, sorted by given sorttype.
	 */
	public List<Tag> getTags(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getTags(ids), sortType);
	}

	public void deleteTag(Tag tag){
		deleteTag(tag.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(tag);
		}
	}

	public void deleteTag(String id){
		ModuleASBlogData module = _getModuleASBlogData();
		Tag varValue = hasServiceListeners()?module.getTag(id):null;
		module.deleteTag(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteTags(List<Tag> list){
		ModuleASBlogData module = _getModuleASBlogData();
		for (Tag tag : list){
			module.deleteTag(tag.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Tag getTag(String id){
		return _getModuleASBlogData().getTag(id);
	}

	public Tag importTag(Tag tag){
		ModuleASBlogData module = _getModuleASBlogData();
		module.importTag((TagDocument)tag);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(tag);
		}
		return tag;
	}

	public List<Tag> importTags(List<Tag> list){
		ModuleASBlogData module = _getModuleASBlogData();
		List<Tag> ret = new ArrayList<Tag>();
		for (Tag tag : list){
			Tag imported = module.importTag((TagDocument)tag);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Tag tag : ret)
				fireObjectImportedEvent(tag);
		}
		return ret;
	}

	public Tag createTag(Tag tag){
		ModuleASBlogData module = _getModuleASBlogData();
		module.createTag((TagDocument)tag);
		updateModule(module);
		fireObjectCreatedEvent(tag);
		return tag;
	}

	/**
	 * Creates multiple new Tag objects.
	 * Returns the created versions.
	 */
	public List<Tag> createTags(List<Tag> list){;
		ModuleASBlogData module = _getModuleASBlogData();
		List<Tag> ret = new ArrayList<Tag>();
		for (Tag tag : list){
			Tag created = module.createTag((TagDocument)tag);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Tag tag : ret)
				fireObjectCreatedEvent(tag);
		}
		return ret;
	}

	public Tag updateTag(Tag tag){
		Tag oldVersion = null;
		ModuleASBlogData module = _getModuleASBlogData();
		if (hasServiceListeners())
			oldVersion = module.getTag(tag.getId());
		module.updateTag((TagDocument)tag);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, tag);
		}
		return tag;
	}

	public List<Tag> updateTags(List<Tag> list){
		List<Tag> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Tag>(list.size());
		ModuleASBlogData module = _getModuleASBlogData();
		for (Tag tag : list){
			if (oldList!=null)
				oldList.add(module.getTag(tag.getId()));
			module.updateTag((TagDocument)tag);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Tag> getTagsByProperty(String propertyName, Object value){
		List<Tag> allTags = getTags();
		List<Tag> ret = new ArrayList<Tag>();
		for (int i=0; i<allTags.size(); i++){
			Tag tag = allTags.get(i);
			try{
				Property property = ((TagDocument)tag).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(tag);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(tag);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(tag);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Tag> getTagsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getTagsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Tags
	 */
	public QueryResult executeQueryOnTags(DocumentQuery query){
		List<Tag> allTags = getTags();
		QueryResult result = new QueryResult();
		for (int i=0; i<allTags.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allTags.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Tag objects, where property matches.
	 */
	public List<Tag> getTagsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Tag> ret = new ArrayList<Tag>();
		List<Tag> src = getTags();
		for ( Tag tag : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(tag.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(tag);
		}
		return ret;
	}

	/**
	 * Returns all Tag objects, where property matches, sorted
	 */
	public List<Tag> getTagsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getTagsByProperty(property), sortType);
	}

	/**
	 * Returns Tag objects count.
	 */
	public int getTagsCount() {
		return _getModuleASBlogData().getTags().size();
	}

	/**
	 * Returns Tag objects segment.
	 */
	public List<Tag> getTags(Segment aSegment) {
		return Slicer.slice(aSegment, getTags()).getSliceData();
	}

	/**
	 * Returns Tag objects segment, where property matched.
	 */
	public List<Tag> getTagsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Tag> ret = new ArrayList<Tag>();
		List<Tag> src = getTags();
		for (Tag tag : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(tag.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(tag);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Tag objects segment, where property matched, sorted.
	 */
	public List<Tag> getTagsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getTagsByProperty(aSegment, aProperty), aSortType);
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query){
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnPosts(query).getEntries());
		ret.add(executeQueryOnComments(query).getEntries());
		ret.add(executeQueryOnTags(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects


	public XMLNode exportPostsToXML(){;
		XMLNode ret = new XMLNode("Posts");
		List<Post> list = getPosts();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Post object : list)
			ret.addChildNode(PostXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPostsToXML(List<Post> list){;
		XMLNode ret = new XMLNode("Posts");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Post object : list)
			ret.addChildNode(PostXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportCommentsToXML(){;
		XMLNode ret = new XMLNode("Comments");
		List<Comment> list = getComments();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Comment object : list)
			ret.addChildNode(CommentXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportCommentsToXML(List<Comment> list){;
		XMLNode ret = new XMLNode("Comments");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Comment object : list)
			ret.addChildNode(CommentXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportTagsToXML(){;
		XMLNode ret = new XMLNode("Tags");
		List<Tag> list = getTags();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Tag object : list)
			ret.addChildNode(TagXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportTagsToXML(List<Tag> list){;
		XMLNode ret = new XMLNode("Tags");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Tag object : list)
			ret.addChildNode(TagXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("ASBlogData");

		ret.addChildNode(exportPostsToXML());
		ret.addChildNode(exportCommentsToXML());
		ret.addChildNode(exportTagsToXML());

		return ret;
	}
}
