/**
 ********************************************************************************
 *** IASBlogDataService.java                                                  ***
 *** Generator: net.anotheria.asg.generator.model.ServiceGenerator            ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asblogdata.service;

import java.util.List;
import net.anotheria.util.sorter.SortType;
import net.anotheria.anosite.gen.asblogdata.data.Post;
import net.anotheria.anosite.gen.asblogdata.data.Comment;
import net.anotheria.anosite.gen.asblogdata.data.Tag;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.slicer.Segment;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.asg.service.ASGService;

public interface IASBlogDataService extends ASGService{

// Generated by: class net.anotheria.asg.generator.model.ServiceGenerator.generateInterface

	/**
	 * Returns all Posts objects stored.
	 */
	public List<Post> getPosts() throws ASBlogDataServiceException;

	/**
	 * Returns all Posts objects sorted by given sortType.
	 */
	public List<Post> getPosts(SortType sortType) throws ASBlogDataServiceException;

	/**
	 * Deletes a Post object by id.
	 */
	public void deletePost(String id) throws ASBlogDataServiceException;

	/**
	 * Deletes a Post object.
	 */
	public void deletePost(Post post) throws ASBlogDataServiceException;

	/**
	 * Deletes multiple Post object.
	 */
	public void deletePosts(List<Post> list) throws ASBlogDataServiceException;

	/**
	 * Returns the Post object with the specified id.
	 */
	public Post getPost(String id) throws ASBlogDataServiceException;

	/**
	 * Imports a new Post object.
	 * Returns the created version.
	 */
	public Post importPost(Post post) throws ASBlogDataServiceException;

	/**
	 * Imports multiple new  Post object.
	 * Returns the created versions.
	 */
	public List<Post> importPosts(List<Post> list) throws ASBlogDataServiceException;

	/**
	 * Creates a new Post object.
	 * Returns the created version.
	 */
	public Post createPost(Post post) throws ASBlogDataServiceException;

	/**
	 * Creates multiple new Post objects.
	 * Returns the created versions.
	 */
	public List<Post> createPosts(List<Post> list) throws ASBlogDataServiceException;

	/**
	 * Updates a Post object.
	 * Returns the updated version.
	 */
	public Post updatePost(Post post) throws ASBlogDataServiceException;

	/**
	 * Updates mutiple Post objects.
	 * Returns the updated versions.
	 */
	public List<Post> updatePosts(List<Post> list) throws ASBlogDataServiceException;

	/**
	 * Returns all Post objects, where property with given name equals object.
	 */
	public List<Post> getPostsByProperty(String propertyName, Object value) throws ASBlogDataServiceException;

	/**
	 * Returns all Post objects, where property with given name equals object, sorted
	 */
	public List<Post> getPostsByProperty(String propertyName, Object value, SortType sortType) throws ASBlogDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnPosts(DocumentQuery query) throws ASBlogDataServiceException;

	/**
	 * Returns all Post objects, where property matches.
	 */
	public List<Post> getPostsByProperty(QueryProperty... property) throws ASBlogDataServiceException;

	/**
	 * Returns all Post objects, where property matches, sorted
	 */
	public List<Post> getPostsByProperty(SortType sortType, QueryProperty... property) throws ASBlogDataServiceException;

	/**
	 * Returns all Posts count.
	 */
	public int getPostsCount() throws ASBlogDataServiceException;

	/**
	 * Returns Posts objects segment.
	 */
	public List<Post> getPosts(Segment aSegment) throws ASBlogDataServiceException;

	/**
	 * Returns Post objects segment, where property matches.
	 */
	public List<Post> getPostsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASBlogDataServiceException;

	/**
	 * Returns Post objects segment, where property matches, sorted.
	 */
	public List<Post> getPostsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASBlogDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportPostsToXML(List<Post> listPosts)  throws ASBlogDataServiceException;
	/**
	 * Returns all Comments objects stored.
	 */
	public List<Comment> getComments() throws ASBlogDataServiceException;

	/**
	 * Returns all Comments objects sorted by given sortType.
	 */
	public List<Comment> getComments(SortType sortType) throws ASBlogDataServiceException;

	/**
	 * Deletes a Comment object by id.
	 */
	public void deleteComment(String id) throws ASBlogDataServiceException;

	/**
	 * Deletes a Comment object.
	 */
	public void deleteComment(Comment comment) throws ASBlogDataServiceException;

	/**
	 * Deletes multiple Comment object.
	 */
	public void deleteComments(List<Comment> list) throws ASBlogDataServiceException;

	/**
	 * Returns the Comment object with the specified id.
	 */
	public Comment getComment(String id) throws ASBlogDataServiceException;

	/**
	 * Imports a new Comment object.
	 * Returns the created version.
	 */
	public Comment importComment(Comment comment) throws ASBlogDataServiceException;

	/**
	 * Imports multiple new  Comment object.
	 * Returns the created versions.
	 */
	public List<Comment> importComments(List<Comment> list) throws ASBlogDataServiceException;

	/**
	 * Creates a new Comment object.
	 * Returns the created version.
	 */
	public Comment createComment(Comment comment) throws ASBlogDataServiceException;

	/**
	 * Creates multiple new Comment objects.
	 * Returns the created versions.
	 */
	public List<Comment> createComments(List<Comment> list) throws ASBlogDataServiceException;

	/**
	 * Updates a Comment object.
	 * Returns the updated version.
	 */
	public Comment updateComment(Comment comment) throws ASBlogDataServiceException;

	/**
	 * Updates mutiple Comment objects.
	 * Returns the updated versions.
	 */
	public List<Comment> updateComments(List<Comment> list) throws ASBlogDataServiceException;

	/**
	 * Returns all Comment objects, where property with given name equals object.
	 */
	public List<Comment> getCommentsByProperty(String propertyName, Object value) throws ASBlogDataServiceException;

	/**
	 * Returns all Comment objects, where property with given name equals object, sorted
	 */
	public List<Comment> getCommentsByProperty(String propertyName, Object value, SortType sortType) throws ASBlogDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnComments(DocumentQuery query) throws ASBlogDataServiceException;

	/**
	 * Returns all Comment objects, where property matches.
	 */
	public List<Comment> getCommentsByProperty(QueryProperty... property) throws ASBlogDataServiceException;

	/**
	 * Returns all Comment objects, where property matches, sorted
	 */
	public List<Comment> getCommentsByProperty(SortType sortType, QueryProperty... property) throws ASBlogDataServiceException;

	/**
	 * Returns all Comments count.
	 */
	public int getCommentsCount() throws ASBlogDataServiceException;

	/**
	 * Returns Comments objects segment.
	 */
	public List<Comment> getComments(Segment aSegment) throws ASBlogDataServiceException;

	/**
	 * Returns Comment objects segment, where property matches.
	 */
	public List<Comment> getCommentsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASBlogDataServiceException;

	/**
	 * Returns Comment objects segment, where property matches, sorted.
	 */
	public List<Comment> getCommentsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASBlogDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportCommentsToXML(List<Comment> listComments)  throws ASBlogDataServiceException;
	/**
	 * Returns all Tags objects stored.
	 */
	public List<Tag> getTags() throws ASBlogDataServiceException;

	/**
	 * Returns all Tags objects sorted by given sortType.
	 */
	public List<Tag> getTags(SortType sortType) throws ASBlogDataServiceException;

	/**
	 * Deletes a Tag object by id.
	 */
	public void deleteTag(String id) throws ASBlogDataServiceException;

	/**
	 * Deletes a Tag object.
	 */
	public void deleteTag(Tag tag) throws ASBlogDataServiceException;

	/**
	 * Deletes multiple Tag object.
	 */
	public void deleteTags(List<Tag> list) throws ASBlogDataServiceException;

	/**
	 * Returns the Tag object with the specified id.
	 */
	public Tag getTag(String id) throws ASBlogDataServiceException;

	/**
	 * Imports a new Tag object.
	 * Returns the created version.
	 */
	public Tag importTag(Tag tag) throws ASBlogDataServiceException;

	/**
	 * Imports multiple new  Tag object.
	 * Returns the created versions.
	 */
	public List<Tag> importTags(List<Tag> list) throws ASBlogDataServiceException;

	/**
	 * Creates a new Tag object.
	 * Returns the created version.
	 */
	public Tag createTag(Tag tag) throws ASBlogDataServiceException;

	/**
	 * Creates multiple new Tag objects.
	 * Returns the created versions.
	 */
	public List<Tag> createTags(List<Tag> list) throws ASBlogDataServiceException;

	/**
	 * Updates a Tag object.
	 * Returns the updated version.
	 */
	public Tag updateTag(Tag tag) throws ASBlogDataServiceException;

	/**
	 * Updates mutiple Tag objects.
	 * Returns the updated versions.
	 */
	public List<Tag> updateTags(List<Tag> list) throws ASBlogDataServiceException;

	/**
	 * Returns all Tag objects, where property with given name equals object.
	 */
	public List<Tag> getTagsByProperty(String propertyName, Object value) throws ASBlogDataServiceException;

	/**
	 * Returns all Tag objects, where property with given name equals object, sorted
	 */
	public List<Tag> getTagsByProperty(String propertyName, Object value, SortType sortType) throws ASBlogDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnTags(DocumentQuery query) throws ASBlogDataServiceException;

	/**
	 * Returns all Tag objects, where property matches.
	 */
	public List<Tag> getTagsByProperty(QueryProperty... property) throws ASBlogDataServiceException;

	/**
	 * Returns all Tag objects, where property matches, sorted
	 */
	public List<Tag> getTagsByProperty(SortType sortType, QueryProperty... property) throws ASBlogDataServiceException;

	/**
	 * Returns all Tags count.
	 */
	public int getTagsCount() throws ASBlogDataServiceException;

	/**
	 * Returns Tags objects segment.
	 */
	public List<Tag> getTags(Segment aSegment) throws ASBlogDataServiceException;

	/**
	 * Returns Tag objects segment, where property matches.
	 */
	public List<Tag> getTagsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASBlogDataServiceException;

	/**
	 * Returns Tag objects segment, where property matches, sorted.
	 */
	public List<Tag> getTagsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASBlogDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportTagsToXML(List<Tag> listTags)  throws ASBlogDataServiceException;
	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query) throws ASBlogDataServiceException;
	/**
	 * creates an xml element with all contained data.
	 */
	public XMLNode exportToXML() throws ASBlogDataServiceException;

}
