/**
 ********************************************************************************
 *** ASLayoutDataServiceImpl.java                                             ***
 *** The implementation of the IASLayoutDataService.                          ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.aslayoutdata.service;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.anodoc.data.Module;
import net.anotheria.anodoc.data.Property;
import net.anotheria.anodoc.data.NoSuchPropertyException;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.util.slicer.Segment;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.anosite.gen.aslayoutdata.data.ModuleASLayoutData;
import net.anotheria.anosite.gen.shared.service.BasicCMSService;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.asg.util.listener.IModuleListener;
import net.anotheria.anosite.gen.aslayoutdata.data.PageStyle;
import net.anotheria.anosite.gen.aslayoutdata.data.PageStyleXMLHelper;
import net.anotheria.anosite.gen.aslayoutdata.data.PageStyleDocument;
import net.anotheria.anosite.gen.aslayoutdata.data.PageLayout;
import net.anotheria.anosite.gen.aslayoutdata.data.PageLayoutXMLHelper;
import net.anotheria.anosite.gen.aslayoutdata.data.PageLayoutDocument;

public class ASLayoutDataServiceImpl extends BasicCMSService implements IASLayoutDataService, IModuleListener{

	// Generated by: class net.anotheria.asg.generator.model.docs.CMSBasedServiceGenerator.generateImplementation

	private static ASLayoutDataServiceImpl instance;

	private ASLayoutDataServiceImpl(){
		addServiceListener(new net.anotheria.anosite.cms.listener.CRUDLogListener());
		addModuleListener(ModuleASLayoutData.MODULE_ID, this);
	}

	static final ASLayoutDataServiceImpl getInstance(){
		if (instance==null){
			instance = new ASLayoutDataServiceImpl();
		}
		return instance;
	}

	private ModuleASLayoutData _getModuleASLayoutData(){
		return (ModuleASLayoutData) getModule(ModuleASLayoutData.MODULE_ID);
	}

	@Override
	public void moduleLoaded(Module module){
		firePersistenceChangedEvent();
	}

	@SuppressWarnings("unchecked")
	public List<PageStyle> getPageStyles(){
		List pagestyles = new ArrayList();
		pagestyles.addAll(_getModuleASLayoutData().getPageStyles());
		return pagestyles;
	}

	public List<PageStyle> getPageStyles(SortType sortType){
		return StaticQuickSorter.sort(getPageStyles(), sortType);
	}

	/**
	 * Returns the PageStyle objects with the specified ids.
	 */
	public List<PageStyle> getPageStyles(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<PageStyle>(0);
		List<PageStyle> all = getPageStyles();
		List<PageStyle> ret = new ArrayList<PageStyle>();
		for (PageStyle pagestyle : all){
			if(ids.contains(pagestyle.getId())){
				ret.add(pagestyle);
			}
		}
		return ret;
	}

	/**
	 * Returns the PageStyle objects with the specified ids, sorted by given sorttype.
	 */
	public List<PageStyle> getPageStyles(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPageStyles(ids), sortType);
	}

	public void deletePageStyle(PageStyle pagestyle){
		deletePageStyle(pagestyle.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(pagestyle);
		}
	}

	public void deletePageStyle(String id){
		ModuleASLayoutData module = _getModuleASLayoutData();
		PageStyle varValue = hasServiceListeners()?module.getPageStyle(id):null;
		module.deletePageStyle(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePageStyles(List<PageStyle> list){
		ModuleASLayoutData module = _getModuleASLayoutData();
		for (PageStyle pagestyle : list){
			module.deletePageStyle(pagestyle.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public PageStyle getPageStyle(String id){
		return _getModuleASLayoutData().getPageStyle(id);
	}

	public PageStyle importPageStyle(PageStyle pagestyle){
		ModuleASLayoutData module = _getModuleASLayoutData();
		module.importPageStyle((PageStyleDocument)pagestyle);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(pagestyle);
		}
		return pagestyle;
	}

	public List<PageStyle> importPageStyles(List<PageStyle> list){
		ModuleASLayoutData module = _getModuleASLayoutData();
		List<PageStyle> ret = new ArrayList<PageStyle>();
		for (PageStyle pagestyle : list){
			PageStyle imported = module.importPageStyle((PageStyleDocument)pagestyle);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageStyle pagestyle : ret)
				fireObjectImportedEvent(pagestyle);
		}
		return ret;
	}

	public PageStyle createPageStyle(PageStyle pagestyle){
		ModuleASLayoutData module = _getModuleASLayoutData();
		module.createPageStyle((PageStyleDocument)pagestyle);
		updateModule(module);
		fireObjectCreatedEvent(pagestyle);
		return pagestyle;
	}

	/**
	 * Creates multiple new PageStyle objects.
	 * Returns the created versions.
	 */
	public List<PageStyle> createPageStyles(List<PageStyle> list){;
		ModuleASLayoutData module = _getModuleASLayoutData();
		List<PageStyle> ret = new ArrayList<PageStyle>();
		for (PageStyle pagestyle : list){
			PageStyle created = module.createPageStyle((PageStyleDocument)pagestyle);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageStyle pagestyle : ret)
				fireObjectCreatedEvent(pagestyle);
		}
		return ret;
	}

	public PageStyle updatePageStyle(PageStyle pagestyle){
		PageStyle oldVersion = null;
		ModuleASLayoutData module = _getModuleASLayoutData();
		if (hasServiceListeners())
			oldVersion = module.getPageStyle(pagestyle.getId());
		module.updatePageStyle((PageStyleDocument)pagestyle);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, pagestyle);
		}
		return pagestyle;
	}

	public List<PageStyle> updatePageStyles(List<PageStyle> list){
		List<PageStyle> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<PageStyle>(list.size());
		ModuleASLayoutData module = _getModuleASLayoutData();
		for (PageStyle pagestyle : list){
			if (oldList!=null)
				oldList.add(module.getPageStyle(pagestyle.getId()));
			module.updatePageStyle((PageStyleDocument)pagestyle);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<PageStyle> getPageStylesByProperty(String propertyName, Object value){
		List<PageStyle> allPageStyles = getPageStyles();
		List<PageStyle> ret = new ArrayList<PageStyle>();
		for (int i=0; i<allPageStyles.size(); i++){
			PageStyle pagestyle = allPageStyles.get(i);
			try{
				Property property = ((PageStyleDocument)pagestyle).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(pagestyle);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(pagestyle);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(pagestyle);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<PageStyle> getPageStylesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPageStylesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on PageStyles
	 */
	public QueryResult executeQueryOnPageStyles(DocumentQuery query){
		List<PageStyle> allPageStyles = getPageStyles();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPageStyles.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPageStyles.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all PageStyle objects, where property matches.
	 */
	public List<PageStyle> getPageStylesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<PageStyle> ret = new ArrayList<PageStyle>();
		List<PageStyle> src = getPageStyles();
		for ( PageStyle pagestyle : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(pagestyle.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagestyle);
		}
		return ret;
	}

	/**
	 * Returns all PageStyle objects, where property matches, sorted
	 */
	public List<PageStyle> getPageStylesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPageStylesByProperty(property), sortType);
	}

	/**
	 * Returns PageStyle objects count.
	 */
	public int getPageStylesCount() {
		return _getModuleASLayoutData().getPageStyles().size();
	}

	/**
	 * Returns PageStyle objects segment.
	 */
	public List<PageStyle> getPageStyles(Segment aSegment) {
		return Slicer.slice(aSegment, getPageStyles()).getSliceData();
	}

	/**
	 * Returns PageStyle objects segment, where property matched.
	 */
	public List<PageStyle> getPageStylesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<PageStyle> ret = new ArrayList<PageStyle>();
		List<PageStyle> src = getPageStyles();
		for (PageStyle pagestyle : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(pagestyle.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagestyle);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns PageStyle objects segment, where property matched, sorted.
	 */
	public List<PageStyle> getPageStylesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPageStylesByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<PageLayout> getPageLayouts(){
		List pagelayouts = new ArrayList();
		pagelayouts.addAll(_getModuleASLayoutData().getPageLayouts());
		return pagelayouts;
	}

	public List<PageLayout> getPageLayouts(SortType sortType){
		return StaticQuickSorter.sort(getPageLayouts(), sortType);
	}

	/**
	 * Returns the PageLayout objects with the specified ids.
	 */
	public List<PageLayout> getPageLayouts(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<PageLayout>(0);
		List<PageLayout> all = getPageLayouts();
		List<PageLayout> ret = new ArrayList<PageLayout>();
		for (PageLayout pagelayout : all){
			if(ids.contains(pagelayout.getId())){
				ret.add(pagelayout);
			}
		}
		return ret;
	}

	/**
	 * Returns the PageLayout objects with the specified ids, sorted by given sorttype.
	 */
	public List<PageLayout> getPageLayouts(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPageLayouts(ids), sortType);
	}

	public void deletePageLayout(PageLayout pagelayout){
		deletePageLayout(pagelayout.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(pagelayout);
		}
	}

	public void deletePageLayout(String id){
		ModuleASLayoutData module = _getModuleASLayoutData();
		PageLayout varValue = hasServiceListeners()?module.getPageLayout(id):null;
		module.deletePageLayout(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePageLayouts(List<PageLayout> list){
		ModuleASLayoutData module = _getModuleASLayoutData();
		for (PageLayout pagelayout : list){
			module.deletePageLayout(pagelayout.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public PageLayout getPageLayout(String id){
		return _getModuleASLayoutData().getPageLayout(id);
	}

	public PageLayout importPageLayout(PageLayout pagelayout){
		ModuleASLayoutData module = _getModuleASLayoutData();
		module.importPageLayout((PageLayoutDocument)pagelayout);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(pagelayout);
		}
		return pagelayout;
	}

	public List<PageLayout> importPageLayouts(List<PageLayout> list){
		ModuleASLayoutData module = _getModuleASLayoutData();
		List<PageLayout> ret = new ArrayList<PageLayout>();
		for (PageLayout pagelayout : list){
			PageLayout imported = module.importPageLayout((PageLayoutDocument)pagelayout);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageLayout pagelayout : ret)
				fireObjectImportedEvent(pagelayout);
		}
		return ret;
	}

	public PageLayout createPageLayout(PageLayout pagelayout){
		ModuleASLayoutData module = _getModuleASLayoutData();
		module.createPageLayout((PageLayoutDocument)pagelayout);
		updateModule(module);
		fireObjectCreatedEvent(pagelayout);
		return pagelayout;
	}

	/**
	 * Creates multiple new PageLayout objects.
	 * Returns the created versions.
	 */
	public List<PageLayout> createPageLayouts(List<PageLayout> list){;
		ModuleASLayoutData module = _getModuleASLayoutData();
		List<PageLayout> ret = new ArrayList<PageLayout>();
		for (PageLayout pagelayout : list){
			PageLayout created = module.createPageLayout((PageLayoutDocument)pagelayout);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageLayout pagelayout : ret)
				fireObjectCreatedEvent(pagelayout);
		}
		return ret;
	}

	public PageLayout updatePageLayout(PageLayout pagelayout){
		PageLayout oldVersion = null;
		ModuleASLayoutData module = _getModuleASLayoutData();
		if (hasServiceListeners())
			oldVersion = module.getPageLayout(pagelayout.getId());
		module.updatePageLayout((PageLayoutDocument)pagelayout);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, pagelayout);
		}
		return pagelayout;
	}

	public List<PageLayout> updatePageLayouts(List<PageLayout> list){
		List<PageLayout> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<PageLayout>(list.size());
		ModuleASLayoutData module = _getModuleASLayoutData();
		for (PageLayout pagelayout : list){
			if (oldList!=null)
				oldList.add(module.getPageLayout(pagelayout.getId()));
			module.updatePageLayout((PageLayoutDocument)pagelayout);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<PageLayout> getPageLayoutsByProperty(String propertyName, Object value){
		List<PageLayout> allPageLayouts = getPageLayouts();
		List<PageLayout> ret = new ArrayList<PageLayout>();
		for (int i=0; i<allPageLayouts.size(); i++){
			PageLayout pagelayout = allPageLayouts.get(i);
			try{
				Property property = ((PageLayoutDocument)pagelayout).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(pagelayout);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(pagelayout);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(pagelayout);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<PageLayout> getPageLayoutsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPageLayoutsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on PageLayouts
	 */
	public QueryResult executeQueryOnPageLayouts(DocumentQuery query){
		List<PageLayout> allPageLayouts = getPageLayouts();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPageLayouts.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPageLayouts.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all PageLayout objects, where property matches.
	 */
	public List<PageLayout> getPageLayoutsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<PageLayout> ret = new ArrayList<PageLayout>();
		List<PageLayout> src = getPageLayouts();
		for ( PageLayout pagelayout : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(pagelayout.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagelayout);
		}
		return ret;
	}

	/**
	 * Returns all PageLayout objects, where property matches, sorted
	 */
	public List<PageLayout> getPageLayoutsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPageLayoutsByProperty(property), sortType);
	}

	/**
	 * Returns PageLayout objects count.
	 */
	public int getPageLayoutsCount() {
		return _getModuleASLayoutData().getPageLayouts().size();
	}

	/**
	 * Returns PageLayout objects segment.
	 */
	public List<PageLayout> getPageLayouts(Segment aSegment) {
		return Slicer.slice(aSegment, getPageLayouts()).getSliceData();
	}

	/**
	 * Returns PageLayout objects segment, where property matched.
	 */
	public List<PageLayout> getPageLayoutsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<PageLayout> ret = new ArrayList<PageLayout>();
		List<PageLayout> src = getPageLayouts();
		for (PageLayout pagelayout : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(pagelayout.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagelayout);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns PageLayout objects segment, where property matched, sorted.
	 */
	public List<PageLayout> getPageLayoutsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPageLayoutsByProperty(aSegment, aProperty), aSortType);
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query){
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnPageStyles(query).getEntries());
		ret.add(executeQueryOnPageLayouts(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects


	public XMLNode exportPageStylesToXML(){;
		XMLNode ret = new XMLNode("PageStyles");
		List<PageStyle> list = getPageStyles();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageStyle object : list)
			ret.addChildNode(PageStyleXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageStylesToXML(List<PageStyle> list){;
		XMLNode ret = new XMLNode("PageStyles");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageStyle object : list)
			ret.addChildNode(PageStyleXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageLayoutsToXML(){;
		XMLNode ret = new XMLNode("PageLayouts");
		List<PageLayout> list = getPageLayouts();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageLayout object : list)
			ret.addChildNode(PageLayoutXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageLayoutsToXML(List<PageLayout> list){;
		XMLNode ret = new XMLNode("PageLayouts");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageLayout object : list)
			ret.addChildNode(PageLayoutXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("ASLayoutData");

		ret.addChildNode(exportPageStylesToXML());
		ret.addChildNode(exportPageLayoutsToXML());

		return ret;
	}
}
