/**
 ********************************************************************************
 *** IASLayoutDataService.java                                                ***
 *** Generator: net.anotheria.asg.generator.model.ServiceGenerator            ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.aslayoutdata.service;

import java.util.List;
import net.anotheria.util.sorter.SortType;
import net.anotheria.anosite.gen.aslayoutdata.data.PageStyle;
import net.anotheria.anosite.gen.aslayoutdata.data.PageLayout;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.slicer.Segment;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.asg.service.ASGService;

public interface IASLayoutDataService extends ASGService{

// Generated by: class net.anotheria.asg.generator.model.ServiceGenerator.generateInterface

	/**
	 * Returns all PageStyles objects stored.
	 */
	public List<PageStyle> getPageStyles() throws ASLayoutDataServiceException;

	/**
	 * Returns all PageStyles objects sorted by given sortType.
	 */
	public List<PageStyle> getPageStyles(SortType sortType) throws ASLayoutDataServiceException;

	/**
	 * Deletes a PageStyle object by id.
	 */
	public void deletePageStyle(String id) throws ASLayoutDataServiceException;

	/**
	 * Deletes a PageStyle object.
	 */
	public void deletePageStyle(PageStyle pagestyle) throws ASLayoutDataServiceException;

	/**
	 * Deletes multiple PageStyle object.
	 */
	public void deletePageStyles(List<PageStyle> list) throws ASLayoutDataServiceException;

	/**
	 * Returns the PageStyle object with the specified id.
	 */
	public PageStyle getPageStyle(String id) throws ASLayoutDataServiceException;

	/**
	 * Imports a new PageStyle object.
	 * Returns the created version.
	 */
	public PageStyle importPageStyle(PageStyle pagestyle) throws ASLayoutDataServiceException;

	/**
	 * Imports multiple new  PageStyle object.
	 * Returns the created versions.
	 */
	public List<PageStyle> importPageStyles(List<PageStyle> list) throws ASLayoutDataServiceException;

	/**
	 * Creates a new PageStyle object.
	 * Returns the created version.
	 */
	public PageStyle createPageStyle(PageStyle pagestyle) throws ASLayoutDataServiceException;

	/**
	 * Creates multiple new PageStyle objects.
	 * Returns the created versions.
	 */
	public List<PageStyle> createPageStyles(List<PageStyle> list) throws ASLayoutDataServiceException;

	/**
	 * Updates a PageStyle object.
	 * Returns the updated version.
	 */
	public PageStyle updatePageStyle(PageStyle pagestyle) throws ASLayoutDataServiceException;

	/**
	 * Updates mutiple PageStyle objects.
	 * Returns the updated versions.
	 */
	public List<PageStyle> updatePageStyles(List<PageStyle> list) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageStyle objects, where property with given name equals object.
	 */
	public List<PageStyle> getPageStylesByProperty(String propertyName, Object value) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageStyle objects, where property with given name equals object, sorted
	 */
	public List<PageStyle> getPageStylesByProperty(String propertyName, Object value, SortType sortType) throws ASLayoutDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnPageStyles(DocumentQuery query) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageStyle objects, where property matches.
	 */
	public List<PageStyle> getPageStylesByProperty(QueryProperty... property) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageStyle objects, where property matches, sorted
	 */
	public List<PageStyle> getPageStylesByProperty(SortType sortType, QueryProperty... property) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageStyles count.
	 */
	public int getPageStylesCount() throws ASLayoutDataServiceException;

	/**
	 * Returns PageStyles objects segment.
	 */
	public List<PageStyle> getPageStyles(Segment aSegment) throws ASLayoutDataServiceException;

	/**
	 * Returns PageStyle objects segment, where property matches.
	 */
	public List<PageStyle> getPageStylesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASLayoutDataServiceException;

	/**
	 * Returns PageStyle objects segment, where property matches, sorted.
	 */
	public List<PageStyle> getPageStylesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASLayoutDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportPageStylesToXML(List<PageStyle> listPageStyles)  throws ASLayoutDataServiceException;
	/**
	 * Returns all PageLayouts objects stored.
	 */
	public List<PageLayout> getPageLayouts() throws ASLayoutDataServiceException;

	/**
	 * Returns all PageLayouts objects sorted by given sortType.
	 */
	public List<PageLayout> getPageLayouts(SortType sortType) throws ASLayoutDataServiceException;

	/**
	 * Deletes a PageLayout object by id.
	 */
	public void deletePageLayout(String id) throws ASLayoutDataServiceException;

	/**
	 * Deletes a PageLayout object.
	 */
	public void deletePageLayout(PageLayout pagelayout) throws ASLayoutDataServiceException;

	/**
	 * Deletes multiple PageLayout object.
	 */
	public void deletePageLayouts(List<PageLayout> list) throws ASLayoutDataServiceException;

	/**
	 * Returns the PageLayout object with the specified id.
	 */
	public PageLayout getPageLayout(String id) throws ASLayoutDataServiceException;

	/**
	 * Imports a new PageLayout object.
	 * Returns the created version.
	 */
	public PageLayout importPageLayout(PageLayout pagelayout) throws ASLayoutDataServiceException;

	/**
	 * Imports multiple new  PageLayout object.
	 * Returns the created versions.
	 */
	public List<PageLayout> importPageLayouts(List<PageLayout> list) throws ASLayoutDataServiceException;

	/**
	 * Creates a new PageLayout object.
	 * Returns the created version.
	 */
	public PageLayout createPageLayout(PageLayout pagelayout) throws ASLayoutDataServiceException;

	/**
	 * Creates multiple new PageLayout objects.
	 * Returns the created versions.
	 */
	public List<PageLayout> createPageLayouts(List<PageLayout> list) throws ASLayoutDataServiceException;

	/**
	 * Updates a PageLayout object.
	 * Returns the updated version.
	 */
	public PageLayout updatePageLayout(PageLayout pagelayout) throws ASLayoutDataServiceException;

	/**
	 * Updates mutiple PageLayout objects.
	 * Returns the updated versions.
	 */
	public List<PageLayout> updatePageLayouts(List<PageLayout> list) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageLayout objects, where property with given name equals object.
	 */
	public List<PageLayout> getPageLayoutsByProperty(String propertyName, Object value) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageLayout objects, where property with given name equals object, sorted
	 */
	public List<PageLayout> getPageLayoutsByProperty(String propertyName, Object value, SortType sortType) throws ASLayoutDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnPageLayouts(DocumentQuery query) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageLayout objects, where property matches.
	 */
	public List<PageLayout> getPageLayoutsByProperty(QueryProperty... property) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageLayout objects, where property matches, sorted
	 */
	public List<PageLayout> getPageLayoutsByProperty(SortType sortType, QueryProperty... property) throws ASLayoutDataServiceException;

	/**
	 * Returns all PageLayouts count.
	 */
	public int getPageLayoutsCount() throws ASLayoutDataServiceException;

	/**
	 * Returns PageLayouts objects segment.
	 */
	public List<PageLayout> getPageLayouts(Segment aSegment) throws ASLayoutDataServiceException;

	/**
	 * Returns PageLayout objects segment, where property matches.
	 */
	public List<PageLayout> getPageLayoutsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASLayoutDataServiceException;

	/**
	 * Returns PageLayout objects segment, where property matches, sorted.
	 */
	public List<PageLayout> getPageLayoutsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASLayoutDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportPageLayoutsToXML(List<PageLayout> listPageLayouts)  throws ASLayoutDataServiceException;
	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query) throws ASLayoutDataServiceException;
	/**
	 * creates an xml element with all contained data.
	 */
	public XMLNode exportToXML() throws ASLayoutDataServiceException;

}
