/**
 ********************************************************************************
 *** ASResourceDataServiceImpl.java                                           ***
 *** The implementation of the IASResourceDataService.                        ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asresourcedata.service;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.anodoc.data.Module;
import net.anotheria.anodoc.data.Property;
import net.anotheria.anodoc.data.NoSuchPropertyException;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.util.slicer.Segment;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.anosite.gen.asresourcedata.data.ModuleASResourceData;
import net.anotheria.anosite.gen.shared.service.BasicCMSService;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.asg.util.listener.IModuleListener;
import net.anotheria.anosite.gen.asresourcedata.data.TextResource;
import net.anotheria.anosite.gen.asresourcedata.data.TextResourceXMLHelper;
import net.anotheria.anosite.gen.asresourcedata.data.TextResourceDocument;
import net.anotheria.anosite.gen.asresourcedata.data.LocalizationBundle;
import net.anotheria.anosite.gen.asresourcedata.data.LocalizationBundleXMLHelper;
import net.anotheria.anosite.gen.asresourcedata.data.LocalizationBundleDocument;
import net.anotheria.anosite.gen.asresourcedata.data.MailTemplate;
import net.anotheria.anosite.gen.asresourcedata.data.MailTemplateXMLHelper;
import net.anotheria.anosite.gen.asresourcedata.data.MailTemplateDocument;
import net.anotheria.anosite.gen.asresourcedata.data.Image;
import net.anotheria.anosite.gen.asresourcedata.data.ImageXMLHelper;
import net.anotheria.anosite.gen.asresourcedata.data.ImageDocument;
import net.anotheria.anosite.gen.asresourcedata.data.FileLink;
import net.anotheria.anosite.gen.asresourcedata.data.FileLinkXMLHelper;
import net.anotheria.anosite.gen.asresourcedata.data.FileLinkDocument;

public class ASResourceDataServiceImpl extends BasicCMSService implements IASResourceDataService, IModuleListener{

	// Generated by: class net.anotheria.asg.generator.model.docs.CMSBasedServiceGenerator.generateImplementation

	private static ASResourceDataServiceImpl instance;

	private ASResourceDataServiceImpl(){
		addServiceListener(new net.anotheria.anosite.cms.listener.CRUDLogListener());
		addModuleListener(ModuleASResourceData.MODULE_ID, this);
	}

	static final ASResourceDataServiceImpl getInstance(){
		if (instance==null){
			instance = new ASResourceDataServiceImpl();
		}
		return instance;
	}

	private ModuleASResourceData _getModuleASResourceData(){
		return (ModuleASResourceData) getModule(ModuleASResourceData.MODULE_ID);
	}

	@Override
	public void moduleLoaded(Module module){
		firePersistenceChangedEvent();
	}

	@SuppressWarnings("unchecked")
	public List<TextResource> getTextResources(){
		List textresources = new ArrayList();
		textresources.addAll(_getModuleASResourceData().getTextResources());
		return textresources;
	}

	public List<TextResource> getTextResources(SortType sortType){
		return StaticQuickSorter.sort(getTextResources(), sortType);
	}

	/**
	 * Returns the TextResource objects with the specified ids.
	 */
	public List<TextResource> getTextResources(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<TextResource>(0);
		List<TextResource> all = getTextResources();
		List<TextResource> ret = new ArrayList<TextResource>();
		for (TextResource textresource : all){
			if(ids.contains(textresource.getId())){
				ret.add(textresource);
			}
		}
		return ret;
	}

	/**
	 * Returns the TextResource objects with the specified ids, sorted by given sorttype.
	 */
	public List<TextResource> getTextResources(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getTextResources(ids), sortType);
	}

	public void deleteTextResource(TextResource textresource){
		deleteTextResource(textresource.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(textresource);
		}
	}

	public void deleteTextResource(String id){
		ModuleASResourceData module = _getModuleASResourceData();
		TextResource varValue = hasServiceListeners()?module.getTextResource(id):null;
		module.deleteTextResource(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteTextResources(List<TextResource> list){
		ModuleASResourceData module = _getModuleASResourceData();
		for (TextResource textresource : list){
			module.deleteTextResource(textresource.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public TextResource getTextResource(String id){
		return _getModuleASResourceData().getTextResource(id);
	}

	public TextResource importTextResource(TextResource textresource){
		ModuleASResourceData module = _getModuleASResourceData();
		module.importTextResource((TextResourceDocument)textresource);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(textresource);
		}
		return textresource;
	}

	public List<TextResource> importTextResources(List<TextResource> list){
		ModuleASResourceData module = _getModuleASResourceData();
		List<TextResource> ret = new ArrayList<TextResource>();
		for (TextResource textresource : list){
			TextResource imported = module.importTextResource((TextResourceDocument)textresource);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (TextResource textresource : ret)
				fireObjectImportedEvent(textresource);
		}
		return ret;
	}

	public TextResource createTextResource(TextResource textresource){
		ModuleASResourceData module = _getModuleASResourceData();
		module.createTextResource((TextResourceDocument)textresource);
		updateModule(module);
		fireObjectCreatedEvent(textresource);
		return textresource;
	}

	/**
	 * Creates multiple new TextResource objects.
	 * Returns the created versions.
	 */
	public List<TextResource> createTextResources(List<TextResource> list){;
		ModuleASResourceData module = _getModuleASResourceData();
		List<TextResource> ret = new ArrayList<TextResource>();
		for (TextResource textresource : list){
			TextResource created = module.createTextResource((TextResourceDocument)textresource);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (TextResource textresource : ret)
				fireObjectCreatedEvent(textresource);
		}
		return ret;
	}

	public TextResource updateTextResource(TextResource textresource){
		TextResource oldVersion = null;
		ModuleASResourceData module = _getModuleASResourceData();
		if (hasServiceListeners())
			oldVersion = module.getTextResource(textresource.getId());
		module.updateTextResource((TextResourceDocument)textresource);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, textresource);
		}
		return textresource;
	}

	public List<TextResource> updateTextResources(List<TextResource> list){
		List<TextResource> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<TextResource>(list.size());
		ModuleASResourceData module = _getModuleASResourceData();
		for (TextResource textresource : list){
			if (oldList!=null)
				oldList.add(module.getTextResource(textresource.getId()));
			module.updateTextResource((TextResourceDocument)textresource);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<TextResource> getTextResourcesByProperty(String propertyName, Object value){
		List<TextResource> allTextResources = getTextResources();
		List<TextResource> ret = new ArrayList<TextResource>();
		for (int i=0; i<allTextResources.size(); i++){
			TextResource textresource = allTextResources.get(i);
			try{
				Property property = ((TextResourceDocument)textresource).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(textresource);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(textresource);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(textresource);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<TextResource> getTextResourcesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getTextResourcesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on TextResources
	 */
	public QueryResult executeQueryOnTextResources(DocumentQuery query){
		List<TextResource> allTextResources = getTextResources();
		QueryResult result = new QueryResult();
		for (int i=0; i<allTextResources.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allTextResources.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all TextResource objects, where property matches.
	 */
	public List<TextResource> getTextResourcesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<TextResource> ret = new ArrayList<TextResource>();
		List<TextResource> src = getTextResources();
		for ( TextResource textresource : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(textresource.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(textresource);
		}
		return ret;
	}

	/**
	 * Returns all TextResource objects, where property matches, sorted
	 */
	public List<TextResource> getTextResourcesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getTextResourcesByProperty(property), sortType);
	}

	/**
	 * Returns TextResource objects count.
	 */
	public int getTextResourcesCount() {
		return _getModuleASResourceData().getTextResources().size();
	}

	/**
	 * Returns TextResource objects segment.
	 */
	public List<TextResource> getTextResources(Segment aSegment) {
		return Slicer.slice(aSegment, getTextResources()).getSliceData();
	}

	/**
	 * Returns TextResource objects segment, where property matched.
	 */
	public List<TextResource> getTextResourcesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<TextResource> ret = new ArrayList<TextResource>();
		List<TextResource> src = getTextResources();
		for (TextResource textresource : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(textresource.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(textresource);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns TextResource objects segment, where property matched, sorted.
	 */
	public List<TextResource> getTextResourcesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getTextResourcesByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllTextResources(String sourceLanguage, String targetLanguage){
		List<TextResource> allDocumentsSrc = getTextResources();
		List<TextResource> allDocuments = new ArrayList<TextResource>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (TextResource document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateTextResources(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<LocalizationBundle> getLocalizationBundles(){
		List localizationbundles = new ArrayList();
		localizationbundles.addAll(_getModuleASResourceData().getLocalizationBundles());
		return localizationbundles;
	}

	public List<LocalizationBundle> getLocalizationBundles(SortType sortType){
		return StaticQuickSorter.sort(getLocalizationBundles(), sortType);
	}

	/**
	 * Returns the LocalizationBundle objects with the specified ids.
	 */
	public List<LocalizationBundle> getLocalizationBundles(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<LocalizationBundle>(0);
		List<LocalizationBundle> all = getLocalizationBundles();
		List<LocalizationBundle> ret = new ArrayList<LocalizationBundle>();
		for (LocalizationBundle localizationbundle : all){
			if(ids.contains(localizationbundle.getId())){
				ret.add(localizationbundle);
			}
		}
		return ret;
	}

	/**
	 * Returns the LocalizationBundle objects with the specified ids, sorted by given sorttype.
	 */
	public List<LocalizationBundle> getLocalizationBundles(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getLocalizationBundles(ids), sortType);
	}

	public void deleteLocalizationBundle(LocalizationBundle localizationbundle){
		deleteLocalizationBundle(localizationbundle.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(localizationbundle);
		}
	}

	public void deleteLocalizationBundle(String id){
		ModuleASResourceData module = _getModuleASResourceData();
		LocalizationBundle varValue = hasServiceListeners()?module.getLocalizationBundle(id):null;
		module.deleteLocalizationBundle(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteLocalizationBundles(List<LocalizationBundle> list){
		ModuleASResourceData module = _getModuleASResourceData();
		for (LocalizationBundle localizationbundle : list){
			module.deleteLocalizationBundle(localizationbundle.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public LocalizationBundle getLocalizationBundle(String id){
		return _getModuleASResourceData().getLocalizationBundle(id);
	}

	public LocalizationBundle importLocalizationBundle(LocalizationBundle localizationbundle){
		ModuleASResourceData module = _getModuleASResourceData();
		module.importLocalizationBundle((LocalizationBundleDocument)localizationbundle);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(localizationbundle);
		}
		return localizationbundle;
	}

	public List<LocalizationBundle> importLocalizationBundles(List<LocalizationBundle> list){
		ModuleASResourceData module = _getModuleASResourceData();
		List<LocalizationBundle> ret = new ArrayList<LocalizationBundle>();
		for (LocalizationBundle localizationbundle : list){
			LocalizationBundle imported = module.importLocalizationBundle((LocalizationBundleDocument)localizationbundle);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (LocalizationBundle localizationbundle : ret)
				fireObjectImportedEvent(localizationbundle);
		}
		return ret;
	}

	public LocalizationBundle createLocalizationBundle(LocalizationBundle localizationbundle){
		ModuleASResourceData module = _getModuleASResourceData();
		module.createLocalizationBundle((LocalizationBundleDocument)localizationbundle);
		updateModule(module);
		fireObjectCreatedEvent(localizationbundle);
		return localizationbundle;
	}

	/**
	 * Creates multiple new LocalizationBundle objects.
	 * Returns the created versions.
	 */
	public List<LocalizationBundle> createLocalizationBundles(List<LocalizationBundle> list){;
		ModuleASResourceData module = _getModuleASResourceData();
		List<LocalizationBundle> ret = new ArrayList<LocalizationBundle>();
		for (LocalizationBundle localizationbundle : list){
			LocalizationBundle created = module.createLocalizationBundle((LocalizationBundleDocument)localizationbundle);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (LocalizationBundle localizationbundle : ret)
				fireObjectCreatedEvent(localizationbundle);
		}
		return ret;
	}

	public LocalizationBundle updateLocalizationBundle(LocalizationBundle localizationbundle){
		LocalizationBundle oldVersion = null;
		ModuleASResourceData module = _getModuleASResourceData();
		if (hasServiceListeners())
			oldVersion = module.getLocalizationBundle(localizationbundle.getId());
		module.updateLocalizationBundle((LocalizationBundleDocument)localizationbundle);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, localizationbundle);
		}
		return localizationbundle;
	}

	public List<LocalizationBundle> updateLocalizationBundles(List<LocalizationBundle> list){
		List<LocalizationBundle> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<LocalizationBundle>(list.size());
		ModuleASResourceData module = _getModuleASResourceData();
		for (LocalizationBundle localizationbundle : list){
			if (oldList!=null)
				oldList.add(module.getLocalizationBundle(localizationbundle.getId()));
			module.updateLocalizationBundle((LocalizationBundleDocument)localizationbundle);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<LocalizationBundle> getLocalizationBundlesByProperty(String propertyName, Object value){
		List<LocalizationBundle> allLocalizationBundles = getLocalizationBundles();
		List<LocalizationBundle> ret = new ArrayList<LocalizationBundle>();
		for (int i=0; i<allLocalizationBundles.size(); i++){
			LocalizationBundle localizationbundle = allLocalizationBundles.get(i);
			try{
				Property property = ((LocalizationBundleDocument)localizationbundle).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(localizationbundle);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(localizationbundle);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(localizationbundle);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<LocalizationBundle> getLocalizationBundlesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getLocalizationBundlesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on LocalizationBundles
	 */
	public QueryResult executeQueryOnLocalizationBundles(DocumentQuery query){
		List<LocalizationBundle> allLocalizationBundles = getLocalizationBundles();
		QueryResult result = new QueryResult();
		for (int i=0; i<allLocalizationBundles.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allLocalizationBundles.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all LocalizationBundle objects, where property matches.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<LocalizationBundle> ret = new ArrayList<LocalizationBundle>();
		List<LocalizationBundle> src = getLocalizationBundles();
		for ( LocalizationBundle localizationbundle : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(localizationbundle.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(localizationbundle);
		}
		return ret;
	}

	/**
	 * Returns all LocalizationBundle objects, where property matches, sorted
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getLocalizationBundlesByProperty(property), sortType);
	}

	/**
	 * Returns LocalizationBundle objects count.
	 */
	public int getLocalizationBundlesCount() {
		return _getModuleASResourceData().getLocalizationBundles().size();
	}

	/**
	 * Returns LocalizationBundle objects segment.
	 */
	public List<LocalizationBundle> getLocalizationBundles(Segment aSegment) {
		return Slicer.slice(aSegment, getLocalizationBundles()).getSliceData();
	}

	/**
	 * Returns LocalizationBundle objects segment, where property matched.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<LocalizationBundle> ret = new ArrayList<LocalizationBundle>();
		List<LocalizationBundle> src = getLocalizationBundles();
		for (LocalizationBundle localizationbundle : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(localizationbundle.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(localizationbundle);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns LocalizationBundle objects segment, where property matched, sorted.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getLocalizationBundlesByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllLocalizationBundles(String sourceLanguage, String targetLanguage){
		List<LocalizationBundle> allDocumentsSrc = getLocalizationBundles();
		List<LocalizationBundle> allDocuments = new ArrayList<LocalizationBundle>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (LocalizationBundle document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateLocalizationBundles(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<MailTemplate> getMailTemplates(){
		List mailtemplates = new ArrayList();
		mailtemplates.addAll(_getModuleASResourceData().getMailTemplates());
		return mailtemplates;
	}

	public List<MailTemplate> getMailTemplates(SortType sortType){
		return StaticQuickSorter.sort(getMailTemplates(), sortType);
	}

	/**
	 * Returns the MailTemplate objects with the specified ids.
	 */
	public List<MailTemplate> getMailTemplates(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<MailTemplate>(0);
		List<MailTemplate> all = getMailTemplates();
		List<MailTemplate> ret = new ArrayList<MailTemplate>();
		for (MailTemplate mailtemplate : all){
			if(ids.contains(mailtemplate.getId())){
				ret.add(mailtemplate);
			}
		}
		return ret;
	}

	/**
	 * Returns the MailTemplate objects with the specified ids, sorted by given sorttype.
	 */
	public List<MailTemplate> getMailTemplates(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getMailTemplates(ids), sortType);
	}

	public void deleteMailTemplate(MailTemplate mailtemplate){
		deleteMailTemplate(mailtemplate.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(mailtemplate);
		}
	}

	public void deleteMailTemplate(String id){
		ModuleASResourceData module = _getModuleASResourceData();
		MailTemplate varValue = hasServiceListeners()?module.getMailTemplate(id):null;
		module.deleteMailTemplate(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteMailTemplates(List<MailTemplate> list){
		ModuleASResourceData module = _getModuleASResourceData();
		for (MailTemplate mailtemplate : list){
			module.deleteMailTemplate(mailtemplate.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public MailTemplate getMailTemplate(String id){
		return _getModuleASResourceData().getMailTemplate(id);
	}

	public MailTemplate importMailTemplate(MailTemplate mailtemplate){
		ModuleASResourceData module = _getModuleASResourceData();
		module.importMailTemplate((MailTemplateDocument)mailtemplate);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(mailtemplate);
		}
		return mailtemplate;
	}

	public List<MailTemplate> importMailTemplates(List<MailTemplate> list){
		ModuleASResourceData module = _getModuleASResourceData();
		List<MailTemplate> ret = new ArrayList<MailTemplate>();
		for (MailTemplate mailtemplate : list){
			MailTemplate imported = module.importMailTemplate((MailTemplateDocument)mailtemplate);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (MailTemplate mailtemplate : ret)
				fireObjectImportedEvent(mailtemplate);
		}
		return ret;
	}

	public MailTemplate createMailTemplate(MailTemplate mailtemplate){
		ModuleASResourceData module = _getModuleASResourceData();
		module.createMailTemplate((MailTemplateDocument)mailtemplate);
		updateModule(module);
		fireObjectCreatedEvent(mailtemplate);
		return mailtemplate;
	}

	/**
	 * Creates multiple new MailTemplate objects.
	 * Returns the created versions.
	 */
	public List<MailTemplate> createMailTemplates(List<MailTemplate> list){;
		ModuleASResourceData module = _getModuleASResourceData();
		List<MailTemplate> ret = new ArrayList<MailTemplate>();
		for (MailTemplate mailtemplate : list){
			MailTemplate created = module.createMailTemplate((MailTemplateDocument)mailtemplate);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (MailTemplate mailtemplate : ret)
				fireObjectCreatedEvent(mailtemplate);
		}
		return ret;
	}

	public MailTemplate updateMailTemplate(MailTemplate mailtemplate){
		MailTemplate oldVersion = null;
		ModuleASResourceData module = _getModuleASResourceData();
		if (hasServiceListeners())
			oldVersion = module.getMailTemplate(mailtemplate.getId());
		module.updateMailTemplate((MailTemplateDocument)mailtemplate);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, mailtemplate);
		}
		return mailtemplate;
	}

	public List<MailTemplate> updateMailTemplates(List<MailTemplate> list){
		List<MailTemplate> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<MailTemplate>(list.size());
		ModuleASResourceData module = _getModuleASResourceData();
		for (MailTemplate mailtemplate : list){
			if (oldList!=null)
				oldList.add(module.getMailTemplate(mailtemplate.getId()));
			module.updateMailTemplate((MailTemplateDocument)mailtemplate);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<MailTemplate> getMailTemplatesByProperty(String propertyName, Object value){
		List<MailTemplate> allMailTemplates = getMailTemplates();
		List<MailTemplate> ret = new ArrayList<MailTemplate>();
		for (int i=0; i<allMailTemplates.size(); i++){
			MailTemplate mailtemplate = allMailTemplates.get(i);
			try{
				Property property = ((MailTemplateDocument)mailtemplate).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(mailtemplate);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(mailtemplate);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(mailtemplate);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<MailTemplate> getMailTemplatesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getMailTemplatesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on MailTemplates
	 */
	public QueryResult executeQueryOnMailTemplates(DocumentQuery query){
		List<MailTemplate> allMailTemplates = getMailTemplates();
		QueryResult result = new QueryResult();
		for (int i=0; i<allMailTemplates.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allMailTemplates.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all MailTemplate objects, where property matches.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<MailTemplate> ret = new ArrayList<MailTemplate>();
		List<MailTemplate> src = getMailTemplates();
		for ( MailTemplate mailtemplate : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(mailtemplate.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(mailtemplate);
		}
		return ret;
	}

	/**
	 * Returns all MailTemplate objects, where property matches, sorted
	 */
	public List<MailTemplate> getMailTemplatesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getMailTemplatesByProperty(property), sortType);
	}

	/**
	 * Returns MailTemplate objects count.
	 */
	public int getMailTemplatesCount() {
		return _getModuleASResourceData().getMailTemplates().size();
	}

	/**
	 * Returns MailTemplate objects segment.
	 */
	public List<MailTemplate> getMailTemplates(Segment aSegment) {
		return Slicer.slice(aSegment, getMailTemplates()).getSliceData();
	}

	/**
	 * Returns MailTemplate objects segment, where property matched.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<MailTemplate> ret = new ArrayList<MailTemplate>();
		List<MailTemplate> src = getMailTemplates();
		for (MailTemplate mailtemplate : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(mailtemplate.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(mailtemplate);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns MailTemplate objects segment, where property matched, sorted.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getMailTemplatesByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllMailTemplates(String sourceLanguage, String targetLanguage){
		List<MailTemplate> allDocumentsSrc = getMailTemplates();
		List<MailTemplate> allDocuments = new ArrayList<MailTemplate>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (MailTemplate document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateMailTemplates(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<Image> getImages(){
		List images = new ArrayList();
		images.addAll(_getModuleASResourceData().getImages());
		return images;
	}

	public List<Image> getImages(SortType sortType){
		return StaticQuickSorter.sort(getImages(), sortType);
	}

	/**
	 * Returns the Image objects with the specified ids.
	 */
	public List<Image> getImages(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Image>(0);
		List<Image> all = getImages();
		List<Image> ret = new ArrayList<Image>();
		for (Image image : all){
			if(ids.contains(image.getId())){
				ret.add(image);
			}
		}
		return ret;
	}

	/**
	 * Returns the Image objects with the specified ids, sorted by given sorttype.
	 */
	public List<Image> getImages(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getImages(ids), sortType);
	}

	public void deleteImage(Image image){
		deleteImage(image.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(image);
		}
	}

	public void deleteImage(String id){
		ModuleASResourceData module = _getModuleASResourceData();
		Image varValue = hasServiceListeners()?module.getImage(id):null;
		module.deleteImage(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteImages(List<Image> list){
		ModuleASResourceData module = _getModuleASResourceData();
		for (Image image : list){
			module.deleteImage(image.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Image getImage(String id){
		return _getModuleASResourceData().getImage(id);
	}

	public Image importImage(Image image){
		ModuleASResourceData module = _getModuleASResourceData();
		module.importImage((ImageDocument)image);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(image);
		}
		return image;
	}

	public List<Image> importImages(List<Image> list){
		ModuleASResourceData module = _getModuleASResourceData();
		List<Image> ret = new ArrayList<Image>();
		for (Image image : list){
			Image imported = module.importImage((ImageDocument)image);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Image image : ret)
				fireObjectImportedEvent(image);
		}
		return ret;
	}

	public Image createImage(Image image){
		ModuleASResourceData module = _getModuleASResourceData();
		module.createImage((ImageDocument)image);
		updateModule(module);
		fireObjectCreatedEvent(image);
		return image;
	}

	/**
	 * Creates multiple new Image objects.
	 * Returns the created versions.
	 */
	public List<Image> createImages(List<Image> list){;
		ModuleASResourceData module = _getModuleASResourceData();
		List<Image> ret = new ArrayList<Image>();
		for (Image image : list){
			Image created = module.createImage((ImageDocument)image);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Image image : ret)
				fireObjectCreatedEvent(image);
		}
		return ret;
	}

	public Image updateImage(Image image){
		Image oldVersion = null;
		ModuleASResourceData module = _getModuleASResourceData();
		if (hasServiceListeners())
			oldVersion = module.getImage(image.getId());
		module.updateImage((ImageDocument)image);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, image);
		}
		return image;
	}

	public List<Image> updateImages(List<Image> list){
		List<Image> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Image>(list.size());
		ModuleASResourceData module = _getModuleASResourceData();
		for (Image image : list){
			if (oldList!=null)
				oldList.add(module.getImage(image.getId()));
			module.updateImage((ImageDocument)image);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Image> getImagesByProperty(String propertyName, Object value){
		List<Image> allImages = getImages();
		List<Image> ret = new ArrayList<Image>();
		for (int i=0; i<allImages.size(); i++){
			Image image = allImages.get(i);
			try{
				Property property = ((ImageDocument)image).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(image);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(image);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(image);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Image> getImagesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getImagesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Images
	 */
	public QueryResult executeQueryOnImages(DocumentQuery query){
		List<Image> allImages = getImages();
		QueryResult result = new QueryResult();
		for (int i=0; i<allImages.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allImages.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Image objects, where property matches.
	 */
	public List<Image> getImagesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Image> ret = new ArrayList<Image>();
		List<Image> src = getImages();
		for ( Image image : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(image.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(image);
		}
		return ret;
	}

	/**
	 * Returns all Image objects, where property matches, sorted
	 */
	public List<Image> getImagesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getImagesByProperty(property), sortType);
	}

	/**
	 * Returns Image objects count.
	 */
	public int getImagesCount() {
		return _getModuleASResourceData().getImages().size();
	}

	/**
	 * Returns Image objects segment.
	 */
	public List<Image> getImages(Segment aSegment) {
		return Slicer.slice(aSegment, getImages()).getSliceData();
	}

	/**
	 * Returns Image objects segment, where property matched.
	 */
	public List<Image> getImagesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Image> ret = new ArrayList<Image>();
		List<Image> src = getImages();
		for (Image image : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(image.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(image);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Image objects segment, where property matched, sorted.
	 */
	public List<Image> getImagesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getImagesByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllImages(String sourceLanguage, String targetLanguage){
		List<Image> allDocumentsSrc = getImages();
		List<Image> allDocuments = new ArrayList<Image>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (Image document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateImages(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<FileLink> getFileLinks(){
		List filelinks = new ArrayList();
		filelinks.addAll(_getModuleASResourceData().getFileLinks());
		return filelinks;
	}

	public List<FileLink> getFileLinks(SortType sortType){
		return StaticQuickSorter.sort(getFileLinks(), sortType);
	}

	/**
	 * Returns the FileLink objects with the specified ids.
	 */
	public List<FileLink> getFileLinks(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<FileLink>(0);
		List<FileLink> all = getFileLinks();
		List<FileLink> ret = new ArrayList<FileLink>();
		for (FileLink filelink : all){
			if(ids.contains(filelink.getId())){
				ret.add(filelink);
			}
		}
		return ret;
	}

	/**
	 * Returns the FileLink objects with the specified ids, sorted by given sorttype.
	 */
	public List<FileLink> getFileLinks(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getFileLinks(ids), sortType);
	}

	public void deleteFileLink(FileLink filelink){
		deleteFileLink(filelink.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(filelink);
		}
	}

	public void deleteFileLink(String id){
		ModuleASResourceData module = _getModuleASResourceData();
		FileLink varValue = hasServiceListeners()?module.getFileLink(id):null;
		module.deleteFileLink(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteFileLinks(List<FileLink> list){
		ModuleASResourceData module = _getModuleASResourceData();
		for (FileLink filelink : list){
			module.deleteFileLink(filelink.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public FileLink getFileLink(String id){
		return _getModuleASResourceData().getFileLink(id);
	}

	public FileLink importFileLink(FileLink filelink){
		ModuleASResourceData module = _getModuleASResourceData();
		module.importFileLink((FileLinkDocument)filelink);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(filelink);
		}
		return filelink;
	}

	public List<FileLink> importFileLinks(List<FileLink> list){
		ModuleASResourceData module = _getModuleASResourceData();
		List<FileLink> ret = new ArrayList<FileLink>();
		for (FileLink filelink : list){
			FileLink imported = module.importFileLink((FileLinkDocument)filelink);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (FileLink filelink : ret)
				fireObjectImportedEvent(filelink);
		}
		return ret;
	}

	public FileLink createFileLink(FileLink filelink){
		ModuleASResourceData module = _getModuleASResourceData();
		module.createFileLink((FileLinkDocument)filelink);
		updateModule(module);
		fireObjectCreatedEvent(filelink);
		return filelink;
	}

	/**
	 * Creates multiple new FileLink objects.
	 * Returns the created versions.
	 */
	public List<FileLink> createFileLinks(List<FileLink> list){;
		ModuleASResourceData module = _getModuleASResourceData();
		List<FileLink> ret = new ArrayList<FileLink>();
		for (FileLink filelink : list){
			FileLink created = module.createFileLink((FileLinkDocument)filelink);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (FileLink filelink : ret)
				fireObjectCreatedEvent(filelink);
		}
		return ret;
	}

	public FileLink updateFileLink(FileLink filelink){
		FileLink oldVersion = null;
		ModuleASResourceData module = _getModuleASResourceData();
		if (hasServiceListeners())
			oldVersion = module.getFileLink(filelink.getId());
		module.updateFileLink((FileLinkDocument)filelink);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, filelink);
		}
		return filelink;
	}

	public List<FileLink> updateFileLinks(List<FileLink> list){
		List<FileLink> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<FileLink>(list.size());
		ModuleASResourceData module = _getModuleASResourceData();
		for (FileLink filelink : list){
			if (oldList!=null)
				oldList.add(module.getFileLink(filelink.getId()));
			module.updateFileLink((FileLinkDocument)filelink);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<FileLink> getFileLinksByProperty(String propertyName, Object value){
		List<FileLink> allFileLinks = getFileLinks();
		List<FileLink> ret = new ArrayList<FileLink>();
		for (int i=0; i<allFileLinks.size(); i++){
			FileLink filelink = allFileLinks.get(i);
			try{
				Property property = ((FileLinkDocument)filelink).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(filelink);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(filelink);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(filelink);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<FileLink> getFileLinksByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getFileLinksByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on FileLinks
	 */
	public QueryResult executeQueryOnFileLinks(DocumentQuery query){
		List<FileLink> allFileLinks = getFileLinks();
		QueryResult result = new QueryResult();
		for (int i=0; i<allFileLinks.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allFileLinks.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all FileLink objects, where property matches.
	 */
	public List<FileLink> getFileLinksByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<FileLink> ret = new ArrayList<FileLink>();
		List<FileLink> src = getFileLinks();
		for ( FileLink filelink : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(filelink.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(filelink);
		}
		return ret;
	}

	/**
	 * Returns all FileLink objects, where property matches, sorted
	 */
	public List<FileLink> getFileLinksByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getFileLinksByProperty(property), sortType);
	}

	/**
	 * Returns FileLink objects count.
	 */
	public int getFileLinksCount() {
		return _getModuleASResourceData().getFileLinks().size();
	}

	/**
	 * Returns FileLink objects segment.
	 */
	public List<FileLink> getFileLinks(Segment aSegment) {
		return Slicer.slice(aSegment, getFileLinks()).getSliceData();
	}

	/**
	 * Returns FileLink objects segment, where property matched.
	 */
	public List<FileLink> getFileLinksByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<FileLink> ret = new ArrayList<FileLink>();
		List<FileLink> src = getFileLinks();
		for (FileLink filelink : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(filelink.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(filelink);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns FileLink objects segment, where property matched, sorted.
	 */
	public List<FileLink> getFileLinksByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getFileLinksByProperty(aSegment, aProperty), aSortType);
	}

	/**
	 * Copies all multilingual fields from sourceLanguage to targetLanguage in all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public void copyMultilingualAttributesInAllObjects(String sourceLanguage, String targetLanguage){
		copyMultilingualAttributesInAllTextResources(sourceLanguage, targetLanguage);
		copyMultilingualAttributesInAllLocalizationBundles(sourceLanguage, targetLanguage);
		copyMultilingualAttributesInAllMailTemplates(sourceLanguage, targetLanguage);
		copyMultilingualAttributesInAllImages(sourceLanguage, targetLanguage);
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query){
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnTextResources(query).getEntries());
		ret.add(executeQueryOnLocalizationBundles(query).getEntries());
		ret.add(executeQueryOnMailTemplates(query).getEntries());
		ret.add(executeQueryOnImages(query).getEntries());
		ret.add(executeQueryOnFileLinks(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects


	public XMLNode exportTextResourcesToXML(){;
		XMLNode ret = new XMLNode("TextResources");
		List<TextResource> list = getTextResources();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (TextResource object : list)
			ret.addChildNode(TextResourceXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportTextResourcesToXML(List<TextResource> list){;
		XMLNode ret = new XMLNode("TextResources");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (TextResource object : list)
			ret.addChildNode(TextResourceXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportTextResourcesToXML(String[] languages){;
		XMLNode ret = new XMLNode("TextResources");
		List<TextResource> list = getTextResources();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (TextResource object : list)
			ret.addChildNode(TextResourceXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportTextResourcesToXML(String[] languages, List<TextResource> list){;
		XMLNode ret = new XMLNode("TextResources");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (TextResource object : list)
			ret.addChildNode(TextResourceXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportLocalizationBundlesToXML(){;
		XMLNode ret = new XMLNode("LocalizationBundles");
		List<LocalizationBundle> list = getLocalizationBundles();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (LocalizationBundle object : list)
			ret.addChildNode(LocalizationBundleXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportLocalizationBundlesToXML(List<LocalizationBundle> list){;
		XMLNode ret = new XMLNode("LocalizationBundles");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (LocalizationBundle object : list)
			ret.addChildNode(LocalizationBundleXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportLocalizationBundlesToXML(String[] languages){;
		XMLNode ret = new XMLNode("LocalizationBundles");
		List<LocalizationBundle> list = getLocalizationBundles();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (LocalizationBundle object : list)
			ret.addChildNode(LocalizationBundleXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportLocalizationBundlesToXML(String[] languages, List<LocalizationBundle> list){;
		XMLNode ret = new XMLNode("LocalizationBundles");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (LocalizationBundle object : list)
			ret.addChildNode(LocalizationBundleXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportMailTemplatesToXML(){;
		XMLNode ret = new XMLNode("MailTemplates");
		List<MailTemplate> list = getMailTemplates();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MailTemplate object : list)
			ret.addChildNode(MailTemplateXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportMailTemplatesToXML(List<MailTemplate> list){;
		XMLNode ret = new XMLNode("MailTemplates");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MailTemplate object : list)
			ret.addChildNode(MailTemplateXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportMailTemplatesToXML(String[] languages){;
		XMLNode ret = new XMLNode("MailTemplates");
		List<MailTemplate> list = getMailTemplates();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MailTemplate object : list)
			ret.addChildNode(MailTemplateXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportMailTemplatesToXML(String[] languages, List<MailTemplate> list){;
		XMLNode ret = new XMLNode("MailTemplates");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MailTemplate object : list)
			ret.addChildNode(MailTemplateXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportImagesToXML(){;
		XMLNode ret = new XMLNode("Images");
		List<Image> list = getImages();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Image object : list)
			ret.addChildNode(ImageXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportImagesToXML(List<Image> list){;
		XMLNode ret = new XMLNode("Images");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Image object : list)
			ret.addChildNode(ImageXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportImagesToXML(String[] languages){;
		XMLNode ret = new XMLNode("Images");
		List<Image> list = getImages();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Image object : list)
			ret.addChildNode(ImageXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportImagesToXML(String[] languages, List<Image> list){;
		XMLNode ret = new XMLNode("Images");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Image object : list)
			ret.addChildNode(ImageXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportFileLinksToXML(){;
		XMLNode ret = new XMLNode("FileLinks");
		List<FileLink> list = getFileLinks();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (FileLink object : list)
			ret.addChildNode(FileLinkXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportFileLinksToXML(List<FileLink> list){;
		XMLNode ret = new XMLNode("FileLinks");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (FileLink object : list)
			ret.addChildNode(FileLinkXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportFileLinksToXML(String[] languages){;
		XMLNode ret = new XMLNode("FileLinks");
		List<FileLink> list = getFileLinks();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (FileLink object : list)
			ret.addChildNode(FileLinkXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportFileLinksToXML(String[] languages, List<FileLink> list){;
		XMLNode ret = new XMLNode("FileLinks");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (FileLink object : list)
			ret.addChildNode(FileLinkXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("ASResourceData");

		ret.addChildNode(exportTextResourcesToXML());
		ret.addChildNode(exportLocalizationBundlesToXML());
		ret.addChildNode(exportMailTemplatesToXML());
		ret.addChildNode(exportImagesToXML());
		ret.addChildNode(exportFileLinksToXML());

		return ret;
	}
	public XMLNode exportToXML(String[] languages){
		XMLNode ret = new XMLNode("ASResourceData");

		ret.addChildNode(exportTextResourcesToXML(languages));
		ret.addChildNode(exportLocalizationBundlesToXML(languages));
		ret.addChildNode(exportMailTemplatesToXML(languages));
		ret.addChildNode(exportImagesToXML(languages));
		ret.addChildNode(exportFileLinksToXML(languages));

		return ret;
	}
}
