/**
 ********************************************************************************
 *** IASResourceDataService.java                                              ***
 *** Generator: net.anotheria.asg.generator.model.ServiceGenerator            ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.asresourcedata.service;

import java.util.List;
import net.anotheria.util.sorter.SortType;
import net.anotheria.anosite.gen.asresourcedata.data.TextResource;
import net.anotheria.anosite.gen.asresourcedata.data.LocalizationBundle;
import net.anotheria.anosite.gen.asresourcedata.data.MailTemplate;
import net.anotheria.anosite.gen.asresourcedata.data.Image;
import net.anotheria.anosite.gen.asresourcedata.data.FileLink;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.slicer.Segment;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.asg.service.ASGService;

public interface IASResourceDataService extends ASGService{

// Generated by: class net.anotheria.asg.generator.model.ServiceGenerator.generateInterface

	/**
	 * Returns all TextResources objects stored.
	 */
	public List<TextResource> getTextResources() throws ASResourceDataServiceException;

	/**
	 * Returns all TextResources objects sorted by given sortType.
	 */
	public List<TextResource> getTextResources(SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Deletes a TextResource object by id.
	 */
	public void deleteTextResource(String id) throws ASResourceDataServiceException;

	/**
	 * Deletes a TextResource object.
	 */
	public void deleteTextResource(TextResource textresource) throws ASResourceDataServiceException;

	/**
	 * Deletes multiple TextResource object.
	 */
	public void deleteTextResources(List<TextResource> list) throws ASResourceDataServiceException;

	/**
	 * Returns the TextResource object with the specified id.
	 */
	public TextResource getTextResource(String id) throws ASResourceDataServiceException;

	/**
	 * Imports a new TextResource object.
	 * Returns the created version.
	 */
	public TextResource importTextResource(TextResource textresource) throws ASResourceDataServiceException;

	/**
	 * Imports multiple new  TextResource object.
	 * Returns the created versions.
	 */
	public List<TextResource> importTextResources(List<TextResource> list) throws ASResourceDataServiceException;

	/**
	 * Creates a new TextResource object.
	 * Returns the created version.
	 */
	public TextResource createTextResource(TextResource textresource) throws ASResourceDataServiceException;

	/**
	 * Creates multiple new TextResource objects.
	 * Returns the created versions.
	 */
	public List<TextResource> createTextResources(List<TextResource> list) throws ASResourceDataServiceException;

	/**
	 * Updates a TextResource object.
	 * Returns the updated version.
	 */
	public TextResource updateTextResource(TextResource textresource) throws ASResourceDataServiceException;

	/**
	 * Updates mutiple TextResource objects.
	 * Returns the updated versions.
	 */
	public List<TextResource> updateTextResources(List<TextResource> list) throws ASResourceDataServiceException;

	/**
	 * Returns all TextResource objects, where property with given name equals object.
	 */
	public List<TextResource> getTextResourcesByProperty(String propertyName, Object value) throws ASResourceDataServiceException;

	/**
	 * Returns all TextResource objects, where property with given name equals object, sorted
	 */
	public List<TextResource> getTextResourcesByProperty(String propertyName, Object value, SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnTextResources(DocumentQuery query) throws ASResourceDataServiceException;

	/**
	 * Returns all TextResource objects, where property matches.
	 */
	public List<TextResource> getTextResourcesByProperty(QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all TextResource objects, where property matches, sorted
	 */
	public List<TextResource> getTextResourcesByProperty(SortType sortType, QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all TextResources count.
	 */
	public int getTextResourcesCount() throws ASResourceDataServiceException;

	/**
	 * Returns TextResources objects segment.
	 */
	public List<TextResource> getTextResources(Segment aSegment) throws ASResourceDataServiceException;

	/**
	 * Returns TextResource objects segment, where property matches.
	 */
	public List<TextResource> getTextResourcesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * Returns TextResource objects segment, where property matches, sorted.
	 */
	public List<TextResource> getTextResourcesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * In all documents of type TextResource copies all multilingual fields from sourceLanguage to targetLanguage
	 */
	public void copyMultilingualAttributesInAllTextResources(String sourceLanguage, String targetLanguage) throws ASResourceDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportTextResourcesToXML(List<TextResource> listTextResources)  throws ASResourceDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportTextResourcesToXML(String[] languages,List<TextResource> listTextResources) throws ASResourceDataServiceException;
	/**
	 * Returns all LocalizationBundles objects stored.
	 */
	public List<LocalizationBundle> getLocalizationBundles() throws ASResourceDataServiceException;

	/**
	 * Returns all LocalizationBundles objects sorted by given sortType.
	 */
	public List<LocalizationBundle> getLocalizationBundles(SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Deletes a LocalizationBundle object by id.
	 */
	public void deleteLocalizationBundle(String id) throws ASResourceDataServiceException;

	/**
	 * Deletes a LocalizationBundle object.
	 */
	public void deleteLocalizationBundle(LocalizationBundle localizationbundle) throws ASResourceDataServiceException;

	/**
	 * Deletes multiple LocalizationBundle object.
	 */
	public void deleteLocalizationBundles(List<LocalizationBundle> list) throws ASResourceDataServiceException;

	/**
	 * Returns the LocalizationBundle object with the specified id.
	 */
	public LocalizationBundle getLocalizationBundle(String id) throws ASResourceDataServiceException;

	/**
	 * Imports a new LocalizationBundle object.
	 * Returns the created version.
	 */
	public LocalizationBundle importLocalizationBundle(LocalizationBundle localizationbundle) throws ASResourceDataServiceException;

	/**
	 * Imports multiple new  LocalizationBundle object.
	 * Returns the created versions.
	 */
	public List<LocalizationBundle> importLocalizationBundles(List<LocalizationBundle> list) throws ASResourceDataServiceException;

	/**
	 * Creates a new LocalizationBundle object.
	 * Returns the created version.
	 */
	public LocalizationBundle createLocalizationBundle(LocalizationBundle localizationbundle) throws ASResourceDataServiceException;

	/**
	 * Creates multiple new LocalizationBundle objects.
	 * Returns the created versions.
	 */
	public List<LocalizationBundle> createLocalizationBundles(List<LocalizationBundle> list) throws ASResourceDataServiceException;

	/**
	 * Updates a LocalizationBundle object.
	 * Returns the updated version.
	 */
	public LocalizationBundle updateLocalizationBundle(LocalizationBundle localizationbundle) throws ASResourceDataServiceException;

	/**
	 * Updates mutiple LocalizationBundle objects.
	 * Returns the updated versions.
	 */
	public List<LocalizationBundle> updateLocalizationBundles(List<LocalizationBundle> list) throws ASResourceDataServiceException;

	/**
	 * Returns all LocalizationBundle objects, where property with given name equals object.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(String propertyName, Object value) throws ASResourceDataServiceException;

	/**
	 * Returns all LocalizationBundle objects, where property with given name equals object, sorted
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(String propertyName, Object value, SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnLocalizationBundles(DocumentQuery query) throws ASResourceDataServiceException;

	/**
	 * Returns all LocalizationBundle objects, where property matches.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all LocalizationBundle objects, where property matches, sorted
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(SortType sortType, QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all LocalizationBundles count.
	 */
	public int getLocalizationBundlesCount() throws ASResourceDataServiceException;

	/**
	 * Returns LocalizationBundles objects segment.
	 */
	public List<LocalizationBundle> getLocalizationBundles(Segment aSegment) throws ASResourceDataServiceException;

	/**
	 * Returns LocalizationBundle objects segment, where property matches.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * Returns LocalizationBundle objects segment, where property matches, sorted.
	 */
	public List<LocalizationBundle> getLocalizationBundlesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * In all documents of type LocalizationBundle copies all multilingual fields from sourceLanguage to targetLanguage
	 */
	public void copyMultilingualAttributesInAllLocalizationBundles(String sourceLanguage, String targetLanguage) throws ASResourceDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportLocalizationBundlesToXML(List<LocalizationBundle> listLocalizationBundles)  throws ASResourceDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportLocalizationBundlesToXML(String[] languages,List<LocalizationBundle> listLocalizationBundles) throws ASResourceDataServiceException;
	/**
	 * Returns all MailTemplates objects stored.
	 */
	public List<MailTemplate> getMailTemplates() throws ASResourceDataServiceException;

	/**
	 * Returns all MailTemplates objects sorted by given sortType.
	 */
	public List<MailTemplate> getMailTemplates(SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Deletes a MailTemplate object by id.
	 */
	public void deleteMailTemplate(String id) throws ASResourceDataServiceException;

	/**
	 * Deletes a MailTemplate object.
	 */
	public void deleteMailTemplate(MailTemplate mailtemplate) throws ASResourceDataServiceException;

	/**
	 * Deletes multiple MailTemplate object.
	 */
	public void deleteMailTemplates(List<MailTemplate> list) throws ASResourceDataServiceException;

	/**
	 * Returns the MailTemplate object with the specified id.
	 */
	public MailTemplate getMailTemplate(String id) throws ASResourceDataServiceException;

	/**
	 * Imports a new MailTemplate object.
	 * Returns the created version.
	 */
	public MailTemplate importMailTemplate(MailTemplate mailtemplate) throws ASResourceDataServiceException;

	/**
	 * Imports multiple new  MailTemplate object.
	 * Returns the created versions.
	 */
	public List<MailTemplate> importMailTemplates(List<MailTemplate> list) throws ASResourceDataServiceException;

	/**
	 * Creates a new MailTemplate object.
	 * Returns the created version.
	 */
	public MailTemplate createMailTemplate(MailTemplate mailtemplate) throws ASResourceDataServiceException;

	/**
	 * Creates multiple new MailTemplate objects.
	 * Returns the created versions.
	 */
	public List<MailTemplate> createMailTemplates(List<MailTemplate> list) throws ASResourceDataServiceException;

	/**
	 * Updates a MailTemplate object.
	 * Returns the updated version.
	 */
	public MailTemplate updateMailTemplate(MailTemplate mailtemplate) throws ASResourceDataServiceException;

	/**
	 * Updates mutiple MailTemplate objects.
	 * Returns the updated versions.
	 */
	public List<MailTemplate> updateMailTemplates(List<MailTemplate> list) throws ASResourceDataServiceException;

	/**
	 * Returns all MailTemplate objects, where property with given name equals object.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(String propertyName, Object value) throws ASResourceDataServiceException;

	/**
	 * Returns all MailTemplate objects, where property with given name equals object, sorted
	 */
	public List<MailTemplate> getMailTemplatesByProperty(String propertyName, Object value, SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnMailTemplates(DocumentQuery query) throws ASResourceDataServiceException;

	/**
	 * Returns all MailTemplate objects, where property matches.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all MailTemplate objects, where property matches, sorted
	 */
	public List<MailTemplate> getMailTemplatesByProperty(SortType sortType, QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all MailTemplates count.
	 */
	public int getMailTemplatesCount() throws ASResourceDataServiceException;

	/**
	 * Returns MailTemplates objects segment.
	 */
	public List<MailTemplate> getMailTemplates(Segment aSegment) throws ASResourceDataServiceException;

	/**
	 * Returns MailTemplate objects segment, where property matches.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * Returns MailTemplate objects segment, where property matches, sorted.
	 */
	public List<MailTemplate> getMailTemplatesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * In all documents of type MailTemplate copies all multilingual fields from sourceLanguage to targetLanguage
	 */
	public void copyMultilingualAttributesInAllMailTemplates(String sourceLanguage, String targetLanguage) throws ASResourceDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportMailTemplatesToXML(List<MailTemplate> listMailTemplates)  throws ASResourceDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportMailTemplatesToXML(String[] languages,List<MailTemplate> listMailTemplates) throws ASResourceDataServiceException;
	/**
	 * Returns all Images objects stored.
	 */
	public List<Image> getImages() throws ASResourceDataServiceException;

	/**
	 * Returns all Images objects sorted by given sortType.
	 */
	public List<Image> getImages(SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Deletes a Image object by id.
	 */
	public void deleteImage(String id) throws ASResourceDataServiceException;

	/**
	 * Deletes a Image object.
	 */
	public void deleteImage(Image image) throws ASResourceDataServiceException;

	/**
	 * Deletes multiple Image object.
	 */
	public void deleteImages(List<Image> list) throws ASResourceDataServiceException;

	/**
	 * Returns the Image object with the specified id.
	 */
	public Image getImage(String id) throws ASResourceDataServiceException;

	/**
	 * Imports a new Image object.
	 * Returns the created version.
	 */
	public Image importImage(Image image) throws ASResourceDataServiceException;

	/**
	 * Imports multiple new  Image object.
	 * Returns the created versions.
	 */
	public List<Image> importImages(List<Image> list) throws ASResourceDataServiceException;

	/**
	 * Creates a new Image object.
	 * Returns the created version.
	 */
	public Image createImage(Image image) throws ASResourceDataServiceException;

	/**
	 * Creates multiple new Image objects.
	 * Returns the created versions.
	 */
	public List<Image> createImages(List<Image> list) throws ASResourceDataServiceException;

	/**
	 * Updates a Image object.
	 * Returns the updated version.
	 */
	public Image updateImage(Image image) throws ASResourceDataServiceException;

	/**
	 * Updates mutiple Image objects.
	 * Returns the updated versions.
	 */
	public List<Image> updateImages(List<Image> list) throws ASResourceDataServiceException;

	/**
	 * Returns all Image objects, where property with given name equals object.
	 */
	public List<Image> getImagesByProperty(String propertyName, Object value) throws ASResourceDataServiceException;

	/**
	 * Returns all Image objects, where property with given name equals object, sorted
	 */
	public List<Image> getImagesByProperty(String propertyName, Object value, SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnImages(DocumentQuery query) throws ASResourceDataServiceException;

	/**
	 * Returns all Image objects, where property matches.
	 */
	public List<Image> getImagesByProperty(QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all Image objects, where property matches, sorted
	 */
	public List<Image> getImagesByProperty(SortType sortType, QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all Images count.
	 */
	public int getImagesCount() throws ASResourceDataServiceException;

	/**
	 * Returns Images objects segment.
	 */
	public List<Image> getImages(Segment aSegment) throws ASResourceDataServiceException;

	/**
	 * Returns Image objects segment, where property matches.
	 */
	public List<Image> getImagesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * Returns Image objects segment, where property matches, sorted.
	 */
	public List<Image> getImagesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * In all documents of type Image copies all multilingual fields from sourceLanguage to targetLanguage
	 */
	public void copyMultilingualAttributesInAllImages(String sourceLanguage, String targetLanguage) throws ASResourceDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportImagesToXML(List<Image> listImages)  throws ASResourceDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportImagesToXML(String[] languages,List<Image> listImages) throws ASResourceDataServiceException;
	/**
	 * Returns all FileLinks objects stored.
	 */
	public List<FileLink> getFileLinks() throws ASResourceDataServiceException;

	/**
	 * Returns all FileLinks objects sorted by given sortType.
	 */
	public List<FileLink> getFileLinks(SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Deletes a FileLink object by id.
	 */
	public void deleteFileLink(String id) throws ASResourceDataServiceException;

	/**
	 * Deletes a FileLink object.
	 */
	public void deleteFileLink(FileLink filelink) throws ASResourceDataServiceException;

	/**
	 * Deletes multiple FileLink object.
	 */
	public void deleteFileLinks(List<FileLink> list) throws ASResourceDataServiceException;

	/**
	 * Returns the FileLink object with the specified id.
	 */
	public FileLink getFileLink(String id) throws ASResourceDataServiceException;

	/**
	 * Imports a new FileLink object.
	 * Returns the created version.
	 */
	public FileLink importFileLink(FileLink filelink) throws ASResourceDataServiceException;

	/**
	 * Imports multiple new  FileLink object.
	 * Returns the created versions.
	 */
	public List<FileLink> importFileLinks(List<FileLink> list) throws ASResourceDataServiceException;

	/**
	 * Creates a new FileLink object.
	 * Returns the created version.
	 */
	public FileLink createFileLink(FileLink filelink) throws ASResourceDataServiceException;

	/**
	 * Creates multiple new FileLink objects.
	 * Returns the created versions.
	 */
	public List<FileLink> createFileLinks(List<FileLink> list) throws ASResourceDataServiceException;

	/**
	 * Updates a FileLink object.
	 * Returns the updated version.
	 */
	public FileLink updateFileLink(FileLink filelink) throws ASResourceDataServiceException;

	/**
	 * Updates mutiple FileLink objects.
	 * Returns the updated versions.
	 */
	public List<FileLink> updateFileLinks(List<FileLink> list) throws ASResourceDataServiceException;

	/**
	 * Returns all FileLink objects, where property with given name equals object.
	 */
	public List<FileLink> getFileLinksByProperty(String propertyName, Object value) throws ASResourceDataServiceException;

	/**
	 * Returns all FileLink objects, where property with given name equals object, sorted
	 */
	public List<FileLink> getFileLinksByProperty(String propertyName, Object value, SortType sortType) throws ASResourceDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnFileLinks(DocumentQuery query) throws ASResourceDataServiceException;

	/**
	 * Returns all FileLink objects, where property matches.
	 */
	public List<FileLink> getFileLinksByProperty(QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all FileLink objects, where property matches, sorted
	 */
	public List<FileLink> getFileLinksByProperty(SortType sortType, QueryProperty... property) throws ASResourceDataServiceException;

	/**
	 * Returns all FileLinks count.
	 */
	public int getFileLinksCount() throws ASResourceDataServiceException;

	/**
	 * Returns FileLinks objects segment.
	 */
	public List<FileLink> getFileLinks(Segment aSegment) throws ASResourceDataServiceException;

	/**
	 * Returns FileLink objects segment, where property matches.
	 */
	public List<FileLink> getFileLinksByProperty(Segment aSegment, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * Returns FileLink objects segment, where property matches, sorted.
	 */
	public List<FileLink> getFileLinksByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASResourceDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportFileLinksToXML(List<FileLink> listFileLinks)  throws ASResourceDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportFileLinksToXML(String[] languages,List<FileLink> listFileLinks) throws ASResourceDataServiceException;
	/**
	 * Copies all multilingual fields from sourceLanguage to targetLanguage in all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public void copyMultilingualAttributesInAllObjects(String sourceLanguage, String targetLanguage) throws ASResourceDataServiceException;

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query) throws ASResourceDataServiceException;
	/**
	 * creates an xml element with all contained data.
	 */
	public XMLNode exportToXML() throws ASResourceDataServiceException;

	/**
	 * creates an xml element with all contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportToXML(String[] languages) throws ASResourceDataServiceException;
}
