/**
 ********************************************************************************
 *** ASSiteDataServiceImpl.java                                               ***
 *** The implementation of the IASSiteDataService.                            ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.assitedata.service;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.anodoc.data.Module;
import net.anotheria.anodoc.data.Property;
import net.anotheria.anodoc.data.NoSuchPropertyException;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.util.slicer.Segment;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.anosite.gen.assitedata.data.ModuleASSiteData;
import net.anotheria.anosite.gen.shared.service.BasicCMSService;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.asg.util.listener.IModuleListener;
import net.anotheria.anosite.gen.assitedata.data.PageTemplate;
import net.anotheria.anosite.gen.assitedata.data.PageTemplateXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.PageTemplateDocument;
import net.anotheria.anosite.gen.assitedata.data.MediaLink;
import net.anotheria.anosite.gen.assitedata.data.MediaLinkXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.MediaLinkDocument;
import net.anotheria.anosite.gen.assitedata.data.Script;
import net.anotheria.anosite.gen.assitedata.data.ScriptXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.ScriptDocument;
import net.anotheria.anosite.gen.assitedata.data.Site;
import net.anotheria.anosite.gen.assitedata.data.SiteXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.SiteDocument;
import net.anotheria.anosite.gen.assitedata.data.NaviItem;
import net.anotheria.anosite.gen.assitedata.data.NaviItemXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.NaviItemDocument;
import net.anotheria.anosite.gen.assitedata.data.EntryPoint;
import net.anotheria.anosite.gen.assitedata.data.EntryPointXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.EntryPointDocument;
import net.anotheria.anosite.gen.assitedata.data.PageAlias;
import net.anotheria.anosite.gen.assitedata.data.PageAliasXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.PageAliasDocument;
import net.anotheria.anosite.gen.assitedata.data.RedirectUrl;
import net.anotheria.anosite.gen.assitedata.data.RedirectUrlXMLHelper;
import net.anotheria.anosite.gen.assitedata.data.RedirectUrlDocument;

public class ASSiteDataServiceImpl extends BasicCMSService implements IASSiteDataService, IModuleListener{

	// Generated by: class net.anotheria.asg.generator.model.docs.CMSBasedServiceGenerator.generateImplementation

	private static ASSiteDataServiceImpl instance;

	private ASSiteDataServiceImpl(){
		addServiceListener(new net.anotheria.anosite.cms.listener.CRUDLogListener());
		addModuleListener(ModuleASSiteData.MODULE_ID, this);
	}

	static final ASSiteDataServiceImpl getInstance(){
		if (instance==null){
			instance = new ASSiteDataServiceImpl();
		}
		return instance;
	}

	private ModuleASSiteData _getModuleASSiteData(){
		return (ModuleASSiteData) getModule(ModuleASSiteData.MODULE_ID);
	}

	@Override
	public void moduleLoaded(Module module){
		firePersistenceChangedEvent();
	}

	@SuppressWarnings("unchecked")
	public List<PageTemplate> getPageTemplates(){
		List pagetemplates = new ArrayList();
		pagetemplates.addAll(_getModuleASSiteData().getPageTemplates());
		return pagetemplates;
	}

	public List<PageTemplate> getPageTemplates(SortType sortType){
		return StaticQuickSorter.sort(getPageTemplates(), sortType);
	}

	/**
	 * Returns the PageTemplate objects with the specified ids.
	 */
	public List<PageTemplate> getPageTemplates(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<PageTemplate>(0);
		List<PageTemplate> all = getPageTemplates();
		List<PageTemplate> ret = new ArrayList<PageTemplate>();
		for (PageTemplate pagetemplate : all){
			if(ids.contains(pagetemplate.getId())){
				ret.add(pagetemplate);
			}
		}
		return ret;
	}

	/**
	 * Returns the PageTemplate objects with the specified ids, sorted by given sorttype.
	 */
	public List<PageTemplate> getPageTemplates(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPageTemplates(ids), sortType);
	}

	public void deletePageTemplate(PageTemplate pagetemplate){
		deletePageTemplate(pagetemplate.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(pagetemplate);
		}
	}

	public void deletePageTemplate(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		PageTemplate varValue = hasServiceListeners()?module.getPageTemplate(id):null;
		module.deletePageTemplate(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePageTemplates(List<PageTemplate> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (PageTemplate pagetemplate : list){
			module.deletePageTemplate(pagetemplate.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public PageTemplate getPageTemplate(String id){
		return _getModuleASSiteData().getPageTemplate(id);
	}

	public PageTemplate importPageTemplate(PageTemplate pagetemplate){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importPageTemplate((PageTemplateDocument)pagetemplate);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(pagetemplate);
		}
		return pagetemplate;
	}

	public List<PageTemplate> importPageTemplates(List<PageTemplate> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<PageTemplate> ret = new ArrayList<PageTemplate>();
		for (PageTemplate pagetemplate : list){
			PageTemplate imported = module.importPageTemplate((PageTemplateDocument)pagetemplate);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageTemplate pagetemplate : ret)
				fireObjectImportedEvent(pagetemplate);
		}
		return ret;
	}

	public PageTemplate createPageTemplate(PageTemplate pagetemplate){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createPageTemplate((PageTemplateDocument)pagetemplate);
		updateModule(module);
		fireObjectCreatedEvent(pagetemplate);
		return pagetemplate;
	}

	/**
	 * Creates multiple new PageTemplate objects.
	 * Returns the created versions.
	 */
	public List<PageTemplate> createPageTemplates(List<PageTemplate> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<PageTemplate> ret = new ArrayList<PageTemplate>();
		for (PageTemplate pagetemplate : list){
			PageTemplate created = module.createPageTemplate((PageTemplateDocument)pagetemplate);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageTemplate pagetemplate : ret)
				fireObjectCreatedEvent(pagetemplate);
		}
		return ret;
	}

	public PageTemplate updatePageTemplate(PageTemplate pagetemplate){
		PageTemplate oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getPageTemplate(pagetemplate.getId());
		module.updatePageTemplate((PageTemplateDocument)pagetemplate);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, pagetemplate);
		}
		return pagetemplate;
	}

	public List<PageTemplate> updatePageTemplates(List<PageTemplate> list){
		List<PageTemplate> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<PageTemplate>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (PageTemplate pagetemplate : list){
			if (oldList!=null)
				oldList.add(module.getPageTemplate(pagetemplate.getId()));
			module.updatePageTemplate((PageTemplateDocument)pagetemplate);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<PageTemplate> getPageTemplatesByProperty(String propertyName, Object value){
		List<PageTemplate> allPageTemplates = getPageTemplates();
		List<PageTemplate> ret = new ArrayList<PageTemplate>();
		for (int i=0; i<allPageTemplates.size(); i++){
			PageTemplate pagetemplate = allPageTemplates.get(i);
			try{
				Property property = ((PageTemplateDocument)pagetemplate).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(pagetemplate);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(pagetemplate);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(pagetemplate);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<PageTemplate> getPageTemplatesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPageTemplatesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on PageTemplates
	 */
	public QueryResult executeQueryOnPageTemplates(DocumentQuery query){
		List<PageTemplate> allPageTemplates = getPageTemplates();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPageTemplates.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPageTemplates.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all PageTemplate objects, where property matches.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<PageTemplate> ret = new ArrayList<PageTemplate>();
		List<PageTemplate> src = getPageTemplates();
		for ( PageTemplate pagetemplate : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(pagetemplate.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagetemplate);
		}
		return ret;
	}

	/**
	 * Returns all PageTemplate objects, where property matches, sorted
	 */
	public List<PageTemplate> getPageTemplatesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPageTemplatesByProperty(property), sortType);
	}

	/**
	 * Returns PageTemplate objects count.
	 */
	public int getPageTemplatesCount() {
		return _getModuleASSiteData().getPageTemplates().size();
	}

	/**
	 * Returns PageTemplate objects segment.
	 */
	public List<PageTemplate> getPageTemplates(Segment aSegment) {
		return Slicer.slice(aSegment, getPageTemplates()).getSliceData();
	}

	/**
	 * Returns PageTemplate objects segment, where property matched.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<PageTemplate> ret = new ArrayList<PageTemplate>();
		List<PageTemplate> src = getPageTemplates();
		for (PageTemplate pagetemplate : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(pagetemplate.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagetemplate);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns PageTemplate objects segment, where property matched, sorted.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPageTemplatesByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<MediaLink> getMediaLinks(){
		List medialinks = new ArrayList();
		medialinks.addAll(_getModuleASSiteData().getMediaLinks());
		return medialinks;
	}

	public List<MediaLink> getMediaLinks(SortType sortType){
		return StaticQuickSorter.sort(getMediaLinks(), sortType);
	}

	/**
	 * Returns the MediaLink objects with the specified ids.
	 */
	public List<MediaLink> getMediaLinks(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<MediaLink>(0);
		List<MediaLink> all = getMediaLinks();
		List<MediaLink> ret = new ArrayList<MediaLink>();
		for (MediaLink medialink : all){
			if(ids.contains(medialink.getId())){
				ret.add(medialink);
			}
		}
		return ret;
	}

	/**
	 * Returns the MediaLink objects with the specified ids, sorted by given sorttype.
	 */
	public List<MediaLink> getMediaLinks(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getMediaLinks(ids), sortType);
	}

	public void deleteMediaLink(MediaLink medialink){
		deleteMediaLink(medialink.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(medialink);
		}
	}

	public void deleteMediaLink(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		MediaLink varValue = hasServiceListeners()?module.getMediaLink(id):null;
		module.deleteMediaLink(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteMediaLinks(List<MediaLink> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (MediaLink medialink : list){
			module.deleteMediaLink(medialink.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public MediaLink getMediaLink(String id){
		return _getModuleASSiteData().getMediaLink(id);
	}

	public MediaLink importMediaLink(MediaLink medialink){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importMediaLink((MediaLinkDocument)medialink);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(medialink);
		}
		return medialink;
	}

	public List<MediaLink> importMediaLinks(List<MediaLink> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<MediaLink> ret = new ArrayList<MediaLink>();
		for (MediaLink medialink : list){
			MediaLink imported = module.importMediaLink((MediaLinkDocument)medialink);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (MediaLink medialink : ret)
				fireObjectImportedEvent(medialink);
		}
		return ret;
	}

	public MediaLink createMediaLink(MediaLink medialink){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createMediaLink((MediaLinkDocument)medialink);
		updateModule(module);
		fireObjectCreatedEvent(medialink);
		return medialink;
	}

	/**
	 * Creates multiple new MediaLink objects.
	 * Returns the created versions.
	 */
	public List<MediaLink> createMediaLinks(List<MediaLink> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<MediaLink> ret = new ArrayList<MediaLink>();
		for (MediaLink medialink : list){
			MediaLink created = module.createMediaLink((MediaLinkDocument)medialink);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (MediaLink medialink : ret)
				fireObjectCreatedEvent(medialink);
		}
		return ret;
	}

	public MediaLink updateMediaLink(MediaLink medialink){
		MediaLink oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getMediaLink(medialink.getId());
		module.updateMediaLink((MediaLinkDocument)medialink);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, medialink);
		}
		return medialink;
	}

	public List<MediaLink> updateMediaLinks(List<MediaLink> list){
		List<MediaLink> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<MediaLink>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (MediaLink medialink : list){
			if (oldList!=null)
				oldList.add(module.getMediaLink(medialink.getId()));
			module.updateMediaLink((MediaLinkDocument)medialink);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<MediaLink> getMediaLinksByProperty(String propertyName, Object value){
		List<MediaLink> allMediaLinks = getMediaLinks();
		List<MediaLink> ret = new ArrayList<MediaLink>();
		for (int i=0; i<allMediaLinks.size(); i++){
			MediaLink medialink = allMediaLinks.get(i);
			try{
				Property property = ((MediaLinkDocument)medialink).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(medialink);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(medialink);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(medialink);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<MediaLink> getMediaLinksByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getMediaLinksByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on MediaLinks
	 */
	public QueryResult executeQueryOnMediaLinks(DocumentQuery query){
		List<MediaLink> allMediaLinks = getMediaLinks();
		QueryResult result = new QueryResult();
		for (int i=0; i<allMediaLinks.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allMediaLinks.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all MediaLink objects, where property matches.
	 */
	public List<MediaLink> getMediaLinksByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<MediaLink> ret = new ArrayList<MediaLink>();
		List<MediaLink> src = getMediaLinks();
		for ( MediaLink medialink : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(medialink.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(medialink);
		}
		return ret;
	}

	/**
	 * Returns all MediaLink objects, where property matches, sorted
	 */
	public List<MediaLink> getMediaLinksByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getMediaLinksByProperty(property), sortType);
	}

	/**
	 * Returns MediaLink objects count.
	 */
	public int getMediaLinksCount() {
		return _getModuleASSiteData().getMediaLinks().size();
	}

	/**
	 * Returns MediaLink objects segment.
	 */
	public List<MediaLink> getMediaLinks(Segment aSegment) {
		return Slicer.slice(aSegment, getMediaLinks()).getSliceData();
	}

	/**
	 * Returns MediaLink objects segment, where property matched.
	 */
	public List<MediaLink> getMediaLinksByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<MediaLink> ret = new ArrayList<MediaLink>();
		List<MediaLink> src = getMediaLinks();
		for (MediaLink medialink : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(medialink.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(medialink);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns MediaLink objects segment, where property matched, sorted.
	 */
	public List<MediaLink> getMediaLinksByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getMediaLinksByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Script> getScripts(){
		List scripts = new ArrayList();
		scripts.addAll(_getModuleASSiteData().getScripts());
		return scripts;
	}

	public List<Script> getScripts(SortType sortType){
		return StaticQuickSorter.sort(getScripts(), sortType);
	}

	/**
	 * Returns the Script objects with the specified ids.
	 */
	public List<Script> getScripts(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Script>(0);
		List<Script> all = getScripts();
		List<Script> ret = new ArrayList<Script>();
		for (Script script : all){
			if(ids.contains(script.getId())){
				ret.add(script);
			}
		}
		return ret;
	}

	/**
	 * Returns the Script objects with the specified ids, sorted by given sorttype.
	 */
	public List<Script> getScripts(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getScripts(ids), sortType);
	}

	public void deleteScript(Script script){
		deleteScript(script.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(script);
		}
	}

	public void deleteScript(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		Script varValue = hasServiceListeners()?module.getScript(id):null;
		module.deleteScript(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteScripts(List<Script> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (Script script : list){
			module.deleteScript(script.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Script getScript(String id){
		return _getModuleASSiteData().getScript(id);
	}

	public Script importScript(Script script){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importScript((ScriptDocument)script);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(script);
		}
		return script;
	}

	public List<Script> importScripts(List<Script> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<Script> ret = new ArrayList<Script>();
		for (Script script : list){
			Script imported = module.importScript((ScriptDocument)script);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Script script : ret)
				fireObjectImportedEvent(script);
		}
		return ret;
	}

	public Script createScript(Script script){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createScript((ScriptDocument)script);
		updateModule(module);
		fireObjectCreatedEvent(script);
		return script;
	}

	/**
	 * Creates multiple new Script objects.
	 * Returns the created versions.
	 */
	public List<Script> createScripts(List<Script> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<Script> ret = new ArrayList<Script>();
		for (Script script : list){
			Script created = module.createScript((ScriptDocument)script);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Script script : ret)
				fireObjectCreatedEvent(script);
		}
		return ret;
	}

	public Script updateScript(Script script){
		Script oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getScript(script.getId());
		module.updateScript((ScriptDocument)script);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, script);
		}
		return script;
	}

	public List<Script> updateScripts(List<Script> list){
		List<Script> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Script>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (Script script : list){
			if (oldList!=null)
				oldList.add(module.getScript(script.getId()));
			module.updateScript((ScriptDocument)script);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Script> getScriptsByProperty(String propertyName, Object value){
		List<Script> allScripts = getScripts();
		List<Script> ret = new ArrayList<Script>();
		for (int i=0; i<allScripts.size(); i++){
			Script script = allScripts.get(i);
			try{
				Property property = ((ScriptDocument)script).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(script);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(script);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(script);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Script> getScriptsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getScriptsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Scripts
	 */
	public QueryResult executeQueryOnScripts(DocumentQuery query){
		List<Script> allScripts = getScripts();
		QueryResult result = new QueryResult();
		for (int i=0; i<allScripts.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allScripts.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Script objects, where property matches.
	 */
	public List<Script> getScriptsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Script> ret = new ArrayList<Script>();
		List<Script> src = getScripts();
		for ( Script script : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(script.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(script);
		}
		return ret;
	}

	/**
	 * Returns all Script objects, where property matches, sorted
	 */
	public List<Script> getScriptsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getScriptsByProperty(property), sortType);
	}

	/**
	 * Returns Script objects count.
	 */
	public int getScriptsCount() {
		return _getModuleASSiteData().getScripts().size();
	}

	/**
	 * Returns Script objects segment.
	 */
	public List<Script> getScripts(Segment aSegment) {
		return Slicer.slice(aSegment, getScripts()).getSliceData();
	}

	/**
	 * Returns Script objects segment, where property matched.
	 */
	public List<Script> getScriptsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Script> ret = new ArrayList<Script>();
		List<Script> src = getScripts();
		for (Script script : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(script.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(script);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Script objects segment, where property matched, sorted.
	 */
	public List<Script> getScriptsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getScriptsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<Site> getSites(){
		List sites = new ArrayList();
		sites.addAll(_getModuleASSiteData().getSites());
		return sites;
	}

	public List<Site> getSites(SortType sortType){
		return StaticQuickSorter.sort(getSites(), sortType);
	}

	/**
	 * Returns the Site objects with the specified ids.
	 */
	public List<Site> getSites(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Site>(0);
		List<Site> all = getSites();
		List<Site> ret = new ArrayList<Site>();
		for (Site site : all){
			if(ids.contains(site.getId())){
				ret.add(site);
			}
		}
		return ret;
	}

	/**
	 * Returns the Site objects with the specified ids, sorted by given sorttype.
	 */
	public List<Site> getSites(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getSites(ids), sortType);
	}

	public void deleteSite(Site site){
		deleteSite(site.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(site);
		}
	}

	public void deleteSite(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		Site varValue = hasServiceListeners()?module.getSite(id):null;
		module.deleteSite(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteSites(List<Site> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (Site site : list){
			module.deleteSite(site.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Site getSite(String id){
		return _getModuleASSiteData().getSite(id);
	}

	public Site importSite(Site site){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importSite((SiteDocument)site);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(site);
		}
		return site;
	}

	public List<Site> importSites(List<Site> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<Site> ret = new ArrayList<Site>();
		for (Site site : list){
			Site imported = module.importSite((SiteDocument)site);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Site site : ret)
				fireObjectImportedEvent(site);
		}
		return ret;
	}

	public Site createSite(Site site){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createSite((SiteDocument)site);
		updateModule(module);
		fireObjectCreatedEvent(site);
		return site;
	}

	/**
	 * Creates multiple new Site objects.
	 * Returns the created versions.
	 */
	public List<Site> createSites(List<Site> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<Site> ret = new ArrayList<Site>();
		for (Site site : list){
			Site created = module.createSite((SiteDocument)site);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Site site : ret)
				fireObjectCreatedEvent(site);
		}
		return ret;
	}

	public Site updateSite(Site site){
		Site oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getSite(site.getId());
		module.updateSite((SiteDocument)site);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, site);
		}
		return site;
	}

	public List<Site> updateSites(List<Site> list){
		List<Site> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Site>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (Site site : list){
			if (oldList!=null)
				oldList.add(module.getSite(site.getId()));
			module.updateSite((SiteDocument)site);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Site> getSitesByProperty(String propertyName, Object value){
		List<Site> allSites = getSites();
		List<Site> ret = new ArrayList<Site>();
		for (int i=0; i<allSites.size(); i++){
			Site site = allSites.get(i);
			try{
				Property property = ((SiteDocument)site).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(site);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(site);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(site);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Site> getSitesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getSitesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Sites
	 */
	public QueryResult executeQueryOnSites(DocumentQuery query){
		List<Site> allSites = getSites();
		QueryResult result = new QueryResult();
		for (int i=0; i<allSites.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allSites.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Site objects, where property matches.
	 */
	public List<Site> getSitesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Site> ret = new ArrayList<Site>();
		List<Site> src = getSites();
		for ( Site site : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(site.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(site);
		}
		return ret;
	}

	/**
	 * Returns all Site objects, where property matches, sorted
	 */
	public List<Site> getSitesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getSitesByProperty(property), sortType);
	}

	/**
	 * Returns Site objects count.
	 */
	public int getSitesCount() {
		return _getModuleASSiteData().getSites().size();
	}

	/**
	 * Returns Site objects segment.
	 */
	public List<Site> getSites(Segment aSegment) {
		return Slicer.slice(aSegment, getSites()).getSliceData();
	}

	/**
	 * Returns Site objects segment, where property matched.
	 */
	public List<Site> getSitesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Site> ret = new ArrayList<Site>();
		List<Site> src = getSites();
		for (Site site : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(site.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(site);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Site objects segment, where property matched, sorted.
	 */
	public List<Site> getSitesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getSitesByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllSites(String sourceLanguage, String targetLanguage){
		List<Site> allDocumentsSrc = getSites();
		List<Site> allDocuments = new ArrayList<Site>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (Site document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateSites(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<NaviItem> getNaviItems(){
		List naviitems = new ArrayList();
		naviitems.addAll(_getModuleASSiteData().getNaviItems());
		return naviitems;
	}

	public List<NaviItem> getNaviItems(SortType sortType){
		return StaticQuickSorter.sort(getNaviItems(), sortType);
	}

	/**
	 * Returns the NaviItem objects with the specified ids.
	 */
	public List<NaviItem> getNaviItems(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<NaviItem>(0);
		List<NaviItem> all = getNaviItems();
		List<NaviItem> ret = new ArrayList<NaviItem>();
		for (NaviItem naviitem : all){
			if(ids.contains(naviitem.getId())){
				ret.add(naviitem);
			}
		}
		return ret;
	}

	/**
	 * Returns the NaviItem objects with the specified ids, sorted by given sorttype.
	 */
	public List<NaviItem> getNaviItems(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getNaviItems(ids), sortType);
	}

	public void deleteNaviItem(NaviItem naviitem){
		deleteNaviItem(naviitem.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(naviitem);
		}
	}

	public void deleteNaviItem(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		NaviItem varValue = hasServiceListeners()?module.getNaviItem(id):null;
		module.deleteNaviItem(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteNaviItems(List<NaviItem> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (NaviItem naviitem : list){
			module.deleteNaviItem(naviitem.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public NaviItem getNaviItem(String id){
		return _getModuleASSiteData().getNaviItem(id);
	}

	public NaviItem importNaviItem(NaviItem naviitem){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importNaviItem((NaviItemDocument)naviitem);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(naviitem);
		}
		return naviitem;
	}

	public List<NaviItem> importNaviItems(List<NaviItem> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<NaviItem> ret = new ArrayList<NaviItem>();
		for (NaviItem naviitem : list){
			NaviItem imported = module.importNaviItem((NaviItemDocument)naviitem);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (NaviItem naviitem : ret)
				fireObjectImportedEvent(naviitem);
		}
		return ret;
	}

	public NaviItem createNaviItem(NaviItem naviitem){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createNaviItem((NaviItemDocument)naviitem);
		updateModule(module);
		fireObjectCreatedEvent(naviitem);
		return naviitem;
	}

	/**
	 * Creates multiple new NaviItem objects.
	 * Returns the created versions.
	 */
	public List<NaviItem> createNaviItems(List<NaviItem> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<NaviItem> ret = new ArrayList<NaviItem>();
		for (NaviItem naviitem : list){
			NaviItem created = module.createNaviItem((NaviItemDocument)naviitem);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (NaviItem naviitem : ret)
				fireObjectCreatedEvent(naviitem);
		}
		return ret;
	}

	public NaviItem updateNaviItem(NaviItem naviitem){
		NaviItem oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getNaviItem(naviitem.getId());
		module.updateNaviItem((NaviItemDocument)naviitem);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, naviitem);
		}
		return naviitem;
	}

	public List<NaviItem> updateNaviItems(List<NaviItem> list){
		List<NaviItem> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<NaviItem>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (NaviItem naviitem : list){
			if (oldList!=null)
				oldList.add(module.getNaviItem(naviitem.getId()));
			module.updateNaviItem((NaviItemDocument)naviitem);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<NaviItem> getNaviItemsByProperty(String propertyName, Object value){
		List<NaviItem> allNaviItems = getNaviItems();
		List<NaviItem> ret = new ArrayList<NaviItem>();
		for (int i=0; i<allNaviItems.size(); i++){
			NaviItem naviitem = allNaviItems.get(i);
			try{
				Property property = ((NaviItemDocument)naviitem).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(naviitem);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(naviitem);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(naviitem);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<NaviItem> getNaviItemsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getNaviItemsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on NaviItems
	 */
	public QueryResult executeQueryOnNaviItems(DocumentQuery query){
		List<NaviItem> allNaviItems = getNaviItems();
		QueryResult result = new QueryResult();
		for (int i=0; i<allNaviItems.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allNaviItems.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all NaviItem objects, where property matches.
	 */
	public List<NaviItem> getNaviItemsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<NaviItem> ret = new ArrayList<NaviItem>();
		List<NaviItem> src = getNaviItems();
		for ( NaviItem naviitem : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(naviitem.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(naviitem);
		}
		return ret;
	}

	/**
	 * Returns all NaviItem objects, where property matches, sorted
	 */
	public List<NaviItem> getNaviItemsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getNaviItemsByProperty(property), sortType);
	}

	/**
	 * Returns NaviItem objects count.
	 */
	public int getNaviItemsCount() {
		return _getModuleASSiteData().getNaviItems().size();
	}

	/**
	 * Returns NaviItem objects segment.
	 */
	public List<NaviItem> getNaviItems(Segment aSegment) {
		return Slicer.slice(aSegment, getNaviItems()).getSliceData();
	}

	/**
	 * Returns NaviItem objects segment, where property matched.
	 */
	public List<NaviItem> getNaviItemsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<NaviItem> ret = new ArrayList<NaviItem>();
		List<NaviItem> src = getNaviItems();
		for (NaviItem naviitem : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(naviitem.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(naviitem);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns NaviItem objects segment, where property matched, sorted.
	 */
	public List<NaviItem> getNaviItemsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getNaviItemsByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllNaviItems(String sourceLanguage, String targetLanguage){
		List<NaviItem> allDocumentsSrc = getNaviItems();
		List<NaviItem> allDocuments = new ArrayList<NaviItem>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (NaviItem document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateNaviItems(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<EntryPoint> getEntryPoints(){
		List entrypoints = new ArrayList();
		entrypoints.addAll(_getModuleASSiteData().getEntryPoints());
		return entrypoints;
	}

	public List<EntryPoint> getEntryPoints(SortType sortType){
		return StaticQuickSorter.sort(getEntryPoints(), sortType);
	}

	/**
	 * Returns the EntryPoint objects with the specified ids.
	 */
	public List<EntryPoint> getEntryPoints(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<EntryPoint>(0);
		List<EntryPoint> all = getEntryPoints();
		List<EntryPoint> ret = new ArrayList<EntryPoint>();
		for (EntryPoint entrypoint : all){
			if(ids.contains(entrypoint.getId())){
				ret.add(entrypoint);
			}
		}
		return ret;
	}

	/**
	 * Returns the EntryPoint objects with the specified ids, sorted by given sorttype.
	 */
	public List<EntryPoint> getEntryPoints(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getEntryPoints(ids), sortType);
	}

	public void deleteEntryPoint(EntryPoint entrypoint){
		deleteEntryPoint(entrypoint.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(entrypoint);
		}
	}

	public void deleteEntryPoint(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		EntryPoint varValue = hasServiceListeners()?module.getEntryPoint(id):null;
		module.deleteEntryPoint(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteEntryPoints(List<EntryPoint> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (EntryPoint entrypoint : list){
			module.deleteEntryPoint(entrypoint.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public EntryPoint getEntryPoint(String id){
		return _getModuleASSiteData().getEntryPoint(id);
	}

	public EntryPoint importEntryPoint(EntryPoint entrypoint){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importEntryPoint((EntryPointDocument)entrypoint);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(entrypoint);
		}
		return entrypoint;
	}

	public List<EntryPoint> importEntryPoints(List<EntryPoint> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<EntryPoint> ret = new ArrayList<EntryPoint>();
		for (EntryPoint entrypoint : list){
			EntryPoint imported = module.importEntryPoint((EntryPointDocument)entrypoint);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (EntryPoint entrypoint : ret)
				fireObjectImportedEvent(entrypoint);
		}
		return ret;
	}

	public EntryPoint createEntryPoint(EntryPoint entrypoint){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createEntryPoint((EntryPointDocument)entrypoint);
		updateModule(module);
		fireObjectCreatedEvent(entrypoint);
		return entrypoint;
	}

	/**
	 * Creates multiple new EntryPoint objects.
	 * Returns the created versions.
	 */
	public List<EntryPoint> createEntryPoints(List<EntryPoint> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<EntryPoint> ret = new ArrayList<EntryPoint>();
		for (EntryPoint entrypoint : list){
			EntryPoint created = module.createEntryPoint((EntryPointDocument)entrypoint);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (EntryPoint entrypoint : ret)
				fireObjectCreatedEvent(entrypoint);
		}
		return ret;
	}

	public EntryPoint updateEntryPoint(EntryPoint entrypoint){
		EntryPoint oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getEntryPoint(entrypoint.getId());
		module.updateEntryPoint((EntryPointDocument)entrypoint);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, entrypoint);
		}
		return entrypoint;
	}

	public List<EntryPoint> updateEntryPoints(List<EntryPoint> list){
		List<EntryPoint> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<EntryPoint>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (EntryPoint entrypoint : list){
			if (oldList!=null)
				oldList.add(module.getEntryPoint(entrypoint.getId()));
			module.updateEntryPoint((EntryPointDocument)entrypoint);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<EntryPoint> getEntryPointsByProperty(String propertyName, Object value){
		List<EntryPoint> allEntryPoints = getEntryPoints();
		List<EntryPoint> ret = new ArrayList<EntryPoint>();
		for (int i=0; i<allEntryPoints.size(); i++){
			EntryPoint entrypoint = allEntryPoints.get(i);
			try{
				Property property = ((EntryPointDocument)entrypoint).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(entrypoint);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(entrypoint);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(entrypoint);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<EntryPoint> getEntryPointsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getEntryPointsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on EntryPoints
	 */
	public QueryResult executeQueryOnEntryPoints(DocumentQuery query){
		List<EntryPoint> allEntryPoints = getEntryPoints();
		QueryResult result = new QueryResult();
		for (int i=0; i<allEntryPoints.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allEntryPoints.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all EntryPoint objects, where property matches.
	 */
	public List<EntryPoint> getEntryPointsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<EntryPoint> ret = new ArrayList<EntryPoint>();
		List<EntryPoint> src = getEntryPoints();
		for ( EntryPoint entrypoint : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(entrypoint.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(entrypoint);
		}
		return ret;
	}

	/**
	 * Returns all EntryPoint objects, where property matches, sorted
	 */
	public List<EntryPoint> getEntryPointsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getEntryPointsByProperty(property), sortType);
	}

	/**
	 * Returns EntryPoint objects count.
	 */
	public int getEntryPointsCount() {
		return _getModuleASSiteData().getEntryPoints().size();
	}

	/**
	 * Returns EntryPoint objects segment.
	 */
	public List<EntryPoint> getEntryPoints(Segment aSegment) {
		return Slicer.slice(aSegment, getEntryPoints()).getSliceData();
	}

	/**
	 * Returns EntryPoint objects segment, where property matched.
	 */
	public List<EntryPoint> getEntryPointsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<EntryPoint> ret = new ArrayList<EntryPoint>();
		List<EntryPoint> src = getEntryPoints();
		for (EntryPoint entrypoint : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(entrypoint.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(entrypoint);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns EntryPoint objects segment, where property matched, sorted.
	 */
	public List<EntryPoint> getEntryPointsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getEntryPointsByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<PageAlias> getPageAliass(){
		List pagealiass = new ArrayList();
		pagealiass.addAll(_getModuleASSiteData().getPageAliass());
		return pagealiass;
	}

	public List<PageAlias> getPageAliass(SortType sortType){
		return StaticQuickSorter.sort(getPageAliass(), sortType);
	}

	/**
	 * Returns the PageAlias objects with the specified ids.
	 */
	public List<PageAlias> getPageAliass(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<PageAlias>(0);
		List<PageAlias> all = getPageAliass();
		List<PageAlias> ret = new ArrayList<PageAlias>();
		for (PageAlias pagealias : all){
			if(ids.contains(pagealias.getId())){
				ret.add(pagealias);
			}
		}
		return ret;
	}

	/**
	 * Returns the PageAlias objects with the specified ids, sorted by given sorttype.
	 */
	public List<PageAlias> getPageAliass(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPageAliass(ids), sortType);
	}

	public void deletePageAlias(PageAlias pagealias){
		deletePageAlias(pagealias.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(pagealias);
		}
	}

	public void deletePageAlias(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		PageAlias varValue = hasServiceListeners()?module.getPageAlias(id):null;
		module.deletePageAlias(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePageAliass(List<PageAlias> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (PageAlias pagealias : list){
			module.deletePageAlias(pagealias.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public PageAlias getPageAlias(String id){
		return _getModuleASSiteData().getPageAlias(id);
	}

	public PageAlias importPageAlias(PageAlias pagealias){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importPageAlias((PageAliasDocument)pagealias);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(pagealias);
		}
		return pagealias;
	}

	public List<PageAlias> importPageAliass(List<PageAlias> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<PageAlias> ret = new ArrayList<PageAlias>();
		for (PageAlias pagealias : list){
			PageAlias imported = module.importPageAlias((PageAliasDocument)pagealias);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageAlias pagealias : ret)
				fireObjectImportedEvent(pagealias);
		}
		return ret;
	}

	public PageAlias createPageAlias(PageAlias pagealias){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createPageAlias((PageAliasDocument)pagealias);
		updateModule(module);
		fireObjectCreatedEvent(pagealias);
		return pagealias;
	}

	/**
	 * Creates multiple new PageAlias objects.
	 * Returns the created versions.
	 */
	public List<PageAlias> createPageAliass(List<PageAlias> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<PageAlias> ret = new ArrayList<PageAlias>();
		for (PageAlias pagealias : list){
			PageAlias created = module.createPageAlias((PageAliasDocument)pagealias);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (PageAlias pagealias : ret)
				fireObjectCreatedEvent(pagealias);
		}
		return ret;
	}

	public PageAlias updatePageAlias(PageAlias pagealias){
		PageAlias oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getPageAlias(pagealias.getId());
		module.updatePageAlias((PageAliasDocument)pagealias);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, pagealias);
		}
		return pagealias;
	}

	public List<PageAlias> updatePageAliass(List<PageAlias> list){
		List<PageAlias> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<PageAlias>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (PageAlias pagealias : list){
			if (oldList!=null)
				oldList.add(module.getPageAlias(pagealias.getId()));
			module.updatePageAlias((PageAliasDocument)pagealias);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<PageAlias> getPageAliassByProperty(String propertyName, Object value){
		List<PageAlias> allPageAliass = getPageAliass();
		List<PageAlias> ret = new ArrayList<PageAlias>();
		for (int i=0; i<allPageAliass.size(); i++){
			PageAlias pagealias = allPageAliass.get(i);
			try{
				Property property = ((PageAliasDocument)pagealias).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(pagealias);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(pagealias);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(pagealias);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<PageAlias> getPageAliassByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPageAliassByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on PageAliass
	 */
	public QueryResult executeQueryOnPageAliass(DocumentQuery query){
		List<PageAlias> allPageAliass = getPageAliass();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPageAliass.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPageAliass.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all PageAlias objects, where property matches.
	 */
	public List<PageAlias> getPageAliassByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<PageAlias> ret = new ArrayList<PageAlias>();
		List<PageAlias> src = getPageAliass();
		for ( PageAlias pagealias : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(pagealias.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagealias);
		}
		return ret;
	}

	/**
	 * Returns all PageAlias objects, where property matches, sorted
	 */
	public List<PageAlias> getPageAliassByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPageAliassByProperty(property), sortType);
	}

	/**
	 * Returns PageAlias objects count.
	 */
	public int getPageAliassCount() {
		return _getModuleASSiteData().getPageAliass().size();
	}

	/**
	 * Returns PageAlias objects segment.
	 */
	public List<PageAlias> getPageAliass(Segment aSegment) {
		return Slicer.slice(aSegment, getPageAliass()).getSliceData();
	}

	/**
	 * Returns PageAlias objects segment, where property matched.
	 */
	public List<PageAlias> getPageAliassByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<PageAlias> ret = new ArrayList<PageAlias>();
		List<PageAlias> src = getPageAliass();
		for (PageAlias pagealias : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(pagealias.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagealias);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns PageAlias objects segment, where property matched, sorted.
	 */
	public List<PageAlias> getPageAliassByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPageAliassByProperty(aSegment, aProperty), aSortType);
	}

	@SuppressWarnings("unchecked")
	public List<RedirectUrl> getRedirectUrls(){
		List redirecturls = new ArrayList();
		redirecturls.addAll(_getModuleASSiteData().getRedirectUrls());
		return redirecturls;
	}

	public List<RedirectUrl> getRedirectUrls(SortType sortType){
		return StaticQuickSorter.sort(getRedirectUrls(), sortType);
	}

	/**
	 * Returns the RedirectUrl objects with the specified ids.
	 */
	public List<RedirectUrl> getRedirectUrls(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<RedirectUrl>(0);
		List<RedirectUrl> all = getRedirectUrls();
		List<RedirectUrl> ret = new ArrayList<RedirectUrl>();
		for (RedirectUrl redirecturl : all){
			if(ids.contains(redirecturl.getId())){
				ret.add(redirecturl);
			}
		}
		return ret;
	}

	/**
	 * Returns the RedirectUrl objects with the specified ids, sorted by given sorttype.
	 */
	public List<RedirectUrl> getRedirectUrls(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getRedirectUrls(ids), sortType);
	}

	public void deleteRedirectUrl(RedirectUrl redirecturl){
		deleteRedirectUrl(redirecturl.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(redirecturl);
		}
	}

	public void deleteRedirectUrl(String id){
		ModuleASSiteData module = _getModuleASSiteData();
		RedirectUrl varValue = hasServiceListeners()?module.getRedirectUrl(id):null;
		module.deleteRedirectUrl(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteRedirectUrls(List<RedirectUrl> list){
		ModuleASSiteData module = _getModuleASSiteData();
		for (RedirectUrl redirecturl : list){
			module.deleteRedirectUrl(redirecturl.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public RedirectUrl getRedirectUrl(String id){
		return _getModuleASSiteData().getRedirectUrl(id);
	}

	public RedirectUrl importRedirectUrl(RedirectUrl redirecturl){
		ModuleASSiteData module = _getModuleASSiteData();
		module.importRedirectUrl((RedirectUrlDocument)redirecturl);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(redirecturl);
		}
		return redirecturl;
	}

	public List<RedirectUrl> importRedirectUrls(List<RedirectUrl> list){
		ModuleASSiteData module = _getModuleASSiteData();
		List<RedirectUrl> ret = new ArrayList<RedirectUrl>();
		for (RedirectUrl redirecturl : list){
			RedirectUrl imported = module.importRedirectUrl((RedirectUrlDocument)redirecturl);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (RedirectUrl redirecturl : ret)
				fireObjectImportedEvent(redirecturl);
		}
		return ret;
	}

	public RedirectUrl createRedirectUrl(RedirectUrl redirecturl){
		ModuleASSiteData module = _getModuleASSiteData();
		module.createRedirectUrl((RedirectUrlDocument)redirecturl);
		updateModule(module);
		fireObjectCreatedEvent(redirecturl);
		return redirecturl;
	}

	/**
	 * Creates multiple new RedirectUrl objects.
	 * Returns the created versions.
	 */
	public List<RedirectUrl> createRedirectUrls(List<RedirectUrl> list){;
		ModuleASSiteData module = _getModuleASSiteData();
		List<RedirectUrl> ret = new ArrayList<RedirectUrl>();
		for (RedirectUrl redirecturl : list){
			RedirectUrl created = module.createRedirectUrl((RedirectUrlDocument)redirecturl);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (RedirectUrl redirecturl : ret)
				fireObjectCreatedEvent(redirecturl);
		}
		return ret;
	}

	public RedirectUrl updateRedirectUrl(RedirectUrl redirecturl){
		RedirectUrl oldVersion = null;
		ModuleASSiteData module = _getModuleASSiteData();
		if (hasServiceListeners())
			oldVersion = module.getRedirectUrl(redirecturl.getId());
		module.updateRedirectUrl((RedirectUrlDocument)redirecturl);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, redirecturl);
		}
		return redirecturl;
	}

	public List<RedirectUrl> updateRedirectUrls(List<RedirectUrl> list){
		List<RedirectUrl> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<RedirectUrl>(list.size());
		ModuleASSiteData module = _getModuleASSiteData();
		for (RedirectUrl redirecturl : list){
			if (oldList!=null)
				oldList.add(module.getRedirectUrl(redirecturl.getId()));
			module.updateRedirectUrl((RedirectUrlDocument)redirecturl);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<RedirectUrl> getRedirectUrlsByProperty(String propertyName, Object value){
		List<RedirectUrl> allRedirectUrls = getRedirectUrls();
		List<RedirectUrl> ret = new ArrayList<RedirectUrl>();
		for (int i=0; i<allRedirectUrls.size(); i++){
			RedirectUrl redirecturl = allRedirectUrls.get(i);
			try{
				Property property = ((RedirectUrlDocument)redirecturl).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(redirecturl);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(redirecturl);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(redirecturl);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<RedirectUrl> getRedirectUrlsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getRedirectUrlsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on RedirectUrls
	 */
	public QueryResult executeQueryOnRedirectUrls(DocumentQuery query){
		List<RedirectUrl> allRedirectUrls = getRedirectUrls();
		QueryResult result = new QueryResult();
		for (int i=0; i<allRedirectUrls.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allRedirectUrls.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all RedirectUrl objects, where property matches.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<RedirectUrl> ret = new ArrayList<RedirectUrl>();
		List<RedirectUrl> src = getRedirectUrls();
		for ( RedirectUrl redirecturl : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(redirecturl.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(redirecturl);
		}
		return ret;
	}

	/**
	 * Returns all RedirectUrl objects, where property matches, sorted
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getRedirectUrlsByProperty(property), sortType);
	}

	/**
	 * Returns RedirectUrl objects count.
	 */
	public int getRedirectUrlsCount() {
		return _getModuleASSiteData().getRedirectUrls().size();
	}

	/**
	 * Returns RedirectUrl objects segment.
	 */
	public List<RedirectUrl> getRedirectUrls(Segment aSegment) {
		return Slicer.slice(aSegment, getRedirectUrls()).getSliceData();
	}

	/**
	 * Returns RedirectUrl objects segment, where property matched.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<RedirectUrl> ret = new ArrayList<RedirectUrl>();
		List<RedirectUrl> src = getRedirectUrls();
		for (RedirectUrl redirecturl : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(redirecturl.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(redirecturl);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns RedirectUrl objects segment, where property matched, sorted.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getRedirectUrlsByProperty(aSegment, aProperty), aSortType);
	}

	/**
	 * Copies all multilingual fields from sourceLanguage to targetLanguage in all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public void copyMultilingualAttributesInAllObjects(String sourceLanguage, String targetLanguage){
		copyMultilingualAttributesInAllSites(sourceLanguage, targetLanguage);
		copyMultilingualAttributesInAllNaviItems(sourceLanguage, targetLanguage);
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query){
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnPageTemplates(query).getEntries());
		ret.add(executeQueryOnMediaLinks(query).getEntries());
		ret.add(executeQueryOnScripts(query).getEntries());
		ret.add(executeQueryOnSites(query).getEntries());
		ret.add(executeQueryOnNaviItems(query).getEntries());
		ret.add(executeQueryOnEntryPoints(query).getEntries());
		ret.add(executeQueryOnPageAliass(query).getEntries());
		ret.add(executeQueryOnRedirectUrls(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects


	public XMLNode exportPageTemplatesToXML(){;
		XMLNode ret = new XMLNode("PageTemplates");
		List<PageTemplate> list = getPageTemplates();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageTemplate object : list)
			ret.addChildNode(PageTemplateXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageTemplatesToXML(List<PageTemplate> list){;
		XMLNode ret = new XMLNode("PageTemplates");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageTemplate object : list)
			ret.addChildNode(PageTemplateXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageTemplatesToXML(String[] languages){;
		XMLNode ret = new XMLNode("PageTemplates");
		List<PageTemplate> list = getPageTemplates();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageTemplate object : list)
			ret.addChildNode(PageTemplateXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportPageTemplatesToXML(String[] languages, List<PageTemplate> list){;
		XMLNode ret = new XMLNode("PageTemplates");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageTemplate object : list)
			ret.addChildNode(PageTemplateXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportMediaLinksToXML(){;
		XMLNode ret = new XMLNode("MediaLinks");
		List<MediaLink> list = getMediaLinks();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MediaLink object : list)
			ret.addChildNode(MediaLinkXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportMediaLinksToXML(List<MediaLink> list){;
		XMLNode ret = new XMLNode("MediaLinks");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MediaLink object : list)
			ret.addChildNode(MediaLinkXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportMediaLinksToXML(String[] languages){;
		XMLNode ret = new XMLNode("MediaLinks");
		List<MediaLink> list = getMediaLinks();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MediaLink object : list)
			ret.addChildNode(MediaLinkXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportMediaLinksToXML(String[] languages, List<MediaLink> list){;
		XMLNode ret = new XMLNode("MediaLinks");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (MediaLink object : list)
			ret.addChildNode(MediaLinkXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportScriptsToXML(){;
		XMLNode ret = new XMLNode("Scripts");
		List<Script> list = getScripts();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Script object : list)
			ret.addChildNode(ScriptXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportScriptsToXML(List<Script> list){;
		XMLNode ret = new XMLNode("Scripts");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Script object : list)
			ret.addChildNode(ScriptXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportScriptsToXML(String[] languages){;
		XMLNode ret = new XMLNode("Scripts");
		List<Script> list = getScripts();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Script object : list)
			ret.addChildNode(ScriptXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportScriptsToXML(String[] languages, List<Script> list){;
		XMLNode ret = new XMLNode("Scripts");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Script object : list)
			ret.addChildNode(ScriptXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportSitesToXML(){;
		XMLNode ret = new XMLNode("Sites");
		List<Site> list = getSites();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Site object : list)
			ret.addChildNode(SiteXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportSitesToXML(List<Site> list){;
		XMLNode ret = new XMLNode("Sites");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Site object : list)
			ret.addChildNode(SiteXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportSitesToXML(String[] languages){;
		XMLNode ret = new XMLNode("Sites");
		List<Site> list = getSites();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Site object : list)
			ret.addChildNode(SiteXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportSitesToXML(String[] languages, List<Site> list){;
		XMLNode ret = new XMLNode("Sites");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Site object : list)
			ret.addChildNode(SiteXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportNaviItemsToXML(){;
		XMLNode ret = new XMLNode("NaviItems");
		List<NaviItem> list = getNaviItems();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (NaviItem object : list)
			ret.addChildNode(NaviItemXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportNaviItemsToXML(List<NaviItem> list){;
		XMLNode ret = new XMLNode("NaviItems");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (NaviItem object : list)
			ret.addChildNode(NaviItemXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportNaviItemsToXML(String[] languages){;
		XMLNode ret = new XMLNode("NaviItems");
		List<NaviItem> list = getNaviItems();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (NaviItem object : list)
			ret.addChildNode(NaviItemXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportNaviItemsToXML(String[] languages, List<NaviItem> list){;
		XMLNode ret = new XMLNode("NaviItems");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (NaviItem object : list)
			ret.addChildNode(NaviItemXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportEntryPointsToXML(){;
		XMLNode ret = new XMLNode("EntryPoints");
		List<EntryPoint> list = getEntryPoints();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (EntryPoint object : list)
			ret.addChildNode(EntryPointXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportEntryPointsToXML(List<EntryPoint> list){;
		XMLNode ret = new XMLNode("EntryPoints");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (EntryPoint object : list)
			ret.addChildNode(EntryPointXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportEntryPointsToXML(String[] languages){;
		XMLNode ret = new XMLNode("EntryPoints");
		List<EntryPoint> list = getEntryPoints();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (EntryPoint object : list)
			ret.addChildNode(EntryPointXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportEntryPointsToXML(String[] languages, List<EntryPoint> list){;
		XMLNode ret = new XMLNode("EntryPoints");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (EntryPoint object : list)
			ret.addChildNode(EntryPointXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportPageAliassToXML(){;
		XMLNode ret = new XMLNode("PageAliass");
		List<PageAlias> list = getPageAliass();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageAlias object : list)
			ret.addChildNode(PageAliasXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageAliassToXML(List<PageAlias> list){;
		XMLNode ret = new XMLNode("PageAliass");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageAlias object : list)
			ret.addChildNode(PageAliasXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPageAliassToXML(String[] languages){;
		XMLNode ret = new XMLNode("PageAliass");
		List<PageAlias> list = getPageAliass();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageAlias object : list)
			ret.addChildNode(PageAliasXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportPageAliassToXML(String[] languages, List<PageAlias> list){;
		XMLNode ret = new XMLNode("PageAliass");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (PageAlias object : list)
			ret.addChildNode(PageAliasXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportRedirectUrlsToXML(){;
		XMLNode ret = new XMLNode("RedirectUrls");
		List<RedirectUrl> list = getRedirectUrls();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (RedirectUrl object : list)
			ret.addChildNode(RedirectUrlXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportRedirectUrlsToXML(List<RedirectUrl> list){;
		XMLNode ret = new XMLNode("RedirectUrls");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (RedirectUrl object : list)
			ret.addChildNode(RedirectUrlXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportRedirectUrlsToXML(String[] languages){;
		XMLNode ret = new XMLNode("RedirectUrls");
		List<RedirectUrl> list = getRedirectUrls();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (RedirectUrl object : list)
			ret.addChildNode(RedirectUrlXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportRedirectUrlsToXML(String[] languages, List<RedirectUrl> list){;
		XMLNode ret = new XMLNode("RedirectUrls");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (RedirectUrl object : list)
			ret.addChildNode(RedirectUrlXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("ASSiteData");

		ret.addChildNode(exportPageTemplatesToXML());
		ret.addChildNode(exportMediaLinksToXML());
		ret.addChildNode(exportScriptsToXML());
		ret.addChildNode(exportSitesToXML());
		ret.addChildNode(exportNaviItemsToXML());
		ret.addChildNode(exportEntryPointsToXML());
		ret.addChildNode(exportPageAliassToXML());
		ret.addChildNode(exportRedirectUrlsToXML());

		return ret;
	}
	public XMLNode exportToXML(String[] languages){
		XMLNode ret = new XMLNode("ASSiteData");

		ret.addChildNode(exportPageTemplatesToXML(languages));
		ret.addChildNode(exportMediaLinksToXML(languages));
		ret.addChildNode(exportScriptsToXML(languages));
		ret.addChildNode(exportSitesToXML(languages));
		ret.addChildNode(exportNaviItemsToXML(languages));
		ret.addChildNode(exportEntryPointsToXML(languages));
		ret.addChildNode(exportPageAliassToXML(languages));
		ret.addChildNode(exportRedirectUrlsToXML(languages));

		return ret;
	}
}
