/**
 ********************************************************************************
 *** IASSiteDataService.java                                                  ***
 *** Generator: net.anotheria.asg.generator.model.ServiceGenerator            ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.assitedata.service;

import java.util.List;
import net.anotheria.util.sorter.SortType;
import net.anotheria.anosite.gen.assitedata.data.PageTemplate;
import net.anotheria.anosite.gen.assitedata.data.MediaLink;
import net.anotheria.anosite.gen.assitedata.data.Script;
import net.anotheria.anosite.gen.assitedata.data.Site;
import net.anotheria.anosite.gen.assitedata.data.NaviItem;
import net.anotheria.anosite.gen.assitedata.data.EntryPoint;
import net.anotheria.anosite.gen.assitedata.data.PageAlias;
import net.anotheria.anosite.gen.assitedata.data.RedirectUrl;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.slicer.Segment;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.asg.service.ASGService;

public interface IASSiteDataService extends ASGService{

// Generated by: class net.anotheria.asg.generator.model.ServiceGenerator.generateInterface

	/**
	 * Returns all PageTemplates objects stored.
	 */
	public List<PageTemplate> getPageTemplates() throws ASSiteDataServiceException;

	/**
	 * Returns all PageTemplates objects sorted by given sortType.
	 */
	public List<PageTemplate> getPageTemplates(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a PageTemplate object by id.
	 */
	public void deletePageTemplate(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a PageTemplate object.
	 */
	public void deletePageTemplate(PageTemplate pagetemplate) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple PageTemplate object.
	 */
	public void deletePageTemplates(List<PageTemplate> list) throws ASSiteDataServiceException;

	/**
	 * Returns the PageTemplate object with the specified id.
	 */
	public PageTemplate getPageTemplate(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new PageTemplate object.
	 * Returns the created version.
	 */
	public PageTemplate importPageTemplate(PageTemplate pagetemplate) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  PageTemplate object.
	 * Returns the created versions.
	 */
	public List<PageTemplate> importPageTemplates(List<PageTemplate> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new PageTemplate object.
	 * Returns the created version.
	 */
	public PageTemplate createPageTemplate(PageTemplate pagetemplate) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new PageTemplate objects.
	 * Returns the created versions.
	 */
	public List<PageTemplate> createPageTemplates(List<PageTemplate> list) throws ASSiteDataServiceException;

	/**
	 * Updates a PageTemplate object.
	 * Returns the updated version.
	 */
	public PageTemplate updatePageTemplate(PageTemplate pagetemplate) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple PageTemplate objects.
	 * Returns the updated versions.
	 */
	public List<PageTemplate> updatePageTemplates(List<PageTemplate> list) throws ASSiteDataServiceException;

	/**
	 * Returns all PageTemplate objects, where property with given name equals object.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all PageTemplate objects, where property with given name equals object, sorted
	 */
	public List<PageTemplate> getPageTemplatesByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnPageTemplates(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all PageTemplate objects, where property matches.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all PageTemplate objects, where property matches, sorted
	 */
	public List<PageTemplate> getPageTemplatesByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all PageTemplates count.
	 */
	public int getPageTemplatesCount() throws ASSiteDataServiceException;

	/**
	 * Returns PageTemplates objects segment.
	 */
	public List<PageTemplate> getPageTemplates(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns PageTemplate objects segment, where property matches.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns PageTemplate objects segment, where property matches, sorted.
	 */
	public List<PageTemplate> getPageTemplatesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportPageTemplatesToXML(List<PageTemplate> listPageTemplates)  throws ASSiteDataServiceException;
	/**
	 * Returns all MediaLinks objects stored.
	 */
	public List<MediaLink> getMediaLinks() throws ASSiteDataServiceException;

	/**
	 * Returns all MediaLinks objects sorted by given sortType.
	 */
	public List<MediaLink> getMediaLinks(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a MediaLink object by id.
	 */
	public void deleteMediaLink(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a MediaLink object.
	 */
	public void deleteMediaLink(MediaLink medialink) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple MediaLink object.
	 */
	public void deleteMediaLinks(List<MediaLink> list) throws ASSiteDataServiceException;

	/**
	 * Returns the MediaLink object with the specified id.
	 */
	public MediaLink getMediaLink(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new MediaLink object.
	 * Returns the created version.
	 */
	public MediaLink importMediaLink(MediaLink medialink) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  MediaLink object.
	 * Returns the created versions.
	 */
	public List<MediaLink> importMediaLinks(List<MediaLink> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new MediaLink object.
	 * Returns the created version.
	 */
	public MediaLink createMediaLink(MediaLink medialink) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new MediaLink objects.
	 * Returns the created versions.
	 */
	public List<MediaLink> createMediaLinks(List<MediaLink> list) throws ASSiteDataServiceException;

	/**
	 * Updates a MediaLink object.
	 * Returns the updated version.
	 */
	public MediaLink updateMediaLink(MediaLink medialink) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple MediaLink objects.
	 * Returns the updated versions.
	 */
	public List<MediaLink> updateMediaLinks(List<MediaLink> list) throws ASSiteDataServiceException;

	/**
	 * Returns all MediaLink objects, where property with given name equals object.
	 */
	public List<MediaLink> getMediaLinksByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all MediaLink objects, where property with given name equals object, sorted
	 */
	public List<MediaLink> getMediaLinksByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnMediaLinks(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all MediaLink objects, where property matches.
	 */
	public List<MediaLink> getMediaLinksByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all MediaLink objects, where property matches, sorted
	 */
	public List<MediaLink> getMediaLinksByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all MediaLinks count.
	 */
	public int getMediaLinksCount() throws ASSiteDataServiceException;

	/**
	 * Returns MediaLinks objects segment.
	 */
	public List<MediaLink> getMediaLinks(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns MediaLink objects segment, where property matches.
	 */
	public List<MediaLink> getMediaLinksByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns MediaLink objects segment, where property matches, sorted.
	 */
	public List<MediaLink> getMediaLinksByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportMediaLinksToXML(List<MediaLink> listMediaLinks)  throws ASSiteDataServiceException;
	/**
	 * Returns all Scripts objects stored.
	 */
	public List<Script> getScripts() throws ASSiteDataServiceException;

	/**
	 * Returns all Scripts objects sorted by given sortType.
	 */
	public List<Script> getScripts(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a Script object by id.
	 */
	public void deleteScript(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a Script object.
	 */
	public void deleteScript(Script script) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple Script object.
	 */
	public void deleteScripts(List<Script> list) throws ASSiteDataServiceException;

	/**
	 * Returns the Script object with the specified id.
	 */
	public Script getScript(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new Script object.
	 * Returns the created version.
	 */
	public Script importScript(Script script) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  Script object.
	 * Returns the created versions.
	 */
	public List<Script> importScripts(List<Script> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new Script object.
	 * Returns the created version.
	 */
	public Script createScript(Script script) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new Script objects.
	 * Returns the created versions.
	 */
	public List<Script> createScripts(List<Script> list) throws ASSiteDataServiceException;

	/**
	 * Updates a Script object.
	 * Returns the updated version.
	 */
	public Script updateScript(Script script) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple Script objects.
	 * Returns the updated versions.
	 */
	public List<Script> updateScripts(List<Script> list) throws ASSiteDataServiceException;

	/**
	 * Returns all Script objects, where property with given name equals object.
	 */
	public List<Script> getScriptsByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all Script objects, where property with given name equals object, sorted
	 */
	public List<Script> getScriptsByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnScripts(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all Script objects, where property matches.
	 */
	public List<Script> getScriptsByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all Script objects, where property matches, sorted
	 */
	public List<Script> getScriptsByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all Scripts count.
	 */
	public int getScriptsCount() throws ASSiteDataServiceException;

	/**
	 * Returns Scripts objects segment.
	 */
	public List<Script> getScripts(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns Script objects segment, where property matches.
	 */
	public List<Script> getScriptsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns Script objects segment, where property matches, sorted.
	 */
	public List<Script> getScriptsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportScriptsToXML(List<Script> listScripts)  throws ASSiteDataServiceException;
	/**
	 * Returns all Sites objects stored.
	 */
	public List<Site> getSites() throws ASSiteDataServiceException;

	/**
	 * Returns all Sites objects sorted by given sortType.
	 */
	public List<Site> getSites(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a Site object by id.
	 */
	public void deleteSite(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a Site object.
	 */
	public void deleteSite(Site site) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple Site object.
	 */
	public void deleteSites(List<Site> list) throws ASSiteDataServiceException;

	/**
	 * Returns the Site object with the specified id.
	 */
	public Site getSite(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new Site object.
	 * Returns the created version.
	 */
	public Site importSite(Site site) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  Site object.
	 * Returns the created versions.
	 */
	public List<Site> importSites(List<Site> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new Site object.
	 * Returns the created version.
	 */
	public Site createSite(Site site) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new Site objects.
	 * Returns the created versions.
	 */
	public List<Site> createSites(List<Site> list) throws ASSiteDataServiceException;

	/**
	 * Updates a Site object.
	 * Returns the updated version.
	 */
	public Site updateSite(Site site) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple Site objects.
	 * Returns the updated versions.
	 */
	public List<Site> updateSites(List<Site> list) throws ASSiteDataServiceException;

	/**
	 * Returns all Site objects, where property with given name equals object.
	 */
	public List<Site> getSitesByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all Site objects, where property with given name equals object, sorted
	 */
	public List<Site> getSitesByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnSites(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all Site objects, where property matches.
	 */
	public List<Site> getSitesByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all Site objects, where property matches, sorted
	 */
	public List<Site> getSitesByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all Sites count.
	 */
	public int getSitesCount() throws ASSiteDataServiceException;

	/**
	 * Returns Sites objects segment.
	 */
	public List<Site> getSites(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns Site objects segment, where property matches.
	 */
	public List<Site> getSitesByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns Site objects segment, where property matches, sorted.
	 */
	public List<Site> getSitesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * In all documents of type Site copies all multilingual fields from sourceLanguage to targetLanguage
	 */
	public void copyMultilingualAttributesInAllSites(String sourceLanguage, String targetLanguage) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportSitesToXML(List<Site> listSites)  throws ASSiteDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportSitesToXML(String[] languages,List<Site> listSites) throws ASSiteDataServiceException;
	/**
	 * Returns all NaviItems objects stored.
	 */
	public List<NaviItem> getNaviItems() throws ASSiteDataServiceException;

	/**
	 * Returns all NaviItems objects sorted by given sortType.
	 */
	public List<NaviItem> getNaviItems(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a NaviItem object by id.
	 */
	public void deleteNaviItem(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a NaviItem object.
	 */
	public void deleteNaviItem(NaviItem naviitem) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple NaviItem object.
	 */
	public void deleteNaviItems(List<NaviItem> list) throws ASSiteDataServiceException;

	/**
	 * Returns the NaviItem object with the specified id.
	 */
	public NaviItem getNaviItem(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new NaviItem object.
	 * Returns the created version.
	 */
	public NaviItem importNaviItem(NaviItem naviitem) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  NaviItem object.
	 * Returns the created versions.
	 */
	public List<NaviItem> importNaviItems(List<NaviItem> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new NaviItem object.
	 * Returns the created version.
	 */
	public NaviItem createNaviItem(NaviItem naviitem) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new NaviItem objects.
	 * Returns the created versions.
	 */
	public List<NaviItem> createNaviItems(List<NaviItem> list) throws ASSiteDataServiceException;

	/**
	 * Updates a NaviItem object.
	 * Returns the updated version.
	 */
	public NaviItem updateNaviItem(NaviItem naviitem) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple NaviItem objects.
	 * Returns the updated versions.
	 */
	public List<NaviItem> updateNaviItems(List<NaviItem> list) throws ASSiteDataServiceException;

	/**
	 * Returns all NaviItem objects, where property with given name equals object.
	 */
	public List<NaviItem> getNaviItemsByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all NaviItem objects, where property with given name equals object, sorted
	 */
	public List<NaviItem> getNaviItemsByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnNaviItems(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all NaviItem objects, where property matches.
	 */
	public List<NaviItem> getNaviItemsByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all NaviItem objects, where property matches, sorted
	 */
	public List<NaviItem> getNaviItemsByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all NaviItems count.
	 */
	public int getNaviItemsCount() throws ASSiteDataServiceException;

	/**
	 * Returns NaviItems objects segment.
	 */
	public List<NaviItem> getNaviItems(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns NaviItem objects segment, where property matches.
	 */
	public List<NaviItem> getNaviItemsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns NaviItem objects segment, where property matches, sorted.
	 */
	public List<NaviItem> getNaviItemsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * In all documents of type NaviItem copies all multilingual fields from sourceLanguage to targetLanguage
	 */
	public void copyMultilingualAttributesInAllNaviItems(String sourceLanguage, String targetLanguage) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportNaviItemsToXML(List<NaviItem> listNaviItems)  throws ASSiteDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportNaviItemsToXML(String[] languages,List<NaviItem> listNaviItems) throws ASSiteDataServiceException;
	/**
	 * Returns all EntryPoints objects stored.
	 */
	public List<EntryPoint> getEntryPoints() throws ASSiteDataServiceException;

	/**
	 * Returns all EntryPoints objects sorted by given sortType.
	 */
	public List<EntryPoint> getEntryPoints(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a EntryPoint object by id.
	 */
	public void deleteEntryPoint(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a EntryPoint object.
	 */
	public void deleteEntryPoint(EntryPoint entrypoint) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple EntryPoint object.
	 */
	public void deleteEntryPoints(List<EntryPoint> list) throws ASSiteDataServiceException;

	/**
	 * Returns the EntryPoint object with the specified id.
	 */
	public EntryPoint getEntryPoint(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new EntryPoint object.
	 * Returns the created version.
	 */
	public EntryPoint importEntryPoint(EntryPoint entrypoint) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  EntryPoint object.
	 * Returns the created versions.
	 */
	public List<EntryPoint> importEntryPoints(List<EntryPoint> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new EntryPoint object.
	 * Returns the created version.
	 */
	public EntryPoint createEntryPoint(EntryPoint entrypoint) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new EntryPoint objects.
	 * Returns the created versions.
	 */
	public List<EntryPoint> createEntryPoints(List<EntryPoint> list) throws ASSiteDataServiceException;

	/**
	 * Updates a EntryPoint object.
	 * Returns the updated version.
	 */
	public EntryPoint updateEntryPoint(EntryPoint entrypoint) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple EntryPoint objects.
	 * Returns the updated versions.
	 */
	public List<EntryPoint> updateEntryPoints(List<EntryPoint> list) throws ASSiteDataServiceException;

	/**
	 * Returns all EntryPoint objects, where property with given name equals object.
	 */
	public List<EntryPoint> getEntryPointsByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all EntryPoint objects, where property with given name equals object, sorted
	 */
	public List<EntryPoint> getEntryPointsByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnEntryPoints(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all EntryPoint objects, where property matches.
	 */
	public List<EntryPoint> getEntryPointsByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all EntryPoint objects, where property matches, sorted
	 */
	public List<EntryPoint> getEntryPointsByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all EntryPoints count.
	 */
	public int getEntryPointsCount() throws ASSiteDataServiceException;

	/**
	 * Returns EntryPoints objects segment.
	 */
	public List<EntryPoint> getEntryPoints(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns EntryPoint objects segment, where property matches.
	 */
	public List<EntryPoint> getEntryPointsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns EntryPoint objects segment, where property matches, sorted.
	 */
	public List<EntryPoint> getEntryPointsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportEntryPointsToXML(List<EntryPoint> listEntryPoints)  throws ASSiteDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportEntryPointsToXML(String[] languages,List<EntryPoint> listEntryPoints) throws ASSiteDataServiceException;
	/**
	 * Returns all PageAliass objects stored.
	 */
	public List<PageAlias> getPageAliass() throws ASSiteDataServiceException;

	/**
	 * Returns all PageAliass objects sorted by given sortType.
	 */
	public List<PageAlias> getPageAliass(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a PageAlias object by id.
	 */
	public void deletePageAlias(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a PageAlias object.
	 */
	public void deletePageAlias(PageAlias pagealias) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple PageAlias object.
	 */
	public void deletePageAliass(List<PageAlias> list) throws ASSiteDataServiceException;

	/**
	 * Returns the PageAlias object with the specified id.
	 */
	public PageAlias getPageAlias(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new PageAlias object.
	 * Returns the created version.
	 */
	public PageAlias importPageAlias(PageAlias pagealias) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  PageAlias object.
	 * Returns the created versions.
	 */
	public List<PageAlias> importPageAliass(List<PageAlias> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new PageAlias object.
	 * Returns the created version.
	 */
	public PageAlias createPageAlias(PageAlias pagealias) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new PageAlias objects.
	 * Returns the created versions.
	 */
	public List<PageAlias> createPageAliass(List<PageAlias> list) throws ASSiteDataServiceException;

	/**
	 * Updates a PageAlias object.
	 * Returns the updated version.
	 */
	public PageAlias updatePageAlias(PageAlias pagealias) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple PageAlias objects.
	 * Returns the updated versions.
	 */
	public List<PageAlias> updatePageAliass(List<PageAlias> list) throws ASSiteDataServiceException;

	/**
	 * Returns all PageAlias objects, where property with given name equals object.
	 */
	public List<PageAlias> getPageAliassByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all PageAlias objects, where property with given name equals object, sorted
	 */
	public List<PageAlias> getPageAliassByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnPageAliass(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all PageAlias objects, where property matches.
	 */
	public List<PageAlias> getPageAliassByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all PageAlias objects, where property matches, sorted
	 */
	public List<PageAlias> getPageAliassByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all PageAliass count.
	 */
	public int getPageAliassCount() throws ASSiteDataServiceException;

	/**
	 * Returns PageAliass objects segment.
	 */
	public List<PageAlias> getPageAliass(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns PageAlias objects segment, where property matches.
	 */
	public List<PageAlias> getPageAliassByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns PageAlias objects segment, where property matches, sorted.
	 */
	public List<PageAlias> getPageAliassByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportPageAliassToXML(List<PageAlias> listPageAliass)  throws ASSiteDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportPageAliassToXML(String[] languages,List<PageAlias> listPageAliass) throws ASSiteDataServiceException;
	/**
	 * Returns all RedirectUrls objects stored.
	 */
	public List<RedirectUrl> getRedirectUrls() throws ASSiteDataServiceException;

	/**
	 * Returns all RedirectUrls objects sorted by given sortType.
	 */
	public List<RedirectUrl> getRedirectUrls(SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Deletes a RedirectUrl object by id.
	 */
	public void deleteRedirectUrl(String id) throws ASSiteDataServiceException;

	/**
	 * Deletes a RedirectUrl object.
	 */
	public void deleteRedirectUrl(RedirectUrl redirecturl) throws ASSiteDataServiceException;

	/**
	 * Deletes multiple RedirectUrl object.
	 */
	public void deleteRedirectUrls(List<RedirectUrl> list) throws ASSiteDataServiceException;

	/**
	 * Returns the RedirectUrl object with the specified id.
	 */
	public RedirectUrl getRedirectUrl(String id) throws ASSiteDataServiceException;

	/**
	 * Imports a new RedirectUrl object.
	 * Returns the created version.
	 */
	public RedirectUrl importRedirectUrl(RedirectUrl redirecturl) throws ASSiteDataServiceException;

	/**
	 * Imports multiple new  RedirectUrl object.
	 * Returns the created versions.
	 */
	public List<RedirectUrl> importRedirectUrls(List<RedirectUrl> list) throws ASSiteDataServiceException;

	/**
	 * Creates a new RedirectUrl object.
	 * Returns the created version.
	 */
	public RedirectUrl createRedirectUrl(RedirectUrl redirecturl) throws ASSiteDataServiceException;

	/**
	 * Creates multiple new RedirectUrl objects.
	 * Returns the created versions.
	 */
	public List<RedirectUrl> createRedirectUrls(List<RedirectUrl> list) throws ASSiteDataServiceException;

	/**
	 * Updates a RedirectUrl object.
	 * Returns the updated version.
	 */
	public RedirectUrl updateRedirectUrl(RedirectUrl redirecturl) throws ASSiteDataServiceException;

	/**
	 * Updates mutiple RedirectUrl objects.
	 * Returns the updated versions.
	 */
	public List<RedirectUrl> updateRedirectUrls(List<RedirectUrl> list) throws ASSiteDataServiceException;

	/**
	 * Returns all RedirectUrl objects, where property with given name equals object.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(String propertyName, Object value) throws ASSiteDataServiceException;

	/**
	 * Returns all RedirectUrl objects, where property with given name equals object, sorted
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(String propertyName, Object value, SortType sortType) throws ASSiteDataServiceException;

	/**
	 * Executes a query
	 */
	public QueryResult executeQueryOnRedirectUrls(DocumentQuery query) throws ASSiteDataServiceException;

	/**
	 * Returns all RedirectUrl objects, where property matches.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all RedirectUrl objects, where property matches, sorted
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(SortType sortType, QueryProperty... property) throws ASSiteDataServiceException;

	/**
	 * Returns all RedirectUrls count.
	 */
	public int getRedirectUrlsCount() throws ASSiteDataServiceException;

	/**
	 * Returns RedirectUrls objects segment.
	 */
	public List<RedirectUrl> getRedirectUrls(Segment aSegment) throws ASSiteDataServiceException;

	/**
	 * Returns RedirectUrl objects segment, where property matches.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(Segment aSegment, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * Returns RedirectUrl objects segment, where property matches, sorted.
	 */
	public List<RedirectUrl> getRedirectUrlsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty) throws ASSiteDataServiceException;

	/**
	 * creates an xml element with selected contained data
	 */
	public XMLNode exportRedirectUrlsToXML(List<RedirectUrl> listRedirectUrls)  throws ASSiteDataServiceException;
	/**
	 * creates an xml element with selected contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportRedirectUrlsToXML(String[] languages,List<RedirectUrl> listRedirectUrls) throws ASSiteDataServiceException;
	/**
	 * Copies all multilingual fields from sourceLanguage to targetLanguage in all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public void copyMultilingualAttributesInAllObjects(String sourceLanguage, String targetLanguage) throws ASSiteDataServiceException;

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query) throws ASSiteDataServiceException;
	/**
	 * creates an xml element with all contained data.
	 */
	public XMLNode exportToXML() throws ASSiteDataServiceException;

	/**
	 * creates an xml element with all contained data but only selected languages in multilingual attributes
	 */
	public XMLNode exportToXML(String[] languages) throws ASSiteDataServiceException;
}
