/**
 ********************************************************************************
 *** BaseBoxAction.java                                                       ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.aswebdata.action;

import net.anotheria.anosite.gen.shared.action.BaseContentAction;
import javax.servlet.http.HttpServletRequest;
import net.anotheria.anosite.gen.aswebdata.data.Box;
import net.anotheria.asg.data.AbstractASGDocument;
import net.anotheria.asg.data.LockableObject;
import net.anotheria.asg.util.locking.exeption.LockingException;
import net.anotheria.asg.util.locking.helper.DocumentLockingHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import net.anotheria.maf.bean.FormBean;

public abstract class BaseBoxAction <T extends FormBean> extends BaseContentAction<T>{

// Generated by: class net.anotheria.asg.generator.view.action.ModuleActionsGenerator.generateBaseAction


	private final Logger logger = LoggerFactory.getLogger("cms-lock-log");
	protected String getTitle(){
		return "Box";
	} //getTitle

	protected String getCurrentModuleDefName(){
		return "ASWebData";
	} //getCurrentModuleDefName

	protected String getCurrentDocumentDefName(){
		return "Box";
	} //getCurrentDocumentDefName

	/**
	 * Executing locking. Actually.
	 */
	protected void lockBoxs(Box box, HttpServletRequest req) throws Exception{
		if(box instanceof AbstractASGDocument){
			AbstractASGDocument lock = (AbstractASGDocument)box;
			lock.setLocked(true);
			lock.setLockerId(getUserId(req));
			lock.setLockingTime(System.currentTimeMillis());
			getASWebDataService().updateBox( box);
			logger.info("Lock-OPERATION, document with id : ["+box.getId()+"] was locked by: " + getUserId(req));
			addLockedAttribute(req, lock);
		}
	}
	/**
	 * Executing unlocking. Actually.
	 */
	protected void unLockBoxs(Box box, HttpServletRequest req, boolean unlockByTimeoout) throws Exception{
		if(box instanceof AbstractASGDocument){
			AbstractASGDocument lock = (AbstractASGDocument)box;
			lock.setLocked(false);
			lock.setLockerId("");
			lock.setLockingTime(0);
			getASWebDataService().updateBox( box);
			if (!unlockByTimeoout){
			   logger.info("UnLock-OPERATION, document with id : ["+box.getId()+"] was unlocked by: " + getUserId(req) +"  with 'admin' role :" + isUserInRole(req, "admin") );
			 } else { 
			   logger.info("UnLock-OPERATION, document with id : ["+box.getId()+"] was unlocked by: timeOut");
			}
			removeLockedAttribute(req, lock);
		}
	}
	/**
	 * Executing auto-unlocking check....
	 */
	protected void checkBoxs(Box box, HttpServletRequest req) throws Exception{
		boolean shouldUnlock = box instanceof AbstractASGDocument && 
 	 	 	 	 ((AbstractASGDocument)box).isLocked() && 
 	 	 	 	 ( System.currentTimeMillis() >= ((AbstractASGDocument)box).getLockingTime() + getLockingTimeout());
		if(shouldUnlock)
			unLockBoxs(box, req, true);
	}
	/**
	 * Checking UpdateCapability rights
	 */
	protected void canUpdateBoxs(Box box, HttpServletRequest req) throws Exception{
		if(box instanceof LockableObject ){
		//Actually - simplest Check! --  exception - if anything happens!!!!
			DocumentLockingHelper.update.checkExecutionPermission((LockableObject)box, false, getUserId(req));
		}
		if (isTimeoutReached(box)) {
			checkBoxs(box, req);
			throw new LockingException(getUserId(req)+" . Document can't be updated! Due to lock - timeout!!!");
		}
		if (wasUnlockedByAdmin(box, req)) {
			throw new LockingException(getUserId(req)+" . Document can't be updated! It was unlocked by user in 'admin' role!!!");
		}
	}
	/**
	 */
	private boolean isTimeoutReached(Box box){
		if (box instanceof LockableObject) {
			LockableObject lock = (LockableObject)box;
			return lock.isLocked() && lock.getLockingTime() + getLockingTimeout() <= System.currentTimeMillis();
		}
		return false;
	}
	/**
	 */
	private boolean wasUnlockedByAdmin(Box box, HttpServletRequest req){
		if (box instanceof AbstractASGDocument) {
			AbstractASGDocument lock = (AbstractASGDocument)box;
			return !lock.isLocked() && containsLockedAttribute(req, lock);
		}
		return false;
	}
}
