/**
 ********************************************************************************
 *** ASWebDataServiceImpl.java                                                ***
 *** The implementation of the IASWebDataService.                             ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.aswebdata.service;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.anodoc.data.Module;
import net.anotheria.anodoc.data.Property;
import net.anotheria.anodoc.data.NoSuchPropertyException;
import net.anotheria.util.sorter.SortType;
import net.anotheria.util.sorter.StaticQuickSorter;
import net.anotheria.util.slicer.Segment;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.anosite.gen.aswebdata.data.ModuleASWebData;
import net.anotheria.anosite.gen.shared.service.BasicCMSService;
import net.anotheria.anodoc.query2.DocumentQuery;
import net.anotheria.anodoc.query2.QueryResult;
import net.anotheria.anodoc.query2.QueryResultEntry;
import net.anotheria.anodoc.query2.QueryProperty;
import net.anotheria.util.xml.XMLNode;
import net.anotheria.util.xml.XMLAttribute;
import net.anotheria.asg.util.listener.IModuleListener;
import net.anotheria.anosite.gen.aswebdata.data.Pagex;
import net.anotheria.anosite.gen.aswebdata.data.PagexXMLHelper;
import net.anotheria.anosite.gen.aswebdata.data.PagexDocument;
import net.anotheria.anosite.gen.aswebdata.data.Box;
import net.anotheria.anosite.gen.aswebdata.data.BoxXMLHelper;
import net.anotheria.anosite.gen.aswebdata.data.BoxDocument;
import net.anotheria.anosite.gen.aswebdata.data.Attribute;
import net.anotheria.anosite.gen.aswebdata.data.AttributeXMLHelper;
import net.anotheria.anosite.gen.aswebdata.data.AttributeDocument;

public class ASWebDataServiceImpl extends BasicCMSService implements IASWebDataService, IModuleListener{

	// Generated by: class net.anotheria.asg.generator.model.docs.CMSBasedServiceGenerator.generateImplementation

	private static ASWebDataServiceImpl instance;

	private ASWebDataServiceImpl(){
		addServiceListener(new net.anotheria.anosite.cms.listener.CRUDLogListener());
		addModuleListener(ModuleASWebData.MODULE_ID, this);
	}

	static final ASWebDataServiceImpl getInstance(){
		if (instance==null){
			instance = new ASWebDataServiceImpl();
		}
		return instance;
	}

	private ModuleASWebData _getModuleASWebData(){
		return (ModuleASWebData) getModule(ModuleASWebData.MODULE_ID);
	}

	@Override
	public void moduleLoaded(Module module){
		firePersistenceChangedEvent();
	}

	@SuppressWarnings("unchecked")
	public List<Pagex> getPagexs(){
		List pagexs = new ArrayList();
		pagexs.addAll(_getModuleASWebData().getPagexs());
		return pagexs;
	}

	public List<Pagex> getPagexs(SortType sortType){
		return StaticQuickSorter.sort(getPagexs(), sortType);
	}

	/**
	 * Returns the Pagex objects with the specified ids.
	 */
	public List<Pagex> getPagexs(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Pagex>(0);
		List<Pagex> all = getPagexs();
		List<Pagex> ret = new ArrayList<Pagex>();
		for (Pagex pagex : all){
			if(ids.contains(pagex.getId())){
				ret.add(pagex);
			}
		}
		return ret;
	}

	/**
	 * Returns the Pagex objects with the specified ids, sorted by given sorttype.
	 */
	public List<Pagex> getPagexs(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getPagexs(ids), sortType);
	}

	public void deletePagex(Pagex pagex){
		deletePagex(pagex.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(pagex);
		}
	}

	public void deletePagex(String id){
		ModuleASWebData module = _getModuleASWebData();
		Pagex varValue = hasServiceListeners()?module.getPagex(id):null;
		module.deletePagex(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deletePagexs(List<Pagex> list){
		ModuleASWebData module = _getModuleASWebData();
		for (Pagex pagex : list){
			module.deletePagex(pagex.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Pagex getPagex(String id){
		return _getModuleASWebData().getPagex(id);
	}

	public Pagex importPagex(Pagex pagex){
		ModuleASWebData module = _getModuleASWebData();
		module.importPagex((PagexDocument)pagex);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(pagex);
		}
		return pagex;
	}

	public List<Pagex> importPagexs(List<Pagex> list){
		ModuleASWebData module = _getModuleASWebData();
		List<Pagex> ret = new ArrayList<Pagex>();
		for (Pagex pagex : list){
			Pagex imported = module.importPagex((PagexDocument)pagex);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Pagex pagex : ret)
				fireObjectImportedEvent(pagex);
		}
		return ret;
	}

	public Pagex createPagex(Pagex pagex){
		ModuleASWebData module = _getModuleASWebData();
		module.createPagex((PagexDocument)pagex);
		updateModule(module);
		fireObjectCreatedEvent(pagex);
		return pagex;
	}

	/**
	 * Creates multiple new Pagex objects.
	 * Returns the created versions.
	 */
	public List<Pagex> createPagexs(List<Pagex> list){;
		ModuleASWebData module = _getModuleASWebData();
		List<Pagex> ret = new ArrayList<Pagex>();
		for (Pagex pagex : list){
			Pagex created = module.createPagex((PagexDocument)pagex);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Pagex pagex : ret)
				fireObjectCreatedEvent(pagex);
		}
		return ret;
	}

	public Pagex updatePagex(Pagex pagex){
		Pagex oldVersion = null;
		ModuleASWebData module = _getModuleASWebData();
		if (hasServiceListeners())
			oldVersion = module.getPagex(pagex.getId());
		module.updatePagex((PagexDocument)pagex);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, pagex);
		}
		return pagex;
	}

	public List<Pagex> updatePagexs(List<Pagex> list){
		List<Pagex> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Pagex>(list.size());
		ModuleASWebData module = _getModuleASWebData();
		for (Pagex pagex : list){
			if (oldList!=null)
				oldList.add(module.getPagex(pagex.getId()));
			module.updatePagex((PagexDocument)pagex);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Pagex> getPagexsByProperty(String propertyName, Object value){
		List<Pagex> allPagexs = getPagexs();
		List<Pagex> ret = new ArrayList<Pagex>();
		for (int i=0; i<allPagexs.size(); i++){
			Pagex pagex = allPagexs.get(i);
			try{
				Property property = ((PagexDocument)pagex).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(pagex);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(pagex);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(pagex);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Pagex> getPagexsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getPagexsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Pagexs
	 */
	public QueryResult executeQueryOnPagexs(DocumentQuery query){
		List<Pagex> allPagexs = getPagexs();
		QueryResult result = new QueryResult();
		for (int i=0; i<allPagexs.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allPagexs.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Pagex objects, where property matches.
	 */
	public List<Pagex> getPagexsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Pagex> ret = new ArrayList<Pagex>();
		List<Pagex> src = getPagexs();
		for ( Pagex pagex : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(pagex.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagex);
		}
		return ret;
	}

	/**
	 * Returns all Pagex objects, where property matches, sorted
	 */
	public List<Pagex> getPagexsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getPagexsByProperty(property), sortType);
	}

	/**
	 * Returns Pagex objects count.
	 */
	public int getPagexsCount() {
		return _getModuleASWebData().getPagexs().size();
	}

	/**
	 * Returns Pagex objects segment.
	 */
	public List<Pagex> getPagexs(Segment aSegment) {
		return Slicer.slice(aSegment, getPagexs()).getSliceData();
	}

	/**
	 * Returns Pagex objects segment, where property matched.
	 */
	public List<Pagex> getPagexsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Pagex> ret = new ArrayList<Pagex>();
		List<Pagex> src = getPagexs();
		for (Pagex pagex : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(pagex.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(pagex);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Pagex objects segment, where property matched, sorted.
	 */
	public List<Pagex> getPagexsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getPagexsByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllPagexs(String sourceLanguage, String targetLanguage){
		List<Pagex> allDocumentsSrc = getPagexs();
		List<Pagex> allDocuments = new ArrayList<Pagex>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (Pagex document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updatePagexs(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<Box> getBoxs(){
		List boxs = new ArrayList();
		boxs.addAll(_getModuleASWebData().getBoxs());
		return boxs;
	}

	public List<Box> getBoxs(SortType sortType){
		return StaticQuickSorter.sort(getBoxs(), sortType);
	}

	/**
	 * Returns the Box objects with the specified ids.
	 */
	public List<Box> getBoxs(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Box>(0);
		List<Box> all = getBoxs();
		List<Box> ret = new ArrayList<Box>();
		for (Box box : all){
			if(ids.contains(box.getId())){
				ret.add(box);
			}
		}
		return ret;
	}

	/**
	 * Returns the Box objects with the specified ids, sorted by given sorttype.
	 */
	public List<Box> getBoxs(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getBoxs(ids), sortType);
	}

	public void deleteBox(Box box){
		deleteBox(box.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(box);
		}
	}

	public void deleteBox(String id){
		ModuleASWebData module = _getModuleASWebData();
		Box varValue = hasServiceListeners()?module.getBox(id):null;
		module.deleteBox(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteBoxs(List<Box> list){
		ModuleASWebData module = _getModuleASWebData();
		for (Box box : list){
			module.deleteBox(box.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Box getBox(String id){
		return _getModuleASWebData().getBox(id);
	}

	public Box importBox(Box box){
		ModuleASWebData module = _getModuleASWebData();
		module.importBox((BoxDocument)box);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(box);
		}
		return box;
	}

	public List<Box> importBoxs(List<Box> list){
		ModuleASWebData module = _getModuleASWebData();
		List<Box> ret = new ArrayList<Box>();
		for (Box box : list){
			Box imported = module.importBox((BoxDocument)box);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Box box : ret)
				fireObjectImportedEvent(box);
		}
		return ret;
	}

	public Box createBox(Box box){
		ModuleASWebData module = _getModuleASWebData();
		module.createBox((BoxDocument)box);
		updateModule(module);
		fireObjectCreatedEvent(box);
		return box;
	}

	/**
	 * Creates multiple new Box objects.
	 * Returns the created versions.
	 */
	public List<Box> createBoxs(List<Box> list){;
		ModuleASWebData module = _getModuleASWebData();
		List<Box> ret = new ArrayList<Box>();
		for (Box box : list){
			Box created = module.createBox((BoxDocument)box);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Box box : ret)
				fireObjectCreatedEvent(box);
		}
		return ret;
	}

	public Box updateBox(Box box){
		Box oldVersion = null;
		ModuleASWebData module = _getModuleASWebData();
		if (hasServiceListeners())
			oldVersion = module.getBox(box.getId());
		module.updateBox((BoxDocument)box);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, box);
		}
		return box;
	}

	public List<Box> updateBoxs(List<Box> list){
		List<Box> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Box>(list.size());
		ModuleASWebData module = _getModuleASWebData();
		for (Box box : list){
			if (oldList!=null)
				oldList.add(module.getBox(box.getId()));
			module.updateBox((BoxDocument)box);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Box> getBoxsByProperty(String propertyName, Object value){
		List<Box> allBoxs = getBoxs();
		List<Box> ret = new ArrayList<Box>();
		for (int i=0; i<allBoxs.size(); i++){
			Box box = allBoxs.get(i);
			try{
				Property property = ((BoxDocument)box).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(box);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(box);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(box);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Box> getBoxsByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getBoxsByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Boxs
	 */
	public QueryResult executeQueryOnBoxs(DocumentQuery query){
		List<Box> allBoxs = getBoxs();
		QueryResult result = new QueryResult();
		for (int i=0; i<allBoxs.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allBoxs.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Box objects, where property matches.
	 */
	public List<Box> getBoxsByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Box> ret = new ArrayList<Box>();
		List<Box> src = getBoxs();
		for ( Box box : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(box.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(box);
		}
		return ret;
	}

	/**
	 * Returns all Box objects, where property matches, sorted
	 */
	public List<Box> getBoxsByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getBoxsByProperty(property), sortType);
	}

	/**
	 * Returns Box objects count.
	 */
	public int getBoxsCount() {
		return _getModuleASWebData().getBoxs().size();
	}

	/**
	 * Returns Box objects segment.
	 */
	public List<Box> getBoxs(Segment aSegment) {
		return Slicer.slice(aSegment, getBoxs()).getSliceData();
	}

	/**
	 * Returns Box objects segment, where property matched.
	 */
	public List<Box> getBoxsByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Box> ret = new ArrayList<Box>();
		List<Box> src = getBoxs();
		for (Box box : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(box.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(box);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Box objects segment, where property matched, sorted.
	 */
	public List<Box> getBoxsByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getBoxsByProperty(aSegment, aProperty), aSortType);
	}

	// This method is not very fast, since it makes an update (eff. save) after each doc.
	public void copyMultilingualAttributesInAllBoxs(String sourceLanguage, String targetLanguage){
		List<Box> allDocumentsSrc = getBoxs();
		List<Box> allDocuments = new ArrayList<Box>(allDocumentsSrc.size());
		allDocuments.addAll(allDocumentsSrc);
		for (Box document : allDocuments){
			document.copyLANG2LANG(sourceLanguage, targetLanguage);
		}
		updateBoxs(allDocuments);
	}

	@SuppressWarnings("unchecked")
	public List<Attribute> getAttributes(){
		List attributes = new ArrayList();
		attributes.addAll(_getModuleASWebData().getAttributes());
		return attributes;
	}

	public List<Attribute> getAttributes(SortType sortType){
		return StaticQuickSorter.sort(getAttributes(), sortType);
	}

	/**
	 * Returns the Attribute objects with the specified ids.
	 */
	public List<Attribute> getAttributes(List<String> ids){;
		if (ids==null || ids.size()==0)
			return new ArrayList<Attribute>(0);
		List<Attribute> all = getAttributes();
		List<Attribute> ret = new ArrayList<Attribute>();
		for (Attribute attribute : all){
			if(ids.contains(attribute.getId())){
				ret.add(attribute);
			}
		}
		return ret;
	}

	/**
	 * Returns the Attribute objects with the specified ids, sorted by given sorttype.
	 */
	public List<Attribute> getAttributes(List<String> ids, SortType sortType){;
		return StaticQuickSorter.sort(getAttributes(ids), sortType);
	}

	public void deleteAttribute(Attribute attribute){
		deleteAttribute(attribute.getId());
		if (hasServiceListeners()){
			fireObjectDeletedEvent(attribute);
		}
	}

	public void deleteAttribute(String id){
		ModuleASWebData module = _getModuleASWebData();
		Attribute varValue = hasServiceListeners()?module.getAttribute(id):null;
		module.deleteAttribute(id);
		updateModule(module);
		if(varValue!=null){
			fireObjectDeletedEvent(varValue);
		}
	}

	public void deleteAttributes(List<Attribute> list){
		ModuleASWebData module = _getModuleASWebData();
		for (Attribute attribute : list){
			module.deleteAttribute(attribute.getId());
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (int t=0; t<list.size(); t++)
				fireObjectDeletedEvent(list.get(t));
		}
	}

	public Attribute getAttribute(String id){
		return _getModuleASWebData().getAttribute(id);
	}

	public Attribute importAttribute(Attribute attribute){
		ModuleASWebData module = _getModuleASWebData();
		module.importAttribute((AttributeDocument)attribute);
		updateModule(module);
		if (hasServiceListeners()){
			fireObjectImportedEvent(attribute);
		}
		return attribute;
	}

	public List<Attribute> importAttributes(List<Attribute> list){
		ModuleASWebData module = _getModuleASWebData();
		List<Attribute> ret = new ArrayList<Attribute>();
		for (Attribute attribute : list){
			Attribute imported = module.importAttribute((AttributeDocument)attribute);
			ret.add(imported);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Attribute attribute : ret)
				fireObjectImportedEvent(attribute);
		}
		return ret;
	}

	public Attribute createAttribute(Attribute attribute){
		ModuleASWebData module = _getModuleASWebData();
		module.createAttribute((AttributeDocument)attribute);
		updateModule(module);
		fireObjectCreatedEvent(attribute);
		return attribute;
	}

	/**
	 * Creates multiple new Attribute objects.
	 * Returns the created versions.
	 */
	public List<Attribute> createAttributes(List<Attribute> list){;
		ModuleASWebData module = _getModuleASWebData();
		List<Attribute> ret = new ArrayList<Attribute>();
		for (Attribute attribute : list){
			Attribute created = module.createAttribute((AttributeDocument)attribute);
			ret.add(created);
		}
		updateModule(module);
		if (hasServiceListeners()){
			for (Attribute attribute : ret)
				fireObjectCreatedEvent(attribute);
		}
		return ret;
	}

	public Attribute updateAttribute(Attribute attribute){
		Attribute oldVersion = null;
		ModuleASWebData module = _getModuleASWebData();
		if (hasServiceListeners())
			oldVersion = module.getAttribute(attribute.getId());
		module.updateAttribute((AttributeDocument)attribute);
		updateModule(module);
		if (oldVersion != null){
			fireObjectUpdatedEvent(oldVersion, attribute);
		}
		return attribute;
	}

	public List<Attribute> updateAttributes(List<Attribute> list){
		List<Attribute> oldList = null;
		if (hasServiceListeners())
			oldList = new ArrayList<Attribute>(list.size());
		ModuleASWebData module = _getModuleASWebData();
		for (Attribute attribute : list){
			if (oldList!=null)
				oldList.add(module.getAttribute(attribute.getId()));
			module.updateAttribute((AttributeDocument)attribute);
		}
		updateModule(module);
		if (oldList!=null){
			for (int t=0; t<list.size(); t++)
				fireObjectUpdatedEvent(oldList.get(t), list.get(t));
		}
		return list;
	}

	public List<Attribute> getAttributesByProperty(String propertyName, Object value){
		List<Attribute> allAttributes = getAttributes();
		List<Attribute> ret = new ArrayList<Attribute>();
		for (int i=0; i<allAttributes.size(); i++){
			Attribute attribute = allAttributes.get(i);
			try{
				Property property = ((AttributeDocument)attribute).getProperty(propertyName);
				if (property.getValue()==null && value==null){;
					ret.add(attribute);
				}else{
					if (value!=null && property.getValue().equals(value))
						ret.add(attribute);
				}
			}catch(NoSuchPropertyException nspe){
				if (value==null)
					ret.add(attribute);
			}catch(Exception ignored){}
		}
		return ret;
	}

	public List<Attribute> getAttributesByProperty(String propertyName, Object value, SortType sortType){
		return StaticQuickSorter.sort(getAttributesByProperty(propertyName, value), sortType);
	}
	/**
	 * Executes a query on Attributes
	 */
	public QueryResult executeQueryOnAttributes(DocumentQuery query){
		List<Attribute> allAttributes = getAttributes();
		QueryResult result = new QueryResult();
		for (int i=0; i<allAttributes.size(); i++){
			List<QueryResultEntry> partialResult = query.match(allAttributes.get(i));
			result.add(partialResult);
		}
		return result;
	}

	/**
	 * Returns all Attribute objects, where property matches.
	 */
	public List<Attribute> getAttributesByProperty(QueryProperty... property){
		//first the slow version, the fast version is a todo.
		List<Attribute> ret = new ArrayList<Attribute>();
		List<Attribute> src = getAttributes();
		for ( Attribute attribute : src){;
			boolean mayPass = true;
			for (QueryProperty qp : property){;
				mayPass = mayPass && qp.doesMatch(attribute.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(attribute);
		}
		return ret;
	}

	/**
	 * Returns all Attribute objects, where property matches, sorted
	 */
	public List<Attribute> getAttributesByProperty(SortType sortType, QueryProperty... property){
		return StaticQuickSorter.sort(getAttributesByProperty(property), sortType);
	}

	/**
	 * Returns Attribute objects count.
	 */
	public int getAttributesCount() {
		return _getModuleASWebData().getAttributes().size();
	}

	/**
	 * Returns Attribute objects segment.
	 */
	public List<Attribute> getAttributes(Segment aSegment) {
		return Slicer.slice(aSegment, getAttributes()).getSliceData();
	}

	/**
	 * Returns Attribute objects segment, where property matched.
	 */
	public List<Attribute> getAttributesByProperty(Segment aSegment, QueryProperty... property) {
		int pLimit = aSegment.getElementsPerSlice();
		int pOffset = aSegment.getSliceNumber() * aSegment.getElementsPerSlice() - aSegment.getElementsPerSlice();
		List<Attribute> ret = new ArrayList<Attribute>();
		List<Attribute> src = getAttributes();
		for (Attribute attribute : src) {;
			boolean mayPass = true;
			for (QueryProperty qp : property) {;
				mayPass = mayPass && qp.doesMatch(attribute.getPropertyValue(qp.getName()));
			}
			if (mayPass)
				ret.add(attribute);
			if (ret.size() > pOffset + pLimit)
				break;
		}
		return Slicer.slice(aSegment, ret).getSliceData();
	}

	/**
	 * Returns Attribute objects segment, where property matched, sorted.
	 */
	public List<Attribute> getAttributesByProperty(Segment aSegment, SortType aSortType, QueryProperty... aProperty){
		return StaticQuickSorter.sort(getAttributesByProperty(aSegment, aProperty), aSortType);
	}

	/**
	 * Copies all multilingual fields from sourceLanguage to targetLanguage in all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public void copyMultilingualAttributesInAllObjects(String sourceLanguage, String targetLanguage){
		copyMultilingualAttributesInAllPagexs(sourceLanguage, targetLanguage);
		copyMultilingualAttributesInAllBoxs(sourceLanguage, targetLanguage);
	}

	/**
	 * Executes a query on all data objects (documents, vo) which are part of this module and managed by this service
	 */
	public QueryResult executeQueryOnAllObjects(DocumentQuery query){
		QueryResult ret = new QueryResult();
		ret.add(executeQueryOnPagexs(query).getEntries());
		ret.add(executeQueryOnBoxs(query).getEntries());
		ret.add(executeQueryOnAttributes(query).getEntries());
		return ret;
	} //executeQueryOnAllObjects


	public XMLNode exportPagexsToXML(){;
		XMLNode ret = new XMLNode("Pagexs");
		List<Pagex> list = getPagexs();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Pagex object : list)
			ret.addChildNode(PagexXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPagexsToXML(List<Pagex> list){;
		XMLNode ret = new XMLNode("Pagexs");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Pagex object : list)
			ret.addChildNode(PagexXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportPagexsToXML(String[] languages){;
		XMLNode ret = new XMLNode("Pagexs");
		List<Pagex> list = getPagexs();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Pagex object : list)
			ret.addChildNode(PagexXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportPagexsToXML(String[] languages, List<Pagex> list){;
		XMLNode ret = new XMLNode("Pagexs");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Pagex object : list)
			ret.addChildNode(PagexXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportBoxsToXML(){;
		XMLNode ret = new XMLNode("Boxs");
		List<Box> list = getBoxs();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Box object : list)
			ret.addChildNode(BoxXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportBoxsToXML(List<Box> list){;
		XMLNode ret = new XMLNode("Boxs");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Box object : list)
			ret.addChildNode(BoxXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportBoxsToXML(String[] languages){;
		XMLNode ret = new XMLNode("Boxs");
		List<Box> list = getBoxs();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Box object : list)
			ret.addChildNode(BoxXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportBoxsToXML(String[] languages, List<Box> list){;
		XMLNode ret = new XMLNode("Boxs");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Box object : list)
			ret.addChildNode(BoxXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportAttributesToXML(){;
		XMLNode ret = new XMLNode("Attributes");
		List<Attribute> list = getAttributes();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Attribute object : list)
			ret.addChildNode(AttributeXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportAttributesToXML(List<Attribute> list){;
		XMLNode ret = new XMLNode("Attributes");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Attribute object : list)
			ret.addChildNode(AttributeXMLHelper.toXML(object));
		return ret;
	}

	public XMLNode exportAttributesToXML(String[] languages){;
		XMLNode ret = new XMLNode("Attributes");
		List<Attribute> list = getAttributes();
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Attribute object : list)
			ret.addChildNode(AttributeXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportAttributesToXML(String[] languages, List<Attribute> list){;
		XMLNode ret = new XMLNode("Attributes");
		ret.addAttribute(new XMLAttribute("count", list.size()));
		for (Attribute object : list)
			ret.addChildNode(AttributeXMLHelper.toXML(object, languages));
		return ret;
	}

	public XMLNode exportToXML(){
		XMLNode ret = new XMLNode("ASWebData");

		ret.addChildNode(exportPagexsToXML());
		ret.addChildNode(exportBoxsToXML());
		ret.addChildNode(exportAttributesToXML());

		return ret;
	}
	public XMLNode exportToXML(String[] languages){
		XMLNode ret = new XMLNode("ASWebData");

		ret.addChildNode(exportPagexsToXML(languages));
		ret.addChildNode(exportBoxsToXML(languages));
		ret.addChildNode(exportAttributesToXML(languages));

		return ret;
	}
}
