/**
 ********************************************************************************
 *** ExportWizardHandlerDefsAction.java                                       ***
 *** generated by AnoSiteGenerator (ASG), Version: 1.3.3                      ***
 *** Copyright (C) 2005 - 2010 Anotheria.net, www.anotheria.net               ***
 *** All Rights Reserved.                                                     ***
 ********************************************************************************
 *** Don't edit this code, if you aren't sure                                 ***
 *** that you do exactly know what you are doing!                             ***
 *** It's better to invest time in the generator, as into the generated code. ***
 ********************************************************************************
 */

package net.anotheria.anosite.gen.aswizarddata.action;

import java.util.List;
import java.util.ArrayList;
import net.anotheria.asg.util.filter.DocumentFilter;
import net.anotheria.util.xml.XMLNode;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.anotheria.maf.action.ActionForward;
import net.anotheria.maf.action.ActionMapping;
import net.anotheria.maf.bean.FormBean;
import net.anotheria.anosite.gen.aswizarddata.data.WizardHandlerDef;
import net.anotheria.anosite.gen.aswizarddata.data.WizardHandlerDefSortType;
import net.anotheria.util.slicer.Slicer;
import net.anotheria.util.slicer.Slice;
import net.anotheria.util.slicer.Segment;
import net.anotheria.asg.util.bean.PagingLink;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.MarkerFactory;
import net.anotheria.util.sorter.Sorter;
import net.anotheria.util.sorter.QuickSorter;
import net.anotheria.anosite.gen.aswizarddata.bean.WizardHandlerDefListItemBeanSortType;

public class ExportWizardHandlerDefsAction extends BaseWizardHandlerDefAction{

	public static final String SA_SORT_TYPE = SA_SORT_TYPE_PREFIX+"WizardHandlerDef";
	public static final String SA_FILTER = SA_FILTER_PREFIX+"WizardHandlerDef";
	private static final List<String> ITEMS_ON_PAGE_SELECTOR = java.util.Arrays.asList(new String[]{"5","10","20","25","50","100","500","1000"});
	private static final Logger log = LoggerFactory.getLogger(ExportWizardHandlerDefsAction.class);
	private Sorter<WizardHandlerDef> sorter;

	private DocumentFilter nameFilterAZ;

	public ExportWizardHandlerDefsAction(){
		super();
		sorter = new QuickSorter<WizardHandlerDef>();
		try{ 
			nameFilterAZ = (DocumentFilter) Class.forName("net.anotheria.asg.util.filter.AZDocumentFilter").newInstance();
		} catch(Exception e){
			log.error(MarkerFactory.getMarker("FATAL"), "Couldn't instantiate filter:", e);
		}
	}
	public ActionForward anoDocExecute(ActionMapping mapping, FormBean af, HttpServletRequest req, HttpServletResponse res) throws Exception{
		String filterParameter0 = "";
		try{ 
			filterParameter0 = getStringParameter(req, "pFilter0");
			addBeanToSession(req, SA_FILTER+"0", filterParameter0);
		}catch(Exception ignored){
			// no filter parameter given, tring to check in the session.
			filterParameter0 = (String)getBeanFromSession(req, SA_FILTER+"0");
			if (filterParameter0==null)
				filterParameter0 = "";
		}
		req.setAttribute("currentFilterParameter0", filterParameter0);

		int sortMethod = WizardHandlerDefListItemBeanSortType.SORT_BY_DEFAULT;
		boolean sortOrder = WizardHandlerDefListItemBeanSortType.ASC;
		boolean sortParamSet = false;

		try{
			sortMethod = getIntParameter(req, PARAM_SORT_TYPE);
			sortParamSet = true;
		}catch(Exception ignored){}

		try{
			String sortMethodName = getStringParameter(req, PARAM_SORT_TYPE_NAME);
			sortMethod = WizardHandlerDefListItemBeanSortType.name2method(sortMethodName);
			sortParamSet = true;
		}catch(Exception ignored){}

		try{
			sortOrder = getStringParameter(req, PARAM_SORT_ORDER).equals("ASC") ? 
				WizardHandlerDefListItemBeanSortType.ASC : WizardHandlerDefListItemBeanSortType.DESC;
		}catch(Exception ignored){}

		WizardHandlerDefListItemBeanSortType sessionSortType  = null;
		WizardHandlerDefSortType sortType = null;
		if (sortParamSet){
			sessionSortType = new WizardHandlerDefListItemBeanSortType(sortMethod, sortOrder);
			sortType = new WizardHandlerDefSortType(sortMethod, sortOrder);
			addBeanToSession(req, SA_SORT_TYPE, sessionSortType);
		}else{
			sessionSortType = (WizardHandlerDefListItemBeanSortType)getBeanFromSession(req, SA_SORT_TYPE);
			sortType = sessionSortType == null ? new WizardHandlerDefSortType(sortMethod, sortOrder) : new WizardHandlerDefSortType(sessionSortType.getSortBy(), sessionSortType.getSortOrder());
			sessionSortType = sessionSortType == null ? new WizardHandlerDefListItemBeanSortType(sortMethod, sortOrder) : sessionSortType;
		}
		req.setAttribute("currentSortCode", sessionSortType.getMethodAndOrderCode());

		List<WizardHandlerDef> _unfiltered_wizardhandlerdefs = getASWizardDataService().getWizardHandlerDefs();
		List<WizardHandlerDef> wizardhandlerdefs = new ArrayList<WizardHandlerDef>();
		for (WizardHandlerDef element : _unfiltered_wizardhandlerdefs ){
			boolean mayPass = true;
			mayPass = mayPass && (nameFilterAZ.mayPass( element, "name", filterParameter0));
			if (mayPass)
				wizardhandlerdefs.add(element);
		}
		wizardhandlerdefs = sorter.sort(wizardhandlerdefs, sortType);

		// paging
		int pageNumber = 1;
		try{
			pageNumber = Integer.parseInt(req.getParameter("pageNumber"));
		}catch(Exception ignored){}
		Integer lastItemsOnPage = (Integer)req.getSession().getAttribute("currentItemsOnPage");
		int itemsOnPage = lastItemsOnPage == null ? 20 : lastItemsOnPage;
		try{
			itemsOnPage = Integer.parseInt(req.getParameter("itemsOnPage"));
		}catch(Exception ignored){}
		Slice<WizardHandlerDef> slice = Slicer.slice(new Segment(pageNumber, itemsOnPage), wizardhandlerdefs);
		wizardhandlerdefs= slice.getSliceData();

		XMLNode beans = getASWizardDataService().exportWizardHandlerDefsToXML(wizardhandlerdefs);

		req.setAttribute("currentpage", pageNumber);
		req.setAttribute("currentItemsOnPage", itemsOnPage);
		req.getSession().setAttribute("currentItemsOnPage", itemsOnPage);
		req.setAttribute("PagingSelector", ITEMS_ON_PAGE_SELECTOR);

		/**
		 * for XML node - page
		 */
		addBeanToRequest(req, "wizardhandlerdefsXML", beans);
		/**
		 * for CSV - page
		 */
		addBeanToRequest(req, "wizardhandlerdefsCSV", wizardhandlerdefs);
		addBeanToRequest(req, "nameFilterAZ", nameFilterAZ.getTriggerer(""));
		return mapping.findForward("success");
	}

}
